2015-08-08  Kaz Kylheku  <kaz@kylheku.com>

	Discontinuing ChangeLog.

	* ChangeLog: renamed to ChangeLog-2009-2015, and discontinued.
	Changes will be tracked only in the git commit messages
	from now on and not duplicated into the ChangeLog.

2015-08-08  Kaz Kylheku  <kaz@kylheku.com>

	Version 111.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version and date.

	* share/txr/stdlib/ver.tl: Likewise.

	* tl.vim, txr.vim: Regenerated.

2015-08-07  Kaz Kylheku  <kaz@kylheku.com>

	C++ upkeep: conversions, clashes, warnings.

	* glob.c (glob_wrap): Fix signed/unsigned comparison.

	* stream.c (make_null_stream): Fix convert beign used
	where coerce is needed.

	* sysif.c (dup_wrap): Fix use of C++ new keyword.

2015-08-07  Kaz Kylheku  <kaz@kylheku.com>

	C++ static forward issue.

	* lib.h (static_forward, static_def): New macros
	for dealing with C++ static forward declaration problem.

	* syslog.c (syslog_strm_ops): Use static
	forward macros.

2015-08-07  Kaz Kylheku  <kaz@kylheku.com>

	C++ upkeep: resolve multiple definitions of fun_k.

	* eval.c (fun_k): Global definition removed.
	(eval_init): Do not initialize fun_k here.

	* filter.c (fun_k): Definition removed.
	(filter_init): Do not initialize fun_k.

	* filter.h (fun_k): Declaration removed.

	* lib.c (fun_k): Defined in this file now.
	(obj_init): Initialize fun_k here.

	* lib.h (fun_k): Declare here.

2015-08-07  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (SRCS): When top_srcdir is blank, elide the entire
	--work-tree argument to git. On Cygwin, git throws a strange error
	message when --work-tree is given a blank argument.

2015-08-07  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c: Include <wctype.h> header for iswprint.
	Needed on Cygwin.

2015-08-07  Kaz Kylheku  <kaz@kylheku.com>

	* sysif.c (w_lstat): If we don't have S_IFLINK, implement
	w_lstat as an alias to w_stat. This helps build on MinGW.

2015-08-07  Kaz Kylheku  <kaz@kylheku.com>

	Change to different exception for debugger quit.

	* debug.c (debug_quit_s): New global variable.
	(debug): Throw debug-quit, not query-error.
	(debug_init): Initialize debug_quit_s.

2015-08-06  Kaz Kylheku  <kaz@kylheku.com>

	* debug.c (help): Rearrange menu. Show missing quit command.

2015-08-06  Kaz Kylheku  <kaz@kylheku.com>

	Suppress debug stepping into auto-loaded library code.

	* debug.c (debug_set_state, debug_restore_state): New functions.

	* debug.h (debug_state_t): New type.
	(debug_set_state, debug_restore_state): Declared, and defined
	as dummy macros in non-debug-support build.

	* lisplib.c (opt_dbg_autoload): New global variable.
	(lisplib_try_load): Disable or enable debugging around
	library loading based on opt_dbg_autoload option.

	* lisplib.h (opt_dbg_autoload): Declared.

	* txr.c (help): List --debug-autoload option.
	(no_dbg_support): New static function to avoid repeated code.
	(txr_main): Add debugger-autoload option. Change duplicate no debug
	support error messages into calls to no_dbg_support.

	* txr.1: Document --debug-autoload

2015-08-06  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (txr_main): Bugfix: debugger long option nonfunctional.

2015-08-06  Kaz Kylheku  <kaz@kylheku.com>

	Better diagnosis for loose @ forms.

	* eval.c (op_meta_error): New static function.
	(eval_init): Register sys:var and sys:expr as operators
	that throw error.

	* parser.y (sym_helper): Take parser_t instead of scanner_t
	argument so we have access to the name and line number.
	Obtain scanner internally from parser. Add source location
	info to (sys:var ...) form.
	(symhlpr): Retarget macro to pass parser rather than scanner to
	sm_helper.

2015-08-05  Kaz Kylheku  <kaz@kylheku.com>

	New filesystem object testing functions.

	* lisplib.c (path_test_set_entries, path_test_instantiate):
	New static functions.
	(dlt_register): Registered new functions to dl_table.

	* txr.1: Documented new functions.

	* share/txr/stdlib/path-test.tl: New file.

2015-08-05  Kaz Kylheku  <kaz@kylheku.com>

	Adding support for uid and gid manipulation.

	* configure: Added check for geteuid and related functions.

	* sysif.c (getuid_wrap, geteuid_wrap, getgid_wrap, getegid_wrap,
	getgroups_wrap, setuid_wrap, seteuid_wrap, setgid_wrap, setegid_wrap):
	New static functions.
	(sysif_init): Register intrinsics getuid, geteuid, getgid,
	getegid, getgroups, setuid, seteuid, setgid, setegid.

	* txr.1: Documented new functions.

2015-08-05  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (system_error_s): New symbol variable.
	(obj_init): Initialize new variable.

	* lib.h (system_error_s): Declared.

	* unwind.c (uw_init): Register system-error exception type.

2015-08-05  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (stream_init): Register get-indent-mode, set-indent-mode,
	test-set-indent-mode, get-indent, set-indent, inc-indent
	and width-check intrinsic functions. Register indent-off,
	indent-data and indent-code variables.

	* txr.1: Documented stream output indentation API.

2015-08-05  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (width_check): Just use the public
	put_char function; no need to manipulate column
	or call put_indent.

2015-08-05  Kaz Kylheku  <kaz@kylheku.com>

	Better diagnostic in funcall family of functions.

	* lib.c (wrongargs): New static function.
	(funcall, funcall2, funcall2, funcall3, funcall4):
	Use wrongargs.

2015-08-05  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (do_eval): Bugfix: though last_form_evaled is
	saved and restored around the execution of a special operator,
	it is never set the current form.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bind_args): Use new ~! for proper indentation
	of multi-line context form.
	(apply): Use ~! for proper indentation of function code.

	* unwind.c (uw_throw): Use ~! for proper indentation of code.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (put_string): In indent mode, put_string has
	to process all the characters as if by put_char,
	(which we now do literally that way).
	(set_indent_mode): Bugfix: no longer reset the column
	to zero when turning off indent mode. This is wrong since
	streams do column counting all the time.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (vformat): Implement ~! format directive for indentation.
	Allow negative widths to be specified with a leading minus sign,
	so that we can indent to the left.

	* txr.1: Document ~! format directive.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (put_string, put_char): Do not put out the indentation
	immediately after outputting a newline. Rather, delay the output of the
	indentation until some output occurs at column zero.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (inc_indent): If a negative indentation increment goes below
	zero, clamp it at zero.
	(set_indent): Clamp indentation value to zero.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (vormat): Bugfix: when width specified as *
	meets a negative argument, the width should be treated
	as positive and the field left aligned. Instead, the
	width is treated as zero.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (string_out_put_string): Do not return nil when
	buffer calculations overflow, but throw exception.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	Remove useless return values and checks.

	* stream.c (vformat_align_pre, vformat_align_post): Change to void
	return.  Do not check return value of put_char.
	(vformat_num, vformat_str): Change to void return. Do not check return
	value of vformat_align_pre, vformat_aign_post or put_char.
	(vformat): Do not check return value of vformat_str or vformat_num.
	nilout exit point no longer needed.
	(put_string): Do not intercept return value of ops->put_string.
	Return t.
	(put_char): Do not intercept return value of ops->put_char.
	Do not check return value of put_indent. Return t.

	* txr.1: Document t return of put-char, put-byte and put-string.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (func_get_name): New function.
	(bind_args): Include the entire context form in argument
	mismatch errors.
	(apply): Include the function name, or else source code
	if it has no name, in argument mismatch erors.
	(eval_init): Register func-get-name intrinsic.

	* eval.h (func_get_name): Declared.

	* txr.1: Documented func-get-name.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (force): Default the new second argument of source_loc_str.
	(eval_error): Derive location of error from
	the last_form_evaled, if form doesn't have it.
	(eval_init): Re-register source-loc-str as binary with an optional arg.

	* match.c (debuglf, sem_error, file_err, typed_error): Default new
	argument of source_loc_str.

	* parser.h (source_loc_str): Declaration updated.

	* parser.l (source_loc_str): Take second argument which specifies
	alternative value if the source loc info is not found.

	* unwind.c (uw_throw): Simplify code thanks to source_loc_str
	default argument.

	* txr.1: Document new argument of source-loc-str.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (hash_revget): New function.

	* hash.h (hash_revget): Declared.

	* eval.c (eval_init): Registered hash-revget intrinsic.

	* txr.1: Documented hash-revget.

2015-08-04  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (indent_mode_put_string): Function removed,
	logic hoisted into put_string.
	(put_string, put_char): Always count column, indent mode or not.

	* tests/009/json.expected: Updated.

2015-08-03  Kaz Kylheku  <kaz@kylheku.com>

	Define TXR_DBG macro when compiling debug build.

	* Makefile (dbg/%.o): Pass $(DBG_ONLY_FLAGS) to COMPILE_C_WITH_DEPS
	recipe macro.

	* configure (debug_only_flags): New macro.
	(gen_config_make): Generate DBG_ONLY_FLAGS.
	Add debug-only-flags to usage help text.

2015-08-03  Christopher Meng  <i@cicku.me>

	Custom linker flags support.

	* Makefile (PLATFORM_FLAGS): Rename to PLATFORM_CFLAGS.
	(LDFLAGS): New variable. Includes -lm and PLATFORM_CFLAGS.
	(LINK_PROG): Use $(LDFLAGS) instead of -lm.

	* configure (platform_flags): Renamed to platform_cflags.
	(platform_ldflags): New variable.
	(gen_config_make): Rename PLATFORM_CFLAGS and generate
	PLATFORM_LDFLAGS.
	Usage help text updated.

2015-08-03  Kaz Kylheku  <kaz@kylheku.com>

	Switching some globals to lexical and changing some names.

	* arith.c (arith-init): Changing *flo-...* from special to
	lexical, and adding un-earmuffed variants. The earmuffed
	versions are obsolescent.
	Adding %pi% and %e% global lexicals. Earmuffed versions are
	also made global lexical, and obsolescent.

	* eval.c (lookup_global_var, lookup_global_var_l): New functions.
	(lookup_var): Uses lookup_global_var.
	(reg_varl): New function.
	(reg_var): Uses reg_var.
	(eval_init): Register global lexicals user-package, system-package
	and keyword-package. Old symbols with earmuffs are obsoleted,
	and also turned into global lexicals.
	(top-vb, top-fb): Changed to lexical.

	* eval.h (lookup_global_var, lookup_global_var_l, reg_varl):
	Declared.

	* genvim.txr: Scan ver.tl so that the lib-version variable
	is included. Extract reg_varl calls.

	* glob.c (glob_init): glob-err and other variables made lexical.

	* lib.c (get_user_package, get_system_package, get_keyword_package):
	Use lookup_global_var_l to avoid searching dynamic scope for
	lexicals which cannot be dynamically rebound.

	* share/txr/stdlib/ver.tl (lib-version): New global lexical variable.
	(*lib-version*): Turned lexical. Obsolescent.

	* signal.c (sig-init): sig-* variables turned lexical.

	* sysif.c (sysif-init): s-*, poll-* and w-* variables turned lexical.

	* syslog.c (syslog-init): log-* variables turned lexical.

	* txr.c (sysroot-init): stdlib and *txr-version* variables turned
	lexical. txr-version variable added, and *txr-version* is
	obsolescent.
	(txr-main): self-path variable added. *self-path* turns lexical
	and is obsolescent.

	* txr.1: Documentation updated. Lexical variables not referred
	to as special. Special variables referred to as special.


2015-08-03  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (txr_main): Bugfix: register *args-full*, the variable
	described in the documentation! We keep *full-args* for backward
	compatibility, as an obsolescent feature.

2015-08-03  Kaz Kylheku  <kaz@kylheku.com>

	Introducing global lexicals: defvarl, defparml.

	* eval.c (defvarl_s, defparm_s, defparml_s, sys_mark_special_s): New
	symbol variables.
	(mark_special): Return val rather than void, since it's hoisted
	into Lisp domain now with func_n1.
	(op_defvar): Renamed to op_defvarl, and doesn't call mark_special.
	defvarl is now the special form for defining variables, and special
	marking is an embellishment added by macros.
	(me_defparm): Renamed to me_def_variable. Handles defvar, defparm
	and defparml.
	(do_expand): Expand defvarl, rather than defvar.
	(eval_init): Intern defvarl, defparm, defparml and mark-special
	symbols, and initialize corresponding globals.
	Register defvarl special operator, retiring defvar.
	Register defparm to me_def_variable, and register defvar and
	defparml to the same.

	* txr.1: Document support for global lexical scopes and the
	new macros.

2015-08-02  Kaz Kylheku  <kaz@kylheku.com>

	Support lstat and fstat.

	* stream.h (statf): Declaration removed.

	* sysif.c (w_stat): Function takes val instead of const wchar_t *
	as leftmost argument.
	(w_lstat, w_fstat): New static functions, with same interface as w_stat.
	(stat_to_list, stat_impl): New static functions.
	(statp, statl): New static functions.
	(statf): Function removed, name re-used for new static function.
	(sysif_init): stat intrinsic registered to statp function, not statf.
	lstat and fstat intrinsics registered to statl and statf.

	* txr.1: Documented lstat and fstat.

2015-08-01  Kaz Kylheku  <kaz@kylheku.com>

	Pass pretty flag to cobj print operation.

	* hash.c (hash_print_op): Take third argument,
	and call cobj_print_impl rather than cobj_print.

	* lib.c (cobj_print_op): Take third argument.  The object class is
	* printed with obj_print_impl.
	(obj_print_impl): Static function becomes extern.  Passes its pretty
	flag argument to cobj print virtual function.

	* lib.h (cobj_ops): print takes third argument.
	(cobj_print_op): Declaration updated.
	(obj_print_impl): Declared.

	* regex.c (regex_print): Takes third argument, and ignores it.

	* stream.c (stream_print_op, stdio_stream_print, cat_stream_print):
	Take third argument, and ignore it.

	* stream.h (stream_print_op): Declaration updated.

2015-08-01  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (special_p): Function renamed to special_var_p.
	(expand_opt_params_rec, expand_vars): Follow rename of special_p.
	(eval_init): Register special-operator-p and special-var-p
	intrinsics.

	* txr.1: Document special-operator-p and special-var-p.

2015-08-01  Kaz Kylheku  <kaz@kylheku.com>

	Big TXR Lisp documentation rearrangement.

	* txr.1: Numerous sections moved around. Miscellaneous formatting
	and wording fixes. New sections under TXR Lisp intro section.

2015-07-31  Kaz Kylheku  <kaz@kylheku.com>

	string_output renamed to string_out

	* stream.c (struct string_output): Renamed to string_out.
	(string_out_stream_destroy, string_out_byte_callback,
	string_out_put_char, strnig_out_put_string, string_out_put_byte,
	make_string_output_stream, get_string_from_stream): Follow rename.

2015-07-31  Kaz Kylheku  <kaz@kylheku.com>

	Simplify type check code in stream module.

	* stream.c (get_string_from_stream, get_list_from_stream,
	stream_set_prop, stream_get_prop, close_stream, get_line,
	get_char, get_byte, unget_char, unget_byte, put_string,
	put_char, put_byte, flush_stream, seek_stream): Use cobj_handle and
	cobj_ops instead of type_check and type_assert.
	(get_indent_mode, test_set_indent_mode, set_indent_mode,
	get_indent, set_indent, inc_indent, width_check): Use cobj_handle
	and cobj_ops instead of stream->co.handle and stream->co.ops
	for safety.

	(vformat, format): Use class_check instead of type_check and
	type_assert.

2015-07-31  Kaz Kylheku  <kaz@kylheku.com>

	Multi-line, indented printing of structure.

	* eval.c (op_error): New static function.
	(macro_form_p, fboundp): Static to external.
	(special_operator_p): New function.
	(eval_init): Register macrolet and symacrolet to op_error.
	These are recognized and processed by expand, but we want
	them in the op table so they are reported by special_operator_p.

	* eval.h (fboundp, macro_form_p, special_operator_p): Declared.

	* hash.c (print_key_val): Break long lines on spaces
	between pairs with stream_width_check.
	(hash_print_op): Implement split and indented printing.

	* lib.c (obj_print_impl): New static function, resulting
	from a merge of obj_print and obj_pprint. Fixes some
	wrong-way recursion bugs: obj_pprint recursed into obj_print
	in some places. Adds support for multi-line printing of
	vectors and lists, with indentation using the new
	interfaces in streams.

	* stream.c (strm_base_init): Update initializer.
	(put_indent, indent_mode_put_string): New static functions.
	(put_string): Use indent_mode_put_string in either of the
	two indent modes.
	(put_char): Implement indent mode.
	(get_indent_mode, test_set_indent_mode,
	set_indent_mode, get_indent, set_indent,
	inc_indent, width_check): New functions.

	* stream.h (enum indent_mode): New.
	(struct strm_base): indent_on member becomes indent_mode.
	New members data_width and code_width.
	(get_indent_mode, test_set_indent_mode,
	set_indent_mode, get_indent, set_indent,
	inc_indent, width_check): Declared.

	* tests/009/json.expected: Updated.

	* tests/010/seq.expected: Likewise.

	* tests/011/macros-2.expected: Likewise.

2015-07-30  Kaz Kylheku  <kaz@kylheku.com>

	* filter.c, utf8.c: Fix bad indentation introduced in whitespace
	fix on 2013-08-09.

2015-07-30  Kaz Kylheku  <kaz@kylheku.com>

	Correction to COBJ initialization pattern.

	In fact, the previosuly documented process is not correct and still
	leaves a corruption problem under generational GC (which has been the
	default for some time).

	* HACKING: Document flaw in the initialization pattern previously
	thought to be correct, and show fix.

	* hash.c (copy_hash): Fix instance of incorrect pattern.

	* regex.c (regex_compile): Likewise.

2015-07-30  Kaz Kylheku  <kaz@kylheku.com>

	* HACKING: Restore accidentally deleted document title.

2015-07-29  Kaz Kylheku  <kaz@kylheku.com>

	Deriving streams from the same base, so
	we can give streams some common slots.

	* stream.c (strm_base_init, strm_base_cleanup, strm_base_mark,
	stream_destroy_op, stream_mark_op): New functions.
	(null_ops): Switch to stream_destroy_op and stream_mark_op.
	(make_null_stream): Associate a strm_base instance with the
	cobj handle rather than a null pointer.
	(struct stdio_handle): Inherit struct strm_base.
	(stdio_stream_destroy): Clean up the strm_base part.
	(stdio_stream_mark): Mark the strm_base part.
	(make_stdio_stream_common): Initialize the strm_base part.
	(struct dir_handle): Inherit struct strm_base.
	(dir_destroy): Clean up the strm_base part.
	(dir_mark): Mark the strm_base part.
	(make_dir_stream): Initialize the strm_base part.
	(struct string_in): New structure. Replaces ad-hoc cons
	cell used for string input streams.
	(string_in_stream_mark): Mark new structure.
	(string_in_get_line, string_in_get_char, string_in_unget_char,
	string_in_get_prop, string_in_get_error, make_string_input_stream):
	Convert to new structure.
	(string_in_ops): Switch to stream_destroy_op.
	(struct byte_input): Inherit struct strm_base.
	(byte_in_stream_destroy): No need to check handle for null.
	No need to set handle to null after freeing: gc does it.
	Clean up the strm_base part.
	(byte_in_ops): Switch to stream_mark_op.
	(make_string_byte_input_stream): Initialize the strm_base part.
	(struct string_output): Inherit struct strm_base.
	(string_out_stream_destroy): No need to check handle for null
	since the logic elsewhere has changed.
	Clean up the strm_base part.
	No need to set handle to null.
	(string_out_ops): Switch to stream_mark_op.
	(make_string_output_stream): Initialize the strm_base part.
	(get_string_from_stream): Don't free the handle.
	Null out the buffer so->buf whose ownership passes to the string.
	(struct strlist_out): New structure. Replaces ad-hoc cons cell
	used for string list output stream.
	(strlist_mark): Renamed to strlist_out_mark. Mark the strm_base
	part.
	(strlist_out_put_string, strlist_out_put_char,
	make_strlist_output_stream, get_list_from_stream):
	Convert to new structure.
	(strlist_out_ops): Switch to stream_destroy_op.
	Follow rename of strlist_mark.
	(struct cat_strm): New structure, replacing ad-hoc list pointer

2015-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (finalize): Null out cobj handle after calling the
	destructor. This can catch some use-after-free errors.

2015-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (common_destroy): Function removed.
	(stdio_stream_destroy, dir_destroy): Call close_stream directly.

2015-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c: Rearranging definitions and declarations so that
	code for each stream type is together. Moving catenated
	streams above utility functions, so they are together with
	other stream definitions.

2015-07-28  Kaz Kylheku  <kaz@kylheku.com>

	Centered fields in format.

	* stream.c (enum align): New enum.
	(vformat_align_pre, vformat_align_post): New static functions.
	(vformat_num, vformat_str): Argument left renamed to align, and changed
	to enum align. vformat_align_pre and vformat_align_post are called to
	generate the correct padding for left, center and right alignment.
	(vformat): Two-valued local variable left turned into three-valued
	align. The ^ prefix on the width field is recognized.

	* txr.1: Documented ^ width prefix.

2015-07-28  Kaz Kylheku  <kaz@kylheku.com>

	* share/txr/stdlib/txr-case.tl (txr-case-impl): Bugfix,
	handle nil case in recursion.

2015-07-28  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: In introduction of user-defined places, mentioning
	placelet as a way of writing place update macros.
	Example added under placelet.

2015-07-25  Kaz Kylheku  <kaz@kylheku.com>

	Version 110.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version and date.

	* share/txr/stdlib/ver.tl: Likewise.

	* tl.vim, txr.vim: Regenerated.

2015-07-25  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Improved highlighting of items in quasiquote.
	Lists can be spliced and quoted. Metanums and metavars can
	be prefixed by multiple @'s.

2015-07-25  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Do not refer to installed code via stdlib.
	Refer to source tree.

2015-07-25  Kaz Kylheku  <kaz@kylheku.com>

	Quasiliteral tests.

	* tests/012/quasi.expected: New file.

	* tests/012/quasi.tl: New file.

2015-07-25  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (tst/tets/012/%): Disable --gc-debug for
	tests in this directory.

2015-07-24  Kaz Kylheku  <kaz@kylheku.com>

	* tests/012/ifa.tl: New test for it being bound to a place.

2015-07-24  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: place-form-p must expand place macros.

	* share/txr/stdlib/place.tl (place-form-p): Take
	environment parameter. Expand the place form using sys:pl-expand.

	* share/txr/stdlib/ifa.tl (ifa): Pass environment
	to place-form-p.
	(nthcdr): Pass environment down to place-form-p.

2015-07-24  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (op_quote): Improved diagnostic.

2015-07-23  Kaz Kylheku  <kaz@kylheku.com>

	Set up blank top_srcdir if building in source directory.

	This means short, relative names are used for C source files when
	compiling in the source directory.

	* Makefile (CFLAGS): Exclude -iquote $(top_srcdir) arguments
	if top_srcdir is blank. Remove slash after $(top_srcdir),
	since the variable includes it now, if its value is not blank.
	(SRCS, ABBREV, opt/%-win.o, lex.yy.c, y.tab.c, install): Remove slash
	after $(top_srcdir).
	(dbg/%.o, opt/%.o): Only include rules for depending
	on $(top_srcdir)%.c prerequisite if top_srcdir is not blank.
	In the blank case, the rules are redundant.

	* configure: if configuring in the root of the source tree,
	establish top_srcdir as blank, otherwise establish is as
	an absolute path with a trailing slash.

2015-07-23  Kaz Kylheku  <kaz@kylheku.com>

	Split off test macros from ifa.tl into common file.

	* Makefile (TESTS_OUT): Don't use find to hunt down tests;
	but rather wildcard. This way common.tl is not mistakenly
	identified as an independent test file.

	* tests/012/ifa.tl: Removed test code, placed in new file
	which is loaded.

	* tests/common.tl: New file.

2015-07-23  Kaz Kylheku  <kaz@kylheku.com>

	Fixes for building in separate dir.

	* Makefile (CFLAGS): Search for mpi header in $(top_srcdir).
	(ABBREV): Remove top_srcdir prefix from source names.
	(dbg/%.o, opt/%.o): Extra set of pattern rules for searching
	for prerequisites in $(top_srcdir) where primary C sources
	are found and in the local dir where some generated C is found.
	This way we don't rely on VPATH.
	(opt/%.res): Bogus target removed.
	(VPATH): Removed in favor of explicitly referencing $(top_srcdir).
	Was causing problems for tests.
	(lex.yy.c, y.tab.c): Prerequisites referenced in $(top_srcdir).

2015-07-23  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l (grammar): Do not allow unescaped newline in
	word list literals and word list quasiliterals, except
	in <= 109 compatibility mode. An escaped newline in
	these literals, together with surrounding whitespace,
	now produces a single space, except in <= 109
	compatibility mode.

	* txr.1: Documented new rules for WLL's and QLL's,
	and added compatibility notes.

2015-07-23  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Scan cadr.c, cadr.tl, with-resources.tl, txr-case.tl.
	Remove hard-coded txr-case symbols. Recognize operators registered
	with in-line intern.

2015-07-23  Kaz Kylheku  <kaz@kylheku.com>

	Adding with-resources macro.

	* share/txr/stdlib/with-resources.tl: New file.

	* lisplib.c (with_resource_set_entries, with_resources_instantiate):
	New static functions.
	(lisplib_init): Register new functions under dlt_register.

	* txr.1: Document with-resources.

2015-07-22  Kaz Kylheku  <kaz@kylheku.com>

	Adding nthcdr as accessor.

	* eval.c (eval_init): Register nthcdr function.

	* lib.c (nthcdr): New function.

	* lib.h (nthcdr): Declared.

	* share/txr/stdlib/place.tl (nthcdr): New defplace.

	* txr.1: Documented.

2015-07-22  Kaz Kylheku  <kaz@kylheku.com>

	Improve bad argument diagnosis for place macros.

	* eval.c (op_mac_param_bind): New static function.
	(eval_init): Register mac-param-bind operator.

	* share/txr/stdlib/place.tl (define-place-macro): Use
	mac-param-bind inside a lambda instead of tb macro.

	* txr.1: Document mac-param-bind.

2015-07-22  Kaz Kylheku  <kaz@kylheku.com>

	Implementing second through tenth as places.

	* eval.c (eval_init): Register second through tenth as intrinsic.

	* gencadr.txr: New cadr.c changes encoded.

	* lib.c (second, third, fourth, fifth, sixth): Functions
	reimplemented using ref, so they are much more efficient
	for vectors and strings.
	(seventh, eighth, ninth, tenth): New functions.

	* lib.h (seventh, eighth, ninth, tenth): Declared.

	* share/txr/stdlib/place.tl: place macros defined for
	second through tenth.

	* txr.1: Documented.

2015-07-22  Kaz Kylheku  <kaz@kylheku.com>

	* lisplib.c (place_set_entries): Add *place-macro* and
	define-place-macro to list of names.

	* share/txr/stdlib/place.tl (*place-macro*): New global hash.
	(sys:tigger-load, sys:pl-expand): New functions.
	(call-update-expander, call-clobber-expander, call-delete-expander):
	Recognize and expand place macros.
	(define-place-macro): New macro.
	(first, rest): Places redefined using define-place-macro, replacing
	the old hack of copying the expanders from one table entry to another.

	* txr.1: Documented place macros.

2015-07-22  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (obj_print, obj_pprint): Bugfix: incorrect
	value returned when printing dwim forms, due to
	mutating the obj variable.

2015-07-21  Kaz Kylheku  <kaz@kylheku.com>

	Implementing caar, cadr, cdar and friends.

	* lib.c (init): Call cadr_init.

	* lisplib.c (dl_table, set_dlt_entries, dlt_register): Externalize.

	* lisplib.h (dl_table, set_dlt_entries, dlt_register): Declared.

	* Makefile (OBJS): Add cadr.o.

	* cadr.c: New file.

	* cadr.h: New file.

	* gencadr.txr: New file.

	* share/txr/stdlib/cadr.tl: New file.

	* txr.1: Document cadr accessors.

2015-07-21  Kaz Kylheku  <kaz@kylheku.com>

	* share/txr/stdlib/place.tl (defplace cdr): Change deletion
	semantics so that (del (cdr x)) is symmetric with (del (car x)).

	* txr.1: Update documentation.

2015-07-21  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register new split function.

	* lib.c (split_func): New static function.
	(partition_split_common): New static function, based on
	on contents of partition function.
	(partition): Now a wrapper around partition_split_common.
	(split): New function.

	* lib.h (split): Documented.

	* txr.1: Documented split.

2015-07-13  Kaz Kylheku  <kaz@kylheku.com>

	* parser.c (open_txr_file): Bugfix: the name of the parsed
	stream should be the resolved name, not the abstract original,
	so that error messages correlate to the file.

2015-07-12  Kaz Kylheku  <kaz@kylheku.com>

	* share/txr/stdlib/ifa.tl (ifa): Use placelet to
	allow "it" to be mutable when it denotes a place form.

2015-07-12  Kaz Kylheku  <kaz@kylheku.com>

	* share/txr/stdlib/place.tl (place-form-p): New function.

	* lisplib.c (place_set_entries): Add place-form-p to list of names.

2015-07-11  Kaz Kylheku  <kaz@kylheku.com>

	Expand away sys:lisp1-value based on lexical info.

	* eval.c (sys_lisp1_value_s): New global symbol variable.
	(expand_lisp1_value): New static function.
	(do_expand): Use expand_lisp1_value.
	(eval_init): Initialize sys_lisp1_value_s.

2015-07-11  Kaz Kylheku  <kaz@kylheku.com>

	Let's have placelet and placelet*.

	* share/txr/stdlib/place.tl (placelet*): New macro.

	* lisplib.c (place_set_entries): Add placelet* to list of names.

	* txr.1: Updated to document placelet* and fix mistakes.

2015-07-11  Kaz Kylheku  <kaz@kylheku.com>

	* share/txr/stdlib/place.tl (defplace dwim): Eliminate
	ogetter-sym variable for caching the sequence; use the getter
	for the sequence place to access it. Again, this is for placelet,
	where the caching is visible. Another way to fix this is to
	clobber the cache variable when updating the sequence place.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register bindable as intrinsic.

	* txr.1: Documented.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	New placelet macro.

	* lisplib.c (place_set_entries): Add placelet to list of names.

	* share/txr/stdlib/place.tl (sys:placelet1, placelet): New macros.
	(defplace dwim): Do not retrieve the
	place's value into a local variable and have the getter
	expand to that variable. Rather, have the getter retrieve the
	value. A getter that refers to a cached copy breaks
	the semantics of placelet, and any place operator which can
	evaluate the location after it is stored.

	* txr.1: Documented placelet.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Handle setting of parse name through prime_parser.

	* parser.c (prime_parser): Take name as argument,
	and install it into parser.
	(lisp_parser): Pass name to parse, instead of setting it
	in the parser object.

	* parser.y (parse): Take name as argument and pass
	down to prime_parser.

	* parser.h (prime_parser, parse): Declarations updated.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Fix wrong name reported for errors in first top-level form.

	* parser.c (read_eval_stream): Get name of original stream,
	and pass that down to lisp_parse as the name argument.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Fix off by one error line numbers for .tl files.

	* parser.c (read_eval_stream): Add terminating newline to
	the first line that was examined for hash bang.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Remove unused "primer" member from parser_t.

	* parser.c (parser_mark, parser_common_init): Remove reference to primer.
	(parser): Don't take primer argument, remove reference to member.
	(ensure_parser): Don't take primer argument, don't pass to parser
	function.
	(lisp_parse): Don't pass primer string to ensure_parser.

	* parser.h (primer_t): Remove primer member.
	(parser): Declaration updated.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: lexer loses unmatched "hold char" between top-level forms.

	Test case: file containing 4(prinl 3). Scanner consumes 4 and (.
	The ( is lost when the scanner is reset for the next call to yyparse,
	resulting in jut prinl being read and interpreted as a variable.

	* parser.c (prime_parser): If present, append hold byte to priming
	string. Takes parser_t * instead of parser, and returns void now.

	* parser.l (reset_scanner): Now returns int value, the value
	of the scanner's yy_hold_char variable which is nonzero when
	the scanner is hanging on to an unmatched byte of input.

	* parser.h (reset_scanner, prime_parser): Declarations updated.

	* parser.y (parse): Pass hold byte returned by reset_scanner to
	prime_parser.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (byte_in_unget_byte): Wrong function name in error message.

2015-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Fix unget-byte and unget-char on catenated streams.

	* stream.c (cat_unget_byte, cat_unget_char): Recursive
	call to unget_byte and unget_char with reversed arguments.

2015-07-09  Kaz Kylheku  <kaz@kylheku.com>

	Parser cleanup: embed scanner in parser.

	* parser.c (parser_destroy): New GC finalizer static function.
	(parser_ops): Register parser_destroy.
	(parser_common_init): New function, shared by parse and parse_once.
	Initializes embedded scanner.
	(parser_cleanup): New function, shared by parse_once and
	parser_destroy.
	(parser): Use parser_common_init.

	* parser.h (parser_t): New member, yyscan.
	(reset_scanner, parser_common_init): Declared.

	* parser.l (reset_scanner): New function.

	* parser.y (parse_once): Use parser_common_init, and
	thus perform only a few initializations. Do not
	define scanner as a local variable.
	(parse): Call reset_scanner instead of
	yylex_init since the scanner is being reused,
	and for the same reason do not call yylex_destroy.
	GC will do that now.

2015-07-08  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: define-modify-macro not registered for auto-loading.

	* lisplib.c (place_set_entries): Add define-modify-macro to
	list of names.

2015-07-07  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: allow @1 in brace variables.

	* parser.l (grammar): Scan a METANUM token in the
	BRACED state also. This allows us to correctly
	reference op arguments in a quasiliteral, as in
	`foo @{@1 [1..2] ","} bar`.

2015-07-07  Kaz Kylheku  <kaz@kylheku.com>

	Improved printing of stream objects.

	* stream.c (null_stream_print): Static function removed.
	(stream_print_op): New function. Prints stream's name and address.
	(null_get_prop): Pull stream name from strm_ops structure
	rather than hard-coding to "null-stream".
	(null_ops, stdio_ops, tail_ops, pipe_ops, string_in_ops,
	byte_in_ops, string_out_ops, strlist_out_ops, dir_ops,
	cat_stream_ops): Use stream_print_op in place of cobj_print_op.
	Initialize name.
	(stdio_stream_print): Use name from ops structure,
	and include object address.
	(string_in_get_prop): Likewise.
	(cat_stream_print): Likewise.

	* stream.h (struct strm_ops): New member, name.
	(strm_ops_init): Initialize name.
	(stream_print_op): Declared.

	* syslog.c (syslog_strm_ops): Use stream_print_op. Initialize name.

2015-07-06  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix in printed rep of stdio stream.

	* stream.c (stdio_stream_print): Wrong way test on h->pid;
	if it is nonzero it must be printed. Was printed wrong:
	argument of integer type passed to ~s which expects a val.

2015-07-06  Kaz Kylheku  <kaz@kylheku.com>

	Clarify clear-error and flush return value.

	* stream.c (stdio_clear_error): Return the prior value of h->err.
	Do not inspect feof(h->f) or ferror(h->f); just clear the error
	status of the stream.
	(stdio_close): Set h->err from errno if fclose failed.
	(dir_clear_error): Return prior value of h->err.

	* txr.1: Document return value convetion for clear-error,
	and flush-stream.

2015-07-06  Kaz Kylheku  <kaz@kylheku.com>

	Tightening behavior for unimplemented stream ops.

	In many cases, if a stream operation is not applicable to a stream, it
	is not appropriate to just do nothing and return nil. An error
	must be thrown.

	* stream.c (unimpl, unimpl_put_string, unimpl_put_char,
	unimpl_put_byte, unimpl_get_line, unimpl_get_char, unimpl_get_byte,
	unimpl_unget_char, unimpl_unget_byte, unimpl_seek, null_put_string,
	null_put_char, null_put_byte, null_get_line, null_get_char,
	null_get_byte, null_close, null_flush, null_seek, null_set_prop,
	null_get_error, null_get_error_str, null_clear_error): New
	static functions.
	(fill_stream_ops): New function.
	(null_ops): Use null_put_string, etc., instead of null pointers.
	(stdio_clear_error, dir_clear_error, cat_clear_error): Return value now
	indicating whether an error was cleared.
	(stream_set_prop, stream_get_prop, real_time_stream_p, close_stream,
	get_error, get_error_str, clear_error, get_line, get_char, get_byte,
	unget_char, unget_byte, put_string, put_char, put_byte,
	flush_stream): Do not test whether a function in the ops table
	is defined; just call it, and return its value.
	(stream_init): Call fill_stream_ops on all stream operation
	structures so any null pointers are defaulted to appropriate
	functions.

	* stream.h (struct strm_ops): clear_error gets return value.
	(fill_stream_ops): Declared.

	* syslog.c (syslog_init): Call fill_stream_ops on syslog_strm_ops.

2015-07-04  Kaz Kylheku  <kaz@kylheku.com>

	Reduce regex duplication in genvim.txr.

	* genvim.txr (bs, hex, at, alpha, alnum, dig, oct, chesc, glyph):
	New variables.
	*(txr_error, txr_atat, txr_comment, txr_contin, txr_char,
	txr_regdir, txr_variable, txr_splicevar, txr_stresc, txr_numesc,
	txr_regesc, txr_chr, txr_num, txr_badnum,txr_ident,
	txr_braced_ident): Use regex definitions.

2015-07-03  Kaz Kylheku  <kaz@kylheku.com>

	Syntax highlighting fixes: characters, variables, identifers.

	* genvim.txr (txr_variable, txr_splicevar, txr_bracevar): Weren't being
	generated into tl.vim. Moved to a common section.
	(txr_nested_error): Relocate above other matches.
	(txr_ident): Fixed not to match tokens starting with #.

2015-07-03  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr: Simplify double plass over BODY into single pass.

2015-07-03  Kaz Kylheku  <kaz@kylheku.com>

	Allow op arguments like @1 to be places.

	* share/txr/stdlib/place.tl: Introducing new defplace
	for (sys:var ...) which is treated as if it were a symbol,
	in anticipation of the op/do macro placing that syntax
	with a symbol.

2015-07-02  Kaz Kylheku  <kaz@kylheku.com>

	Support trailing semicolon after hex/octal characters.

	* parser.l (%option): Remove nounput option since we need
	yyunput.
	(grammar): Rule for matching hex and octal escape in SPECIAL
	state recognizes optional semicolon. In 109 compatibility,
	this is pushed back into the stream, otherwise consumed.

	* txr.1: Updated documentation, including compat notes.

	* genvim.txr (txr_char): Include optional semicolon in
	match. Corrected some errors where 8 and 9 were being
	included as matches for octal digits.
	(txr_error): Default match for \x or \o  not followed
	by digits.

2015-07-02  Kaz Kylheku  <kaz@kylheku.com>

	Hash-bang support for .tl files.

	* parser.c (read_eval_stream): New boolean argument
	to request hash bang support.

	* parser.h (read_eval_stream): Declaration updated.

	* eval.c (sys_load): Pass new thid argument to read_eval_stream,
	to decline hash bang support.

	* match.c (v_load): Likewise.

	* txr.c (txr_main): Request hash bang support from
	read_eval_stream. Thus files referenced from the txr
	command line can have a #! line, which is ignored.

2015-07-02  Kaz Kylheku  <kaz@kylheku.com>

	Handle escapes accurately in Vim syntax highlighting.

	* genvim.txr (txr_badesc, txr_stresc, txr_numesc, txr_regesc): New
	match categories.
	(txr_string, txr_quasilit, txr_regex, txl_regex): No longer use skip=
	argument, but rather contain escape categories.
	All escapes are colored as Special rather than String, and
	unknown or malformed escapes are colored as errors.

2015-07-01  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr: Take advantage of \@ escape in quasilit.

	* genvim.txr (txr_escat): New match category containing \@.
	Colorized a String.
	(txr_quasilit): Contains txr_escat. Thus, \@ looks like any
	other escape inside a quasilit.

2015-07-01  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr: Bugfix: reproduce the correct opening bracket
	before a function link.

2015-06-27  Kaz Kylheku  <kaz@kylheku.com>

	Fix issues in configure found by ShellCheck.

	* configure (have_timegm, tm_gmtoff, tm_tmzone): Unused
	variables removed.
	(SIZEOF_LONG_LONG_T): Reference to nonexistent variable fixed.
	Also, fixed two instances of arithmetic expressions using
	unnecessary $ prefixes on variables.

2015-06-27  Kaz Kylheku  <kaz@kylheku.com>

	Fix TXR 97 regression in quasiliterals.

	* eval.c (expand_quasi): When the modifiers argument of a var
	item is expanded, the expansion incorrectly places it as the
	fourth item rather than third. This is effectively a continuation
	of the incomplete regression fix that was applied on 2014-08-29.
	The breakage is that `@{(expr) modifier}` ignores modifier
	whenever (expr) is an expression that undergoes expansion.

2015-06-26  Kaz Kylheku  <kaz@kylheku.com>

	Third round of quasiliteral-related fixes.

	* parser.l (char_esc): Recognize \@ escape.
	(grammar): Add a rule for a \@ escape in quasiliterals,
	and quasi word list literals.

	* txr.1: Document \@, and remove the lie that @@
	encodes for a single @ in quasiliterals.

2015-06-26  Kaz Kylheku  <kaz@kylheku.com>

	Second round of quasiliteral-related fixes.

	* parser.l: Only shift to QSPECIAL state when @ is followed
	by a trailing context consisting of certain characters.
	Not every kind of Lisp object syntax can be introduced
	with @ in a quasiliteral. Adding a rule to produce an
	error when @ appears that is not followed by an allowed
	character.

2015-06-26  Kaz Kylheku  <kaz@kylheku.com>

	First round of quasiliteral-related fixes.

	* parser.l: Do not try to recognize floating-point literals
	in QSPECIAL state; that is not possible because @134.3
	in a quasiliteral parses as a METANUM followed by ".3".
	On the other hand, recognize METANUM literals in QSPECIAL state,
	so that @@123 scans. Recognize @ as a token in QSPECIAL state,
	so @@abc will scan. When transitioning from QSILIT and QWLIT
	states to QSPECIAL upon scanning @, return a @ token, which
	is now parsed in the grammar.

	* parser.y (quasi_meta_helper): New static function.
	(q_var): Do not handle SYMTOK any more, only the braced
	variable syntax. SYMTOK is handled as a n_expr.
	Braced vars are handled with explicit '@' token, which
	is now produced by the scanner when it shifts from QSILIT
	to QSPECIAL.
	(quasi_item): No longer necessary to recognize various
	forms here such as quotes and splices. Just recognize a n_expr,
	preceded by '@'.

2015-06-26  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr: New filter to add hyperlinks within code in
	more places such as examples and summary lists.

2015-06-24  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: partition example: wrong use of where function.

2015-06-24  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (hash_from_pairs, hash_list): New functions.

	* hash.h (hash_from_pairs, hash_list): Declared.

	* eval.c (eval_init): Registered hash-from-pairs and hash-list
	intrinsic.

	* txr.1: Documented new functions.

2015-06-24  Kaz Kylheku  <kaz@kylheku.com>

	Refactoring n-ary functions to use a single helper.

	* lib.c (nary_op): New function.
	(plusv, mulv, logandv, logiorv): Use nary_op.

	* lib.h (nary_op): Declared.

2015-06-23  Kaz Kylheku  <kaz@kylheku.com>

	Hash subset testing.

	* eval.c (eval_init): Register hash-subset and hash-proper-subset
	intrinsics.

	* hash.c (hash_subset, hash_proper_subset): New functions.

	* hash.h (hash_subset, hash_proper_subset): Declared.

	* txr.1: New functions documented.

2015-06-22  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Add ifa.tl library file.

	* tl.vim, txr.vim: Regenerated.

2015-06-22  Kaz Kylheku  <kaz@kylheku.com>

	* share/txr/stdlib/place.tl: Get rid of big progn around the
	whole module.

	* genvim.txr: Handle (def's not preceded by spaces.

2015-06-21  Kaz Kylheku  <kaz@kylheku.com>

	Version 109.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version and date.

	* share/txr/stdlib/ver.tl: Likewise.

	* tl.vim, txr.vim: Regenerated.

2015-06-21  Kaz Kylheku  <kaz@kylheku.com>

	* lisplib.c (ifa_set_entries): Add conda.

	* share/txr/stdlib/ifa.tl (conda): New macro.

	* tests/012/ifa.tl: Adding test for conda.

	* txr.1: Documenting conda.

2015-06-20  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr: Rewrite the man2html-generated inner name links with hash
	values derived from the title text, so that when sections are inserted
	or deleted, the URL's remain stable. The PREAMBLE is gone, and
	VERSION is collected when processsing the body.

2015-06-20  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr (month-name): Filter removed.
	Page date is converted to a time value, and later formatted.

2015-06-20  Kaz Kylheku  <kaz@kylheku.com>

	Remove places.h generation hack.

	* Makefile (GEN_HDRS, LISP_TO_C_STRING): Variables removed.
	(%.h: %.tl): Rule removed. The place.h header is no longer
	generated from place.tl.

	* lisplib.c (place_instantiate): Load place.tl from stdlib directory,
	rather than obtaining it from a string literal in generated header
	place.h.

	* place.tl: Moved to share/txr/stdlib directory.

	* genvim.txr: Refer to place.tl in stdlib.

2015-06-20  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register have function, synonym of true.

	* txr.1: Document have.

2015-06-19  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Documented ifa.

	* share/txr/stdlib/ifa.tl: Tightened up the tests for
	situations when the macro is ill-formed, following
	the improved specification. Also, eval-error is thrown
	instead of just error.

2015-06-19  Kaz Kylheku  <kaz@kylheku.com>

	Test ifa macro.

	* Makefile (TEST_OUT): Include .tl files.
	(tst/%.out): New rule variant, from .tl prerequisite.

	* tests/012/ifa.expected: New file.

	* tests/012/ifa.tl: New file.

2015-06-19  Kaz Kylheku  <kaz@kylheku.com>

	* parser.c (parser_mark): Do not mark p->syntax_tree if
	its value is nao. Introduced on 2015-06-10, "Error handling improvement
	in read".

2015-06-18  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (mkstring): Fix neglect to null terminate.

2015-06-18  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (cat_str): Detect overflow in the total length
	calculation.

2015-06-18  Kaz Kylheku  <kaz@kylheku.com>

	Improvements in equal hashing function.

	* hash.c (equal_hash): For conses and vectors, ensure that
	distinct permutations lead to different hash codes.  This is done by
	accumulating the partial hash with a multiplier, rather than just
	adding subhashes.

2015-06-18  Kaz Kylheku  <kaz@kylheku.com>

	Library .txr files become .tl and are autoloaded.

	* lisplib.c (ver_set_entries, ver_instantiate,
	txr_case_set_entries, txr_case_instantiate): New
	static functions.
	(lisplib_init): Register new functions.

	* share/txr/stdlib/txr-case.txr: Reduced to a load for the
	corresponding .tl file, retained for backward compatibility.

	* share/txr/stdlib/ver.txr: Likewise.

	* share/txr/stdlib/txr-case.tl: New file, based on previous
	contents of corresponding .txr file.

	* share/txr/stdlib/ver.tl: Likewise.

2015-06-17  Kaz Kylheku  <kaz@kylheku.com>

	Adding anaphoric ifa macro.

	* Makefile (install): Install .tl files present in stdlib directory.
	(INSTALL): Handle argument 2 being a list.

	* eval.c (load): New function.

	* eval.h (load): Declared.

	* lisplib.c (ifa_set_entries, ifa_instantiate): New functions
	to lazily load ifa.tl.
	(lisplib_init): Register new functions.

	* txr.c (stdlib_path): New variable.
	(sysroot_init): Store the stdlib path in stdlib_path.

	* txr.h (stdlib_path): Declared.

	* share/txr/stdlib/ifa.tl: New file.

2015-06-17  Kaz Kylheku  <kaz@kylheku.com>

	Refactoring of lisplib.c

	* lisplib.c (set_dlt_entries): New static function.
	(set_place_dlt_entries): Renamed to place_set_entries.
	Uses set_dlt_entries as subroutine.
	(place_instantiate): Argument changes from table to function,
	which is invoked to null out the hash entries.
	(dlt_register): New static function.
	(lisplib_init): Use dlt_register to register dynamic loading
	of places_tl.

2015-06-13  Kaz Kylheku  <kaz@kylheku.com>

	Version 108.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version and date.

	* share/txr/stdlib/ver.txr: Likewise.

	* tl.vim, txr.vim: Regenerated.

2015-06-13  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Documented Lisp loading.

2015-06-13  Kaz Kylheku  <kaz@kylheku.com>

	New --lisp option: treat unsuffixed files as Lisp.

	* txr.c (help): Added help text.
	(txr_main): Handle lisp option.

2015-06-13  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (txr_main): Handle Lisp files.

2015-06-13  Kaz Kylheku  <kaz@kylheku.com>

	Lisp load macro.

	* eval.c (sys_load_s): New symbol variable.
	(sys_load, me_load): New static functions.
	(eval_init): Initialize sys_load_s, register
	sys:load intrinsic function and load macro.

2015-06-12  Kaz Kylheku  <kaz@kylheku.com>

	@(load) and @(include) now load Lisp code.

	* match.c (v_load): Check txr_lisp_p flag coming out of
	open_txr_file and handle the Lisp case usin read_eval_stream.

	* parser.c (read_eval_stream, get_parser, parser_errors):
	New functions.

	* parser.h (read_eval_stream, get_parser, parser_errors):
	Declared.

2015-06-10  Kaz Kylheku  <kaz@kylheku.com>

	Preparing for lisp loading.

	* parser.c (open_txr_file): Rewritten to take new argument
	which indicates whether to treat an unsuffixed file as
	TXR or TXR Lisp, and is updated to indicate which is the
	case by looking at the suffix.

	* parser.h (open_txr_file): Declaration updated.

	* match.c (v_load): Follow change in open_txr_file.

	* txr.c (txr_main): Likewise.

2015-06-10  Kaz Kylheku  <kaz@kylheku.com>

	Error handling improvement in read.

	* parser.y (spec): New grammar production to handle the cases
	that SECRET_ESCAPE_E is not followed by anything (the input
	ends before any object is scanned, or there is no input
	token which starts an object).

	* parser.c (lisp_parse): Deal with EOF indication from parser
	(the syntax_tree member of parser_t set to nao).

2015-06-10  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (yybadtoken): Print unexpected character
	literally rather than as a Lisp character literal.

2015-06-08  Kaz Kylheku  <kaz@kylheku.com>

	Code simplification.

	* txr.c (txr_main): Replacing two code blocks with single
	call to existing open_txr_file function.

2015-06-07  Kaz Kylheku  <kaz@kylheku.com>

	Critical bugfix for weak hashes.

	* hash.c (hash_mark): Hash tables which have both weak keys
	and values were not added to the reachable_weak_hashes list,
	and thus not subject to complete hash processing, leading
	to corruption.

2015-06-07  Kaz Kylheku  <kaz@kylheku.com>

	* lib.h (mkloc): Rename misleading argument from fun to obj.

2015-06-07  Kaz Kylheku  <kaz@kylheku.com>

	* parser.c (stream_parser_hash): New static variable.
	(parser_mark): Mark parser and primer members.
	(parser, ensure_parser): new argument: primer.
	(get_parser_impl, ensure_parser): New static
	functions.
	(prime_parser): New function.
	(lisp_parse): Multiple calls to this function on the same stream
	now logically continue the parse, not resetting the line
	number to 1.
	(parse_init): Initialize and gc-protect stream_parser_hash.

	* parser.h (parser_t): New members, primer and parser.
	(prime_parser): Declared.
	(parser): Declaration updated.

	* parser.y (parse): Now responsible for calling prime_parser.

2015-06-07  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (v_load): Call parse_once rater than parse.

	* parser.c (regex_parse, lisp_parse): Likewise.

	* txr.c (txr_main): Likewise.

	* parser.h (parse): Declaration updated.
	(parse_once): Declared.

	* parser.y (parse_once): New function, same as old parse implementation.
	(parse): Becomes one argument function which works with a previously
	initialized parser and continues the parse.

2015-06-07  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (catenated_stream_p, catenated_stream_push): New functions.
	(stream_init): Registered new functions as intrinsics.

	* stream.h (catenated_stream_p, catenated_stream_push): Declared.

	* txr.1: Documented catenated-stream-p and catenated-stream-push.

2015-05-25  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Document new syntactic places framework and place-mutating macros.

2015-05-25  Kaz Kylheku  <kaz@kylheku.com>

	Fix mismanaged dyn_env variable.

	* eval.c (bindings_helper): In the parallel binding case, only allocate
	a new dynamic env when it is needed (because a special variable is
	being bound), rather than unconditionally.
	Consequently, only modify dyn_env when the dynamic environment actually
	needs to be extended.  Constructs that use bindings_helper are only
	wrapped in the dynamic environment save/restore form
	sys:with-saved-vars if they bind special variables.

2015-05-22  Kaz Kylheku  <kaz@kylheku.com>

	Ligher weight debug instrumentation.

	This speeds up the TXR Lisp interpreter, because do_eval
	sets up a debug frame and uses debug_return.

	* debug.c (debug_block_s): Symbol removed.
	(debug_init): Remove initialization of debug_block_s.

	* debug.h (debug_block_s): Declaration removed.
	(debug_enter): Do not establish a named block or a catch block;
	no time-wasting unwind stack manipulation at all.
	The debug_depth variable is managed by the extended setjmp
	context now.  Provide a return value variable, and a well-defined name to
	branch to to exit from the debug block.
	(debug_return): Do not use heavy-weight uw_block_return;
	simply set the return variable and branch to debug_return_out
	label.

	* signal.h (EJ_DBG_MEMB, EJ_DBG_SAVE, EJ_DBG_REST,
	EJ_OPT_MEMB, EJ_OPT_SAVE, EJ_OPT_REST): New macros.
	(extended_jmp_buf): Define optional global state
	variables using EJ_OPT_MEMB.
	(extended_setjmp): Save and restore optional
	globals using EJ_OPT_SAVE and EJ_OPT_RESTORE.
	Now debug_depth is saved and restored if
	debugging support is compiled in.

	* match.c (open_data_source): Remove bogus debug_return
	invocations which were uncovered here by changes to the macro.

	* eval.c (do_eval, expand_macro): debug_return must now be after
	debug_end, because it won't dynamically clean up frames that it doesn't
	know about. The set_dyn_env is no longer unreachable in expand_macro;
	it is now necessary because debug_return isn't doing the longjmp
	that previously restored dyn_env.

2015-05-22  Kaz Kylheku  <kaz@kylheku.com>

	* place.tl (pushnew): New macro.

	* lisplib.c (set_place_dlt_entries): Add pushnew.

2015-05-22  Kaz Kylheku  <kaz@kylheku.com>

	symbol-function, symbol-value and fun become places.

	* eval.c (op_setqf): New function.
	(eval_init): Register sys:setqf operator. Also expose
	global variable hash tables via sys:top-vb and sys:top-fb.

	* place.tl (sys:get-fb, sys:get-vb): New functions.
	(fun, symbol-function, symbol-value): New places defined.

2015-05-21  Kaz Kylheku  <kaz@kylheku.com>

	Introduce defparm operator.

	* eval.c (me_defparm): New function.
	(eval_init): Register defparm.

	* txr.1: Documented defparm together with defvar.
	defvar documentation is revised.

2015-05-19  Kaz Kylheku  <kaz@kylheku.com>

	Represent place.tl more compactly in image.

	The contents of place.tl are now stored as a UTF-8 ordinary literal
	instead of a wide char literal.

	* Makefile (LISP_TO_C_STRING): Generate plain literal.

	* lisplib.c: Convert plain literal to string.

2015-05-15  Kaz Kylheku  <kaz@kylheku.com>

	Variables are now deletable places, if they are global.

	* place.tl (sys:sym-delete-expander): New function.
	(get-delete-expander): Retrieve delete expander for
	symbols.

2015-05-15  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (symbol_value): Retrieve the binding of a symbol
	macro also.
	(boundp): Return t for symbol macros.
	(makunbound, fmakunbound): New functions.
	(eval_init): Register makunbound and fmakunbound.

	* txr.1: Document changes to symbol-value and boundp.

2015-05-14  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (replace_list, replace_str, replace_vec): Handle
	the case when from is a vector, for consistency with the sel
	function and the dwim operator.

	* txr.1: Document that the third argument of select and replace may be
	a vector.

2015-05-13  Kaz Kylheku  <kaz@kylheku.com>

	Recursive lcons force bug (keep-if*, remove-if*).

	* lib.c (rem_lazy_func): Do not access the cdr field of
	the lcons that we are in the middle of forcing!

2015-05-13  Kaz Kylheku  <kaz@kylheku.com>

	* place.tl (define-modify-macro): New macro.

	* lisplib.c (set_place_dlt_entries): Add define-modify-macro.

2015-05-13  Kaz Kylheku  <kaz@kylheku.com>

	* place.tl (push): Ensure left-to-right eval order.

2015-05-12  Kaz Kylheku  <kaz@kylheku.com>

	* place.tl (rlet): For the sake of sane evaluation order
	in the face of unknown side effects, do not thread symbolic references;
	only propagate constants.

2015-05-12  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (env_vb_to_fb): Allow null env argument. This
	case occurs when (flet () ...) is expanded.

2015-05-12  Kaz Kylheku  <kaz@kylheku.com>

	DWIM places must use Lisp-1 semantics.

	This really only affects code which does something like
	(set [f x] y) and f resolves as a function. (The TXR Program
	bent over backwards to install a mutable object into a function
	binding.) In this situation, we need to update the function binding
	f, rather than some variable f.

	* eval.c (op_lisp1_setq, op_lisp1_value): New static functions.
	(eval_init): Register sys:lisp1-setq and sys:lisp1-value
	special forms.

	* place.tl (sys:*lisp1*): New special variable.
	(sys:l1-setq, sys:l1-val): New macros, optimizing
	versions of sys:lisp1-setq and sys:lisp1-value special operators.
	(sys:sym-place-update-expander, sys:sym-place-clobber-expander):
	React to sys:*lisp1* variable by doing symbol access using Lisp-1
	semantics, with help of newly introduced macros and special forms.
	(dwim): Bind sys:*lisp1* to true, if main argument is a symbolic place,
	so that the update is done using Lisp-1 semantics. Use the
	sys:l1-val operator when evaluating arguments.

2015-05-12  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (lookup_var_l): Gut this function of its silly
	reimplementation of lookup_var.
	(op_setq): Use lookup_var instead of lookup_var_l.
	Now only outside modules use the lookup_var_l interface.
	Error message fix: sys:setq, not setvar.

2015-05-11  Kaz Kylheku  <kaz@kylheku.com>

	Handle vectors and strings in rplaca and rplacd.

	* lib.c (rplaca, rplacd): Use refset and replace
	respectively to handle vectors and strings.
	Adjust type mismatch error message.

2015-05-11  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (chr_str_set): Check for literal strings.

2015-05-11  Kaz Kylheku  <kaz@kylheku.com>

	Fix argument count checking regression.

	* eval.c (apply): Revert some changes from 2015-03-13
	which cause the too many arguments case not to be
	diagnosed.

2015-05-10  Kaz Kylheku  <kaz@kylheku.com>

	* place.tl (errno): Support (errno) form as place.

2015-05-09  Kaz Kylheku  <kaz@kylheku.com>

	Improve error message related to splice misuse.

	* eval.c (expand_qquote): Corrected awkward error message text
	which was saying that a splice "cannot occur as an atom".

2015-05-09  Kaz Kylheku  <kaz@kylheku.com>

	Adding pset operator.

	* place.tl (pset): New macro.

	* lisplib.c (set_place_dlt_entries): Add pset.

2015-05-09  Kaz Kylheku  <kaz@kylheku.com>

	* place.tl (set): Take multiple place/value pairs. Allow zero
	arguments.

2015-05-08  Kaz Kylheku  <kaz@kylheku.com>

	Crack down on redefinitions of built-ins.

	* eval.c (builtin, eval_initing): New global variable.
	(op_defun, op_defmacro): During initialization, record functions
	and macros in builtin hash.
	(builtin_reject_test): New static function.
	(expand_macrolet): Perform builtin reject test for fbind, lbind,
	and macrolet.
	(regfun, reg_mac): Add symbol to builtin hash.
	(eval_init): GC-protect new hash table variable and initialize it.
	Set eval_initing to true over eval initialization.
	The flip function is renamed fo flipargs.
	(eval_compat_fixup): New function, for dealing with the
	operator/function conflict over flip.

	* eval.h (eval_compat_fixup): Declared.

	* lib.c (compat_fixup): Call eval_compat_fixup.

	* tests/011/macros-2.txr: This test was defining a macro called
	while which is now illegal. Renamed to whilst.

	* tests/011/macros-2.expected: Regenerated.

	* txr.1:  Function flip renamed to flipargs and documented in
	Compatibility section.

2015-05-07  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (LISP_TO_C_STRING): Strip comments, but not comment lines,
	so line numbers don't change.

	* eval.c (eval_init): Fix registrations of lisp-parse and read.

	* lisplib.c (place_instantiate): Give name to parsed string stream
	using new lisp_parse argument.

	* parser.c (lisp_parse): Takes new argument to override name.

	* parser.h (lisp_parse): Declaration updated.

	* txr.c (txr_main): Call lisp_parse with four args, defaulting
	the new one.

	* txr.1: Documented new argument.

2015-05-06  Kaz Kylheku  <kaz@kylheku.com>

	New macro-based framework for assignment places.

	The operators set, inc, dec, pop and others are now macros
	which generate code, rather than built-in special forms
	that use "C magic".  Moreover, new such macros are easy to write, and
	several new ones are already available.  Moreover, new kinds of
	assignable places are easy to create.

	* place.tl: New file.

	* lisplib.c, lisplib.h: New files.

	* Makefile (OBJS): New target, lisplib.o.
	(GEN_HDRS): New variable.
	(LISP_TO_C_STRING): New recipe macro, with rule.
	(clean): Remove generated headers named in $(GEN_HDRS).

	* eval.c (dec_s, push_s, pop_s, flip_s, del_s): Variables removed.
	(setq_s): New variable.
	(lookup_var, lokup_sym_lisp_1, lookup_var_l, lookup_fun, lookup_mac,
	lookup_symac, lookup_symac_lisp1): Trigger the delayed loading of
	libraries for undefined global symbols, and re-try the lookup.
	(op_modplace, dwim_loc, force_l): Static functions removed.
	(op_setq): New static function.
	(eval_init): Initialize setq_s; remove initializations of
	removed variables; remove registrations for op_modplace;
	add registration for sys:setq, sys:rplaca, sys:rplacd,
	sys:dwim-set and sys:dwim-del intrinsics.
	Call lisplib_init to initialize the dynamic library loading module.

	* lib.c (sys_rplaca, sys_rplacd): New functions, differing
	in return value from rplaca and rplacd.
	(ref, refset): Handle hash table.
	(dwim_set, dwim_del): New functions.

	* lib.h (sys_rplaca, sys_rplacd, dwim_set, dwim_del): Declared.

	* genvim.txr: Include place.tl in scan.

	* tests/010/seq.txr: The del operator test
	case no longer throws at run-time but at macro-expansion time, so the
	test case is simply removed.

	* tests/010/seq.expected: Updated output.

	* tests/011/macros-2.txr: Reset *gensym-counter* to zero, because
	the textual output of the test case includes gensyms, whose numberings
	fluctuate with the content of the new Lisp library material.

	* tests/011/macros-2.expected: Updated output.

2015-05-06  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (make_obj, gc): Move resetting of prev_malloc_bytes
	out of make_obj into gc.

2015-05-05  Kaz Kylheku  <kaz@kylheku.com>

	Do some cleanup in progn-like form sequences.

	* eval.c (expand_progn): New function.
	(do_expand): Use expand_progn for constructs
	which have an implicit progn body.

2015-05-03  Kaz Kylheku  <kaz@kylheku.com>

	Deal with bad quote syntax.

	* eval.c (op_quote): Throw error on bad syntax.

	* lib.c (obj_print, obj_pprint): Do not hide bad quote syntax
	using ' notation; print it using ordinary notation.

2015-05-01  Kaz Kylheku  <kaz@kylheku.com>

	Move initialization calls to more suitable place.

	* lib.c (init): Initialize parser, syslog and glob modules
	here.

	* txr.c (main): Remove initialization of parser, syslog and glob
	modules from here.

2015-05-01  Kaz Kylheku  <kaz@kylheku.com>

	* signal.h (sig_save_disable): Bugfix: macro enabling
	rather than disabling async signals.

2015-05-01  Kaz Kylheku  <kaz@kylheku.com>

	Fix corruption triggered by extended gc disabling.

	The issue is that when gc is disabled, the gc function
	does nothing. But various code depends on calls to gc()
	doing something, like making space available in various
	static arrays.

	When gc is disabled for long periods, there are issues,
	like array overruns.

	* gc.c (gc): Must no longer be called at all if gc_enabled is false,
	and asserts that it is true. Callers must check the gc_enabled
	flag and implement appropriate cases.
	(make_obj): Only call gc when gc_enabled is true.
	If there is no space in the freshobj array after trying gc,
	or gc couldn't be tried because it is disabled, then
	schedule a full gc.
	(gc_set): If the checkobj array is full, only call gc if gc
	is enabled, otherwise schedule a full_gc.
	(gc_mutated): Do not assume that the mutobj array has room
	for another object; only set the object's generation to -1
	and put it into the array if there is room. Similarly to
	gc_set, do a gc if there is no room, but if gc is not enabled, then
	schedule a full gc.
	(gc_wrap): Only call gc if gc_enabled is true, and return t in
	that case rathe than nil.

	* txr.1: Document return value of sys:gc function.

2015-04-30  Kaz Kylheku  <kaz@kylheku.com>

	Fix source location for dangling unquotes and splices.

	* parser.y (grammar): Propagate the parser line number to the unquote
	or splice form, if it has not received location info from its operand
	(because its operand is an atom). In the quasi_item case, we also use
	rlcp_tree to make sure the info is propagated through the list being
	consed up.
	(rlcp_tree): Bugfix: propagate the source location info to every cons
	in the list itself, not just into their cars.

2015-04-29  Kaz Kylheku  <kaz@kylheku.com>

	Improved syntax checking: defun, flet, labels, lambda.

	* eval.c (check_lambda_list): New static function.
	(op_defun): Argument list checking moved into
	check_lambda_list, which is called for defun out of
	do_expand. Name checks moved into do_expand.
	Thus, defun is checked earlier, at expansion time.
	(me_flet_labels): Check the lambda list of each lexical function
	with check_lambda_list.
	(do_expand): Check the syntax of the lambda form, and
	the validity of its argument list.
	Check the name of a defun or defmacro for validity.
	Check the validity of the defun argument list.

2015-04-29  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: cannot print (lambda . 42) structure.

	* lib.c (obj_print, obj_pprint): Fix mistake in the test for
	properly formed lambda syntax whcih is printed specially.

2015-04-28  Kaz Kylheku  <kaz@kylheku.com>

	Adding poll function.

	* configure: Check for the poll function and set
	HAVE_POLL accordingly in config.h.

	* stream.h (fd_k): External declaration added.

	* sysif.c (poll_wrap): New function.
	(sysif_init): Registered poll-in, poll-out, poll-err,
	poll-pri, poll-rdhup, poll-nval, poll-rdband, poll-wrband
	variables and poll function.

	* txr.1: Documented poll.

2015-04-21  Kaz Kylheku  <kaz@kylheku.com>

	Version 107.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise.

	* tl.vim, txr.vim: Regenerated.

2015-04-25  Kaz Kylheku  <kaz@kylheku.com>

	Allow (force ...) to be an assignable place.

	This allows mlet variables to be assignable.

	* eval.c (force_s): New global variable.
	(op_modplace): Handle force form.
	(me_mlet): Use force_s symbol.
	(force_l): New static function.
	(eval_init): Initialize force_s variable. Use it in registration
	of force function.

	* txr.1: Remove text in mlet definition that variables
	are not assignable. Replace with note about an unspecified behavior.

2015-04-25  Kaz Kylheku  <kaz@kylheku.com>

	Introducing mlet macro.

	* eval.c (me_mlet): New static function.
	(eval_init): Registered mlet macro.

	* txr.1: Documented mlet.

2015-04-25  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (symbol_package): If the argument is nil, return
	the user package directly, not the value of the *user-package*
	variable.

2015-04-25  Kaz Kylheku  <kaz@kylheku.com>

	Remove silly package lookup from keywordp.

	This tiny change yields a 165% (2.65X) speedup in the
	tst/tests/011/mandel.txr test case.

	* lib.c (keywordp): Use keyword_package_var instead of the
	keyword_package macro which looks up the global environment.

	* parser.y (sym_helper): Likewise.

2015-04-24  Kaz Kylheku  <kaz@kylheku.com>

	Regression: runaway allocation of heaps.

	* gc.c (make_obj): Fix regression introduced on 2014-10-18,
	released in TXR 100. Because make_obj discontinues
	placing objects into the freshobj_array when the full_gc
	flag has been set, it is incorrect to allocate another heap
	when the free list is exhausted and the freshobj_array
	has room remaining. It has room remaining because it is
	disused.

2015-04-24  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (make_obj, gc): The check for insufficient space in freshobj
	array after a gc is moved into the gc function.

2015-04-24  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (gc): Minor off-by-one: compare gc_counter to FULL_GC_INTERVAL
	rather than FULL_GC_INTERVAL - 1, since it is pre-incremented.

2015-04-22  Kaz Kylheku  <kaz@kylheku.com>

	Switch to in-tree mpi directory.

	* Makefile (CFLAGS, MPI_OBJS): Refer to mpi directory without version
	number.
	(repatch): Target removed.
	(distclean): Don't try to remove old unpacked tarball mpi directory.

	* configure (mpi_version, have_quilt, have_patch): Variables removed.
	(gen_config_make): Do not generate mpi_version make variable.
	Do not test for quilt or patch. No longer extract MPI tarball or
	try to apply patches.

	* mpi-1.8.6.tar.gz: File removed.

	* mpi-patches: Directory and all files under it removed.

2015-04-22  Kaz Kylheku  <kaz@kylheku.com>

	delay/force overhaul.

	* eval.c (promise_forced_s, promise_inprogress_s): New symbol
	variables.
	(me_delay): Change representation of promises so that the
	original delay form is stashed there for better reporting
	in the force function. Also, propagate the debug info
	from the second argument of the form to the entire form;
	otherwise it will inherit it from elsewhere.
	(force): Rewritten to follow new three-state representation
	to detect the recursive case and diagnose it.
	(eval_init): Register new symbol variables.

2015-04-21  Kaz Kylheku  <kaz@kylheku.com>

	Version 106

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise.

2015-04-19  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: throwing error when trying to print valid regexps.

	* regex.c (print_rec): Only dianose "bad object in regex syntax"
	for some atom other than nil, which denotes an empty (sub)expression,
	like what results from #// or #/a|/ and such.

2015-04-19  Kaz Kylheku  <kaz@kylheku.com>

	Do not allow unrecognized escapes in regex.

	* parser.l (REGOP): New regex alias for matching all regex
	special characters.
	(grammar): Several rules for regex special characters merged
	together. New rule introduced to match a special character
	after a backslash, making it literal. The old rule which makes
	literal any character after a backslash now throws an error,
	unless version 105 comaptibility is selected.

	* txr.1: Documented this behavior change.

2015-04-19  Kaz Kylheku  <kaz@kylheku.com>

	Improvement in error reporting.

	This fix prevents certain situations when an inappropriate form
	is reported, in the default unhandled exception handler, as pertaining
	to an error.

	* eval.c (do_eval): Save and restore the last_form_evaled,
	in an exception-unsafe way.  If we successfully evaluate a form or
	subform, we can restore the previous one.
	(expand): Save and restore last_form_expanded similarly. We don't
	need the unwind block and counter.

2015-04-18  Kaz Kylheku  <kaz@kylheku.com>

	Adding lcons macro.

	* eval.c (me_lcons): New function.
	(eval_init): Registered lcons macro.

	* txr.1: Documented lcons.

	* tl.vim, txr.vim: Regenerated.

2015-04-18  Kaz Kylheku  <kaz@kylheku.com>

	Adding getenv, setenv and unsetenv.

	* lib.c (setenv, unsetenv): Changed static functions to external.
	Moved them out of the #if !HAVE_TIMEGM block.

	* lib.h (setenv, unsetenv): Declared.

	* sysif.c (getenv_wrap, setenv_wrap, unsetenv_wrap): New functions.
	(sysif_init): Registered getenv, setenv and unsetenv.

	* txr.1: Documented getenv, setenv and unsetenv.

	* tl.vim, txr.vim: Regenerated.

2015-04-18  Kaz Kylheku  <kaz@kylheku.com>

	Fix quasistring regression introduced in TXR 81.

	* parser.y (expand_meta): This function must recognize
	quasistrings, inside (sys:quasi ...) forms, (sys:var ...) forms
	do not denote TXR Lisp variables. These must not be expanded.
	Doing so is not only wrong, but the way it was done broke
	brace variables by stripping their arguments.

2015-04-16  Kaz Kylheku  <kaz@kylheku.com>

	Adding exit* function which calls _exit.

	* sysif.c (exit_star_wrap): New static function.
	(sysif_init): Registered exit* intrinsic.

	* txr.1: Documented exit*.

	* tl.vim, txr.vim: Regenerated.

2015-04-16  Kaz Kylheku  <kaz@kylheku.com>

	Add exec and pipe functions.

	* configure: Check for pipe.

	* sysif.c (exec_wrap, pipe_wrap): New static functions.
	(sysif_init): Register exec and pipe intrinsics.

	* txr.1: Documented exec and pipe.

	* tl.vim, txr.vim: Regenerated.

2015-04-16  Kaz Kylheku  <kaz@kylheku.com>

	Adding chmod.

	* configure: Detect chmod.

	* sysif.c (chmod_wrap): New function.
	(sysif_init): Register chmod intrinsic.

	* txr.1: Documented.

	* tl.vim, txr.vim: Regenerated.

2015-04-16  Kaz Kylheku  <kaz@kylheku.com>

	Adding dotimes macro.

	* eval.c (me_dotimes): New function.
	(eval_init): Registering dotimes macro.

	* txr.1: Documented dotimes.

2015-04-15  Kaz Kylheku  <kaz@kylheku.com>

	Fix escaping issues in open-process on Windows.

	This can now execute programs with spaces in their path names.
	Arguments can contain embedded double quotes, and other characters
	that are special to cmd.exe, like &, |, (, ), ^ and others.

	* stream.c (string_extend_count, win_escape_cmd): New static functions.
	(win_escape_arg): Fix and extend escaping scheme to cover not only
	the argument processing scheme implemented by programs which use Microsoft's
	C library, but also to smuggle the command line through cmd.exe.
	(win_make_cmdline): Use win_escape_cmd to wrap the command.
	Escape the quotes which are placed around arguments, so cmd.exe
	doesn't interpret them, which will cause it to suppress its processing
	of the caret escapes.

2015-04-15  Kaz Kylheku  <kaz@kylheku.com>

	Allow quasiquotes in braces and quasiliterals, and quotes in braces.

	* parser.l: Consolidate rules for recognizing quote, unquote, and
	quasiquote. An effect of this is that quasiquotes can now occur in
	braces and in string quasiliterals.

	* parser.y (quasi_item): Support quotes and quasiquotes as quasi items:
	that is to say, i.e. objects denoted by @ in a quasiliteral.

2015-04-14  Kaz Kylheku  <kaz@kylheku.com>

	Diagnose trailing junk in numeric literals.

	* parser.l: Combining the handling of hex, octal and binary numeric
	literals into a single rule. Implementing an additional rule which
	diagnoses such tokens that have trailing junk. Thus, something
	like #x1F2AZ is now invalid syntax.

2015-04-11  Kaz Kylheku  <kaz@kylheku.com>

	Implementing while* and until* loops.

	* eval.c (while_star_s, until_star_s): New symbol variables.
	(me_while_star, me_until_star): New static functions.
	(eval_init): Initialize new variables. Register while* and
	until* macros.

	* txr.1: Documented while* and until*.

	* txr.vim, tl.vim: Regenerated.

2015-04-11  Kaz Kylheku  <kaz@kylheku.com>

	* sysif.c: Use HAVE_FORK_STUFF to wrap fork, waitpid and dup/dup2.

2015-04-11  Kaz Kylheku  <kaz@kylheku.com>

	Exposing dup and dup2.

	* sysif.c (dup_wrap): New static function.
	(sysif_init): Register dup_wrap as dupfd. The name dup
	conflicts with an existing function.

	* txr.1: Documented dupfd.

	* txr.vim, tl.vim: Regenerated.

2015-04-10  Kaz Kylheku  <kaz@kylheku.com>

	Functions open-fileno and fileno.

	* stream.c (fd_k): New keyword variable.
	(stdio_get_prop): Handle the :fd property by returning
	the file descriptor.
	(open_fileno): New function.
	(stream_init): Initialize fd_k, and register fileno and open-fileno.

	* stream.h (open_fileno): Declared.

	* txr.1: Documented open-fileno and fileno.

	* utf8.c (w_fdopen): New function.

	* utf8.h (w_fdopen): Declared.

2015-04-10  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (sweep): Fix comment referring to nonexistent identifier.

2015-04-10  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): There is an until_s global variable, so
	no need to intern the symbol when registering me_until.

2015-04-09  Kaz Kylheku  <kaz@kylheku.com>

	Fork and wait support.

	* sysif.c (work_wrap, wait_wrap, wifexited, wexitstatus,
	wifsignaled, wtermsig, wcoredump, wifstopped, wstopsig,
	wifcontinued): New static functions.
	(sysif_init): Register new intrinsics: functions fork, wait,
	w-ifexited, w-exitstatus, w-ifsignaled, w-termsig,
	w-coredump, w-ifstopped, w-stopsig, w-ifcontinued; and
	variables w-nohang, w-untraced, w-continued.

	* txr.1: Documented.

	* tl.vim, txr.vim: Regenerated.

2015-04-06  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (iflet_s, when_s): New global variables.
	(me_iflet_whenlet): New static function.
	(eval_init): Initialize when_s, iflet_s. Use
	when_s for registering me_when.
	Register me_iflet_whenlet.

	* txr.1: Documented iflet and whenlet.

	* tl.vim, txr.vim: Regenerated.

2015-04-05  Kaz Kylheku  <kaz@kylheku.com>

	New whilet macro.

	* eval.c (while_s): New symbol variable.
	(me_whilet): New static function.
	(eval_init): Initialize while_s. Use while_s in registration
	of while macro. Register new whilet macro.

	* txr.1: whilet is documented.

	* tl.vim, txr.vim: Regenerated.

2015-04-01  Kaz Kylheku  <kaz@kylheku.com>

	New zap operator.

	* eval.c (zap_s): New global variable.
	(op_modplace): Support zap.
	(eval_init): Initialize zap_s, and register as operator.

	* txr.1: Documented zap.

2015-03-31  Kaz Kylheku  <kaz@kylheku.com>

	Array overrun fix in apply.

	* eval.c (APPLY_ARGS): New preprocessor symbol, replaces
	hard-coded 32 inside apply.
	(apply): Use APPLY_ARGS for argument array.
	Fix overrun of args array in non-variadic function case when
	list has more than APPLY_ARGS elements.
	Eliminate superflous "variadic" local variable.

2015-03-31  Kaz Kylheku  <kaz@kylheku.com>

	Deal with spurious retention in function application.

	* gc.h (zap): New inline function.
	(z): New macro.

	* lib.c (generic_funcall, funcall1, funcall2, funcall4, do_not,
	do_dup, do_iff): Use z macro to burn funargs with no next use.

	* eval.c (apply, apply_frob_args, iapply, call, do_eval,
	op_dwim, mapcarv, mappendv, lazy_mapcarv_func, mapdov, do_apf,
	do_ipf, callf): Use z macro to burn funargs with no next use.

2015-03-30  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (vformat): Bugfix: ~X printing in lower case, like ~x,
	when argument is a bignum integer.

2015-03-29  Kaz Kylheku  <kaz@kylheku.com>

	* mpi-patches/eliminate-locale-dependencies: New patch.
	(s_mp_tovalue): Eliminate use of isupper, islower.

	* mpi-patches/series: Add patch.

2015-03-29  Kaz Kylheku  <kaz@kylheku.com>

	New -n option. New "i" mode letter in file opening functions.

	* stream.c (struct stdio_mode): New struct type.
	(stdio_mode_init_trivial): New initializer macro.
	(parse_mode, format_mode, normalize_mode, set_mode_props):
	New static functions.
	(make_stdio_stream_common): the isatty check, and automatic marking
	of tty device streams as real-time is no longer done, unless
	backward compatibility 105 or earlier is requested.
	(open_file, open_tail,  open_command, open_process): Use new
	mode parsing, which supports the "i" flag.
	(stream_init): If we have isatty, and standard input is a tty,
	then mark the *std-input* stream as real-time.

	* txr.1: Document -n/--noninteractive option. Fix typo where
	real-time-stream-p is referred to as stream-real-time-p.
	Document "i" flag on open-file and others.

	* txr.c (opt_noninteractive): New global.
	(help): Help text for -n/--noninteractive.
	(txr_main): Handle new options.

	* txr.h (opt_noninteractive): Declared.

2015-03-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (prinl, pprinl): Become external functions.
	(tprint): New function.
	(eval_init): Register tprint as intrinsic.

	* eval.h (prinl, pprinl, tprint): Declared.

	* txr.c (txr_main): New option, -t.

	* txr.1: Documented tprint and -t option.

2015-03-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): register get-lines as having one optional
	argument.

	* lib.c (lazy_stream_cons): Default the argument to std_input.

	* txr.1: Document that the stream is optional in get-lines.

2015-03-24  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (enforce): Update error error message.

	* configure (have_git): Don't set this variable if
	the TXR repository is missing, even if git is installed.
	I.e. have_git means have have the tool and the repo.

2015-03-20  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (int_str): Workaround for wcstol recognizing the 0x prefix when
	radix is 16. Also, thrown an error if radix is not in the range
	0 to 36.

	* txr.1: Document int-str's radix range restriction.

2015-03-17  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (help): Added missing documentation for -e and -p.
	Also documented -P.
	(txr_main): New option implemented, -P.

	* txr.1: Document -P, and clean up -e and -p documentation.

2015-03-11  Kaz Kylheku  <kaz@kylheku.com>

	Version 105.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise.

	* txr.vim, tl.vim: Regenerated.

2015-03-11  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (run): In Windows version, fix nasty corruption bug:
	we were freeing C strings that were not duplicated, but only borrowed
	from string objects.

2015-03-11  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (open_process, run): Eliminate utf8name local variable
	and associated memory leak. Correctly allocate only nargs + 1 elements
	for argv array, not nargs + 2.

2015-03-10  Kaz Kylheku  <kaz@kylheku.com>

	* sysif.c (mkdir_nothrow_exists): New static function.
	(ensure_dir): New function.
	(sysif_init): ensure_dir registered as intrinsic.

	* txr.1: ensure_dir documented.

2015-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* parser.c (open_txr_file, regex_parse, lisp_parse): Functions
	moved here from parser.l.

	* parser.l (open_txr_file, regex_parse, lisp_parse): Functions
	moved from here to parser.c.

2015-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (OBJS): Add parser.o.

	* parser.h (parser_s): Declared.
	(parse_init): Declaration removed.
	(parser_l_init): Declared.

	* parser.l (parse_init): Function renamed to parser_l_init.

	* parser.c: New file.

2015-02-25  Kaz Kylheku  <kaz@kylheku.com>

	New ignerr macro.

	* eval.c (me_ignerr): New static function.
	(eval_init): Registered ignerr macro.

	* txr.1: Documented.

	* tl.vim, txr.vim: Regenerated.

2015-02-25  Kaz Kylheku  <kaz@kylheku.com>

	Introducing persistent error state on streams.

	* lib.c (cobj_ops): New function.

	* lib.h (cobj_ops): Declared.

	* stream.c (null_ops): Initializer updated.
	(struct stdio_handle): New member, err.
	(stdio_stream_mark): Mark the err member.
	(errno_to_string): New static function.
	(stdio_maybe_read_error, stdio_maybe_error): Set persistent error
	state. Use errno_to_string_function.
	(stdio_put_string, stdio_put_char, stdio_put_byte, stdio_seek,
	stdio_get_line): Set errno to zero, so that if the underlying
	operations do not set errno on err, we don't misinterpret some pervious
	errno value as pertaining to the failed stream operation.
	(stdio_get_error, stdio_get_error_str, stdio_clear_error): New static
	functions.
	(stdio_ops, tail_ops, pipe_ops): Update initializer with new functions.
	(string_in_get_error, string_in_get_error_str): New static functions.
	(string_in_ops): Update initializer with new functions.
	(byte_in_get_error, byte_in_get_error_str): New static functions.
	(byte_in_ops): Update initializer with new functions.
	(string_out_ops, strlist_out_ops): Update initializer with null
	pointers for new functions.
	(struct dir_handle): New struct type.
	(dir_destroy, dir_mark): New functions.
	(dir_get_line): Refactor for struct dir_handle context rather than DIR.
	Persist error state.
	(dir_close): Refactor for struct dir_handle.
	(dir_get_error, dir_get_error_str, dir_clear_error): New static functions.
	(dir_ops): Update initializer with new functions.
	(make_stdio_stream_common): Initialize new err member.
	(make_dir_stream): Refactor for struct dir_handle.
	(get_error, get_error_str, clear_error): New functions.
	(cat_get_error, cat_get_error_str, cat_clear_error): New static
	functions.
	(cat_stream_ops): Update initializer with new functions.
	(stream_init): Register get-error, get-error-str, clear-error intrinsics.

	* stream.h (struct strm_ops): New function pointer members, get_error,
	get_error_str and clear_error.
	(strm_ops_init): Macro extended with new arguments for new function pointers.
	(get_error, get_error_str, clear_error): Declared.

	* syslog.c (syslog_strm_ops): Update initializer with null
	pointers for new functions.

	* txr.1: Documented get-error, get-error-str and clear-error.

2015-02-21  Kaz Kylheku  <kaz@kylheku.com>

	Improved error reporting, particularly for macro expansion.

	* eval.c (last_form_expanded): New variable.
	(do_expand): New static function; contains previous expand
	function.
	(expand): Becomes a wrapper for do_expand, with re-entry
	counting.
	(eval_init): GC-protect last_form_expanded.

	* eval.h (last_form_expanded): Declared.

	* parser.l (regex_parse, lisp_parse): Just use a simple word for
	the name of the regex or string parse location, not the entire
	expression itself.

	* unwind.c (uw_throw): Check whether expansion was going on
	when the unhandled exception was thrown and print additional
	information.

2015-02-20  Kaz Kylheku  <kaz@kylheku.com>

	* regex.c (match_regex_right): Bugfix: zero length matches
	should return zero length, rather than nil. This is achieved by trying
	the match at one past the last character.

2015-02-20  Kaz Kylheku  <kaz@kylheku.com>

	String-returning wrappers for some regex matching functions.

	* eval.c (eval_init): Register search-regst, match-regst
	and match-regst-right intrinsics.

	* regex.c (search_regst, match_regst, match_regst_right): New functions.

	* regex.h (search_regst, match_regst, match_regst_right): Declared.

	* txr.1: Documented new variants.

2015-02-15  Kaz Kylheku  <kaz@kylheku.com>

	* regex.c (print_rec): A compound must use parentheses for
	elements which have a higher precedence than catenation.

2015-02-12  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (list_collect, list_collect_append): In error
	messages about bad appends, do not show the list being
	appended because it may be an infinite lazy list.
	For instance (append* 3 lazy-list).

2015-02-12  Kaz Kylheku  <kaz@kylheku.com>

	New functions pad and weave.

	* eval.c (pad_func, pad, weave_while, weave_gen, weavev):
	New static functions.
	(eval_init): Registered pad and weave intrisics.

	* txr.1: Documented pad and weave.

2015-02-12  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (lazy_appendv_func, lazy_appendv): Bugfix: append*
	was silently ignoring lists after the first atom, instead of
	throwing an error. Also, it was not detecting the case that
	the last argument is a list which should just be returned,
	and instead trying to find its tail in preparation for the
	next call to lazy_appendv_func, the consequences being runaway
	iteration over an infinite list.

2015-02-10  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (symacro_k, fun_k): New keyword variables.
	(lexical_lisp1_binding): New static function.
	(eval_init): Initialize symacro_k and fun_k; register
	new intrinsic function lexical-lisp1-binding.

	* match.h (var_k): Existing external name declared.

	* txr.1: Documented lexical-lisp1-binding.

2015-02-09  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: Add dependency froml $(EXTRA_OBJS-y) to header
	file and config.h, so windows resource file is rebuilt
	when the version changes.

2015-02-09  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: Removing bogus eval which refers to nonexistent
	DEP_INSTANTIATE macro.

2015-02-09  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (clean): Remove $(EXTRA_OBJS-y) so the Windows .res
	file is removed.

2015-02-08  Kaz Kylheku  <kaz@kylheku.com>

	Version 104.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

2015-02-07  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (trunc_rem): New function.

	* eval.c (eval_init): Register trunc-rem intrinsic.

	* lib.h (trunc_rem): Declared.

	* txr.1: Documented trunc-rem.

	* tl.vim, txr.vim: Updated.

2015-02-07  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (CFLAGS): Removed puzzling, unnecessary definitions
	of XMALLOC, XCALLOC, XREALLOC and XFREE for $(MPI_OBJS). MPI
	does not use such macros and the allocator is already retargetted
	to use the TXR one.

	* mpi-patches/use-txr-allocator: In this patch, we don't need
	external declaration for chk_malloc or chk_realloc because they
	are not used. Only chk_calloc is used.

	* mpi-patches/add-bitops: Refreshed.

	* mpi-patches/add-mp-hash: Likewise.

	* mpi-patches/add-mp-set-intptr: Likewise.

	* mpi-patches/add-mpi-toradix-with-case: Likewise.

	* mpi-patches/bit-search-optimizations: Likewise.

	* mpi-patches/export-mp-eq: Likewise.

	* mpi-patches/faster-square-root: Likewise.

	* mpi-patches/fix-bad-shifts: Likewise.

	* mpi-patches/fix-ctype-warnings: Likewise.

	* mpi-patches/fix-mult-bug: Likewise.

	* mpi-patches/mpi-set-double-intptr: Likewise.

	* mpi-patches/mpi-set-mpi-word: Likewise.

	* mpi-patches/mpi-to-double: Likewise.

2015-02-07  Kaz Kylheku  <kaz@kylheku.com>

	Support txr-win.exe target which has no console window.

	* Makefile (EACH_CONF): Iterate over arguments.
	(opt/txr-win.o, dbg/txr-win.o): New special object files.
	(opt/%-win.o, dbg/%-win.o): New pattern rule to build special object
	files.
	($(PROG)-win, $(PROG)-win-dbg): New program targets.

	* inst.nsi: Install txr-win.exe.

2015-02-07  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: fixed flurry of phrasing, formatting fumbles.

2015-02-07  Kaz Kylheku  <kaz@kylheku.com>

	* tests/011/macros-1.txr: Add test for lexical function
	shadowing symbol macro.

	* tests/011/macros-1.expected: Updated.

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	* unwind.c (uw_throw): Detect invalid re-entry and bail.
	Cautiously, we use fprintf rather than our streams system, in case some
	problem with the streams is involved in this mess.

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	* unwind.c (uw_throw): Put a txr: prefix on the unhandled
	exception in early initialization message.

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	Slight internal representation change of string-only exceptions.

	One upshot of all this is that (throw 'foo "msg") now
	does exactly the same thing as (throwf 'foo "msg").
	A message-only exception really is a one-string exception argument
	list ("message ..."), like the documentation says.

	* unwind.h (struct uw_catch): exception member renamed to args.
	(uw_catch): Macro follows structure member rename.

	* eval.c (op_catch): Removed now unnecessary kludge of turning non-list
	exception argument list into a one-element argument list.

	* match.c (v_try): Similar hack to the one in op_catch
	removed here.

	* unwind.c (uw_unwind_to_exit_point, uw_push_catch): Follows rename of
	exception member.
	(uw_throw): The exception parameter is renamed to args.  The kludge
	removed from op_catch re-appears here, because numerous calls
	to uw_throw just pass a string as args. It's less of a kludge here
	because this is the master entry point to exception processing,
	and it straightens out the representation right away.
	The exception arguments or message are printed in a clearer way.

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	Serious bugfix in the op macro, and derived macro, in
	the handling of missing meta-numbers (for
	instance (op ... @1 .. @3): 1 and 3 occur, but not 2.

	* eval.c (supplement_op_syms): Bugfix: loop was testing
	and updating the wrong variable, causing it to be looking at the first
	element of the syms list in every iteration.
	Not a regression: this was implemented wrong when the function
	was introduced on October 6, 2013.

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (subst_vars): Bugfix. When an ordinary variable
	occurs in the quasi syntax (which is the result of substitution
	of metanums like @1 by the op macro), if that variable
	evaluated to a list form, it was not being converted to
	a string. The resulting form was then examined for variable
	substitutions as if it were part of the quasi syntax.
	This was introduced at the same time as the feature of being
	able to use metanums in a quasiliteral (Feb 13, 2012:
	last change before Version 57).

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (transform_op): When expanding @rest and metanums
	like @1, @2, preserve the (sys:var X args ..) structure
	if there are args (but of course with X replaced by the appropriate
	gensym). This allows syntax like `@{1 10}` to work in quasiliterals: in
	other words, modifiers on interpolated metas, on par with @{a 10}.

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	* sysif.c (abort_wrap): New static function.
	(sysif_init): Registered abort intrinsic.

	* txr.1: Documented abort. Changed Unix Programming heading
	to System Programming, since exit, abort and errno are not
	Unix-specific, but C-specific.

	* tl.vim, txr.vim: Updated.

2015-02-06  Kaz Kylheku  <kaz@kylheku.com>

	* unwind.c (unhandled_hook_s): New static variable.
	(uw_throw): In the unhandled case, check if *unhandled-hook* variable
	has a function, and use it instead of the default logic. If it's not a
	function, abort with an error message. Clear it so that if the hook
	function re-enters this code, it will not be used. Always exit now on
	unhandled exceptions; do not abort.
	(uw_late_init): New function.

	* unwind.h (uw_late_init): Declared.

	* lib.c (init): Call uw_late_init.

	* txr.1: Documented *unhandled-hook*.

	* genvim.txr: Scan the unwind.c file, since it has a reg_var now.

	* tl.vim, txr.vim: Updated.

2015-02-05  Kaz Kylheku  <kaz@kylheku.com>

	* win/env.nsh: Before the potentially length SendMessage,
	print an informative message.

2015-02-05  Kaz Kylheku  <kaz@kylheku.com>

	* win/env.nsh: Improve messages about environment
	variable modification.

2015-02-04  Kaz Kylheku  <kaz@kylheku.com>

	Symbol macros shadowed by functions under dwim.

	* eval.c (lookup_symac_lisp1, expand_lisp1,
	expand_forms_lisp1): New static functions.
	(expand): Handle dwim's arguments via
	expand_forms_lisp1, rather than as a generic
	compound form.

	* txr.1: Revised text in several places to clarify
	this expansion rule.

2015-02-01  Kaz Kylheku  <kaz@kylheku.com>

	Version 103

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

2015-02-01  Kaz Kylheku  <kaz@kylheku.com>

	Update copyright notices from 2014 to 2015.

	* arith.c, arith.h, combi.c, combi.h, debug.c, debug.h, eval.c, eval.h,
	filter.c, filter.h, gc.c, gc.h, hash.c, hash.h, lib.c, lib.h,
	match.c, match.h, parser.h, rand.c, rand.h, regex.c, regex.h,
	signal.c, signal.h, stream.c, stream.h, sysif.c, sysif.h, syslog.c,
	syslog.h, txr.c, txr.h, unwind.c, unwind.h, utf8.c, utf8.h:
	Update.

	* LICENSE, METALICENSE: Likewise.

2015-02-01  Kaz Kylheku  <kaz@kylheku.com>

	Windows installer.

	* inst.nsi: New file.

	* win/env.nsh: New file.

2015-01-31  Kaz Kylheku  <kaz@kylheku.com>

	On Windows, add icon and identifying meta-data to executable.

	* Makefile (EXTRA_OBJS-y): New variable.
	(WINDRES): New recipe.

	* configure: Check for presence of windres,
	and generate add_win_res variable in config.make.

	* win/txr.xcf: New file: GIMP project for icon.

	* win/txr.ico: New file: icon with three sizes generated
	from GIMP project.

	* win/txr.rc: New file.

2015-01-29  Kaz Kylheku  <kaz@kylheku.com>

	Use macro to initialize strm_ops.

	* stream.h (strm_ops_init): New macro.

	* stream.c (null_ops, stdio_ops, tail_ops, pipe_ops, string_in_ops,
	byte_in_ops, string_out_ops, strlist_out_ops, dir_ops,
	cat_stream_ops): Initialize using macro.

	* syslog.c (syslog_strm_ops): Likewise.

2015-01-29  Kaz Kylheku  <kaz@kylheku.com>

	Use macro to initialize cobj_ops.

	* lib.h (cobj_ops_init): New macro.

	* hash.c (hash_ops, hash_iter_ops): Initialize with cobj_ops_init.

	* rand.c (random_state_ops): Likewise.

	* regex.c (char_set_obj_ops, regex_obj_ops): Likewise.

2015-01-29  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (make_ubignum): New static function.
	(sign_extend): New function.

	* eval.c (eval_init): Register sign-extend intrinsic.

	* lib.h (sign_extend): Declared.

	* txr.1: Documented sign-extend.

	* tl.vim, txr.vim: Updated.

2015-01-29  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: fixed use of nonexistent str-int in @(require) example;
	fixed bad formatting under logtrunc and partition.

2015-01-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (get_opt_param_syms): Fix broken function. This
	was choking on keywords like :env in the lambda list,
	and failing to handle the nested patterns of macro
	lambda lists. Failing case: (defmacro x (: opt :env foo)).

2015-01-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bind_macro_params): Bugfix: the colon argument's special
	meaning "treat the argument as missing" must apply only to optional
	parameters.

2015-01-27  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (make_like): Fix regression introduced in 102.
	A one element list being converted to a string
	treated as an empty list, leading to empty string.

2015-01-27  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (width): New function.

	* arith.h (width): Declared.

	* eval.c (eval_init): Width registered as intrisinc.

	* txr.1: Documented width.

2015-01-25  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (call_f): New global variable.
	(do_mapf, mapf): New static functions.
	(eval_init): Protect call_f from gc, and initialize it.
	Re-register call function using call_f.
	Register mapf intrinsic.

	* txr.1: Documented mapf.

2015-01-25  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register dupl and swap_12_21 as
	the dup and flip intrinsics.

	* lib.c (do_dup): New static function.
	(dupl): New function.

	* lib.h (dupl): Declared.

	* txr.1: Documented dup and flip.

2015-01-24  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (callf): New static function.
	(eval_init): callf registered.

	* txr.1: Documented callf.

2015-01-22  Kaz Kylheku  <kaz@kylheku.com>

	Basic implementation of constantp. Does not
	recognize forms like (+ 2 2) as constant.

	* eval.c (constantp_noex, constantp): New functions.
	(eval_init): Registered constantp as intrinsic.

	* tl.vim, txr.vim: Updated.

	* txr.1: Documented constantp.

2015-01-21  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (get_string): New argument, close_after_p.
	Close the stream unless close_after_p is specified and is nil,
	or when it is missing, an there is no compatibility or it's
	newer than version 102.

	* stream.h (get_string): Updated declartion.

	* txr.1: Documented default closing behavior of get-string
	and the new optional argument for overriding it.

2015-01-21  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Minor fix in split-str-set documentation.

2015-01-21  Kaz Kylheku  <kaz@kylheku.com>

	Allow macros to tell what symbols have lexical function
	or variable bindings.

	* eval.c (lexical_var_p, lexical_fun_p): New local functions.
	(eval_init): Registered as intrinsics.

	* txr.1: Documented lexical-var-p and lexical-fun-p.

	* tl.vim, txr.vim: Updated.

2015-01-13  Kaz Kylheku  <kaz@kylheku.com>

	Version 102

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

	* tl.vim, txr.vim: Regenerated.

2015-01-12  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (zerop): Handle character arguments.
	(plusp, minusp): New functions.

	* eval.c (eval_init): Register plusp and minusp.

	* lib.h (plusp, minusp): Declared.

	* txr.1: Documented plusp and minusp, and the
	handling of characters by zerop.

2015-01-12  Kaz Kylheku  <kaz@kylheku.com>

	Fix for LLVM wchar_t literals not being four byte
	aligned, affecting OS X port.

	* configure: Detect a SIZEOF_WCHAR_T when detecting integer
	type that will hold a pointer. In the lit_align test,
	if we are on Apple Mac OSX, use a lit_align of 2,
	so the logic kicks in for padding literals and handling
	misalignment.

	* lib.h (litptr): Add a case for LIT_ALIGN < 4 and
	SIZEOF_WCHAR_T == 4. In this case we do the arithmetic
	on the pointer using short *, and then convert to
	wchar_t.

	* HACKING: New section 2.4.3 about new wchar_t hack.

2015-01-12  Kaz Kylheku  <kaz@kylheku.com>

	* signal.h (sig_save_enable, sig_save_disable):
	Use do;while(0) trick instead of local typedef
	to cause terminating semicolon to be required.
	(sig_restore_enable, sig_restore_disable):
	Remove superfluous do { } while (0).
	Closing a brace is good enough.

2015-01-11  Kaz Kylheku  <kaz@kylheku.com>

	* glob.c: New file.
	(glob_wrap, glob_init): New functions.
	(errfunc_thunk): New static function.

	* glob.h: New file.

	* txr.c (main): call glob_init if HAVE_GLOB is defined.

	* configure (have_glob): New variable.
	(gen_config_make): Add have_glob to config/config.make.
	Detect glob function and set have_glob, and add
	HAVE_GLOB to config/config.h.

	* Makefile (OBJS): Include glob.h if have_glob is "y".

	* genvim.txr: Scan glob.c for functions and variables also.

	* txr.1: Documented glob and glob-related variables.

2015-01-11  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (retest): New phony target for convenience.

2015-01-11  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (make_like): Bugfix. (make-like nil "abc")
	must return the empty string, not nil. Only
	lists of non-characters fail to convert to a string.
	Since programs may depend on the hitherto wrong,
	undocumented behavior, this is made subject to
	compatibility.

	* txr.1: Added compatibility note.

2015-01-11  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (merge_wrap): Make generic over sequences.

	* txr.1: Update documentation for merge function.

2015-01-05  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (h_trailer): Bugfix: not returning new variable
	bindings captured in trailer section. Ouch!

2015-01-01  Kaz Kylheku  <kaz@kylheku.com>

	Version 101

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

2015-01-01  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (rebuild, clean, repatch): Fail these targets if
	the program is not configured.
	(distclean): Providing alternative implementation when the
	program is not configured.

2014-12-31  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (replace_str, replace_vec): Bugfix. The replacement item
	sequence may be an infinite list in the case that the from argument
	specifies a list of indices. We must avoid trying to calculate its
	length before we have detected this case.

2014-12-31  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Fix error. (set [seq index-list] new) corresponds to
	replace not to refset.

2014-12-25  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (stream_init): Register make_catenated_stream in
	a different form as cat-streams.

	* txr.1: Document cat-streams.

	* tl.vim, txr.vim: Regenerated.

2014-12-25  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (simple_lazy_stream_func): Bugfix: close the stream
	if get_line returns nil.

	* stream.c (cat_get_line, cat_get_char, cat_get_byte): The catenated
	stream read operations close an exhausted stream before popping
	to the next one.

	* txr.1: Document closing behavior of catenated streams.

2014-12-23  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (ap_s, ret_s, aret_s): New symbol variables.
	(me_ret): Static function renamed to me_ret_aret.
	Handles ret and aret macro expansion.
	(eval_init): Initialize ap_s, ret_s and aret_s.
	Re-register ret macro using ret_s and bind to me_ret_aret.
	Register aret macro.

	* txr.1: Documented aret.

	* tl.vim, txr.vim: Regenerated.

2014-12-23  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Registered intrinsic function unique.

	* lib.c (unique): New function.
	(uniq): Becomes wrapper around unique.

	* lib.h (unique): Declared.

	* txr.1: Documented unique, and equivalence between uniq and unique.

	* tl.vim, txr.vim: Regenerated.

2014-12-23  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (func_n1ov, func_n2ov, func_n3ov): New functions.

	* lib.h (func_n1ov, func_n2ov, func_n3ov): Declared.

2014-12-23  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (func_n0o): Useless, unused function removed.

	* lib.h (func_n0o): Declaration removed.

2014-12-18  Kaz Kylheku  <kaz@kylheku.com>

	Syntax highlighting issue: keywords in braced variable syntax
	not being recognized.

	* genvim.txr (txr_braced_ident): New match kind, specifically
	for a keyword.
	(txr_bracevar): Bracevar region contains txr_braced_indent.

	* txr.vim, tl.vim: Regenerated.

2014-12-18  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (copy): Support copying random state objects
	vi make_random_state.

	* txr.1: Updated.

2014-12-17  Kaz Kylheku  <kaz@kylheku.com>

	* rand.c (rand32): Bugfix: if the seed object is a random
	state, we do not want to make the 8 calls to rand32 to
	mix up the state; we need are making a straight copy.

	* txr.1: Document the possibility that the seed object
	is a random state. Document the platform-independence of the
	integer seed.

2014-12-17  Kaz Kylheku  <kaz@kylheku.com>

	* rand.c (struct rand_state): Change cur member to unsigned.
	This generates better code for rand32.

2014-12-16  Kaz Kylheku  <kaz@kylheku.com>

	* rand.c (rstate): New inline function.
	(rand32): Use inline function instead of macro.
	I compared gcc -O2 output on Intel: no difference.

2014-12-13  Kaz Kylheku  <kaz@kylheku.com>

	Factor out some compiling commands into macros.

	* Makefile (COMPILE_C, COMPILE_C_WITH_DEPS, LINK_PROG): New
	macro strings.
	(dbg/%.o, opt/*.o, %.o, $(PROG), $(PROG)-dbg, conftest,
	conftest2): These targets now use these commands.

2014-12-11  Kaz Kylheku  <kaz@kylheku.com>

	Build bugfix: if a config.h header exists in $(top_srcdir),
	then that header is used when building in a separate directory,
	instead of the config.h generated in that directory.
	To fix this, we move config.h into a config/ subdirectory.
	The $(top_srcdir)/config is not in the include search path
	when buiding in a separate build directory.
	While we are at it, let's move all the configure materials
	generated by the configure script into config/.

	* Makefile: include config/config.make at the top. Removing the
	rule which asserts the existence of configuration based on
	the presence of config.make.
	(CFLAGS): Add $(conf_dir) to include search path with -iquote.
	(notconfigured): New conditionally-defined target for producing
	the error message when the build system is not configured.
	(NL, DEP): New variables.
	($(OBJS)): Make dependent on config/config.make and config/config.h
	with help of DEP macro.
	(opt/lex.yy.o, dbg/lex.yy.o): Express dependency using DEP.
	(y.tab.h): Split off as a dependent on y.tab.c rather than
	a co-target in the rule.  The rule has a body to handle
	the situation when y.tab.h is missing for some reason, but
	y.tab.c already exists (and so won't be re-made, and so
	y.tab.h won't be remade).

	* configure: Require GNU Make 3.81 rather than 3.80.
	(conf_dir): New variable.
	(config_h, config_make, config_log): New variables.  These are used in
	place of config.h, config.make and config.log.  Add conf_dir to
	config.make variable.

2014-12-11  Kaz Kylheku  <kaz@kylheku.com>

	* configure (have_git): New variable and configure test for git.

	* Makefile (SRCS): Only set if git is available.
	(enforce): Fail if we don't have git.

2014-12-10  Kaz Kylheku  <kaz@kylheku.com>

	Throwing away old dependency system.

	* Makefile (DEPGEN): New macro variable.
	(OPT_OBJS, DBG_OBJS): Define with := assignment.
	(OBJS): New variable.
	(dbg/%.o, opt/*.o): Use -MMD and -MT options of gcc to generate
	dependencies. Also use DEPGEN macro to rewrite each dependency
	makefile's rule into a DEP_ variable assignment.
	(DEP_INSTANTIATE): New macro variable.
	(include dep.mk): Removed, replaced by eval hack that
	includes all the .d files and instantiates the rule from
	the DEP_ variable in each one.
	(opt/lex.yy.o, dbg/lex.yy.o): We need to hard code the dependency
	of these on y.tab.h, to force that header to generate.
	(DEP_opt/lex.yy.o, DEP_dbg/lex.yy.o): New variables, related
	to above.
	(depend): Target removed.

	* dep.mk: File removed.

	* depend.txr: File removed.

2014-12-10  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (ABBREV): Rewrite to take advantage of DEP_
	variables to remove the dependencies from the output.
	(ABBREV2): No longer needed, removed.
	(dbg/%.o, opt/%.o, %.o): Just use ABBREV instead of ABBREV2; it does
	the right thing.  Dependency of objects on config.make removed.

2014-12-09  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (install-tests): Do not use option -c of
	cpio (use old ASCII format). This was unintentional.
	On extract, use -m option to preserve timestamps,
	like we do in INSTALL.

2014-12-09  Kaz Kylheku  <kaz@kylheku.com>

	Test output goes to tst/ now.

	* Makefile (TESTS_OUT): We don't need to refer to top_srcdir.
	Add the tst/ prefix to .out paths. Find must be used with -H
	because tests is a symlink for out-of-tree build directories.
	(tests/*): All target-specific assignments are moved to tst/tests/*
	paths, and top_srcdir is no longer used in the right hand side
	values.
	(%.out): Becomes (tst/%.out).
	(%.ok): need to compute .expected name from .out differently to
	account for tst/ prefix.
	(tests.clean): Just remove the tst directory.
	(install-tests): Remove the tst directory first so test commands
	are forced to run (though it is a dry run).
	We no longer need to switch to top_srcdir to find the .txr
	files, nor do we have to filter out .out files from the tests
	tree. We no longer have to switch to top_srcdir in the recursive
	make. Also, show the installation of tests using ABBREV3.

	* configure: When configuring in a separate directory, symlink
	the tests directory back to the source tree. Since there
	are now three things being symlinked, rewrote that as a loop.
	The recommendation to build in a separate directory is just a note, not
	a warning.

2014-12-09  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (($TESTS_OUT)): Do not depend on $(PROG).
	This adds superfluous commands to run.sh under make install-tests,
	and is also inappropriate if a different txr binary is being tested.
	(install-tests): Do not override top_srcdir in the recursive make
	call; instead use -C to change to $(top_srcdir).

2014-12-09  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (all): Mark as phony target.

2014-12-09  Kaz Kylheku  <kaz@kylheku.com>

	Condensed make output.

	* Makefile (VERBOSE): New variable.
	(V, ABBREV, ABBREV1, ABBREV3): New macro variables.
	(dbg/%.o, opt/%.o): Use V, ABBREV1 for concensed output.
	($(PROG), $(PROG)-dbg, lex.yy.c, y.tab.c, %.out,
	%.ok, INSTALL): Likewise, but use ABBREV.
	(tests, GREP_CHECK, config.make, conftest.yacc,
	conftest.clean): Use $(V) instead of @.
	(tests.clean): Remove @; do not hide remove commands.
	(INSTALL): Use $(V) instead of @ and use ABBREV3 to
	provide condensed output.
	(install): Use $(V) on $(PREINSTALL) so we don't see :
	in the output.
	(install-tests): Put $(V) on all steps.

2014-12-07  Kaz Kylheku  <kaz@kylheku.com>

	Debug builds optional with --debug-also config option.

	* Makefile (PROG): Variable removed, now set in config.make.
	(all): Target now depends on $(BUILD_TARGETS) variable, set
	in config.make.

	* configure (debug_also) New variable.
	(gen_config_make): Generate PROG and BUILD_TARGETS variables.

2014-12-05  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (tofloat, toint): Handle characters.
	Fix error message in toint wrongly identifying itself as tofloat.

	* txr.1: Document handling of characters.

2014-12-05  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register in function as intrinsic.

	* lib.c (in): New function.

	* lib.h (in): Declared.

	* txr.1: Documented in.

	* txr.vim, tl.vim: Regenerated.

2014-12-05  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (set_diff): Bugfix: use member rather than find,
	so that a nil set element is handled properly.

2014-12-05  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (INSTALL): Bugfix: touch -r $(2) does not work
	right when $(2) is a wildcard like path/to/*.txr.  It touches files in
	the source tree to the timestamp of the argument after -r.  Putting in
	a shell loop to handle this.

2014-12-05  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (TESTS_TMP): New variable.
	(TESTS_OUT): Depends on $(PROG).
	(TESTS_OK): Does not dependon $(PROG).
	(tests): Does not depend on tests.clean.
	(retest): Target removed.
	(%.out : %.txr): Generate to temporary file,
	then move to .out.
	(tests.clean): Remove $(TESTS_TMP).

2014-12-05  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (SRCS): Compute from top_srcdir, so we don't get a warning
	from git, and "make enforce" works from out of three builds.

2014-12-05  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Bugfix: the "share" directory has to be
	symbolically linked. Without this, tests which require txr to have
	access to its library do not work.

2014-12-04  Kaz Kylheku  <kaz@kylheku.com>

	TXR now builds optimized and debug at the same time.
	Optimized object files are under opt/ and debug
	object files are under dbg/. The debug txr executable
	is called txr-dbg.

	* Makefile (CFLAGS): $(OPT_FLAGS) is omitted from CFLAGS,
	so we can expand it where appropriate.
	(ADD_CONF, EACH_CONF): New variables, used as macros.
	(DBG_OBJS, OPT_OBJS): New variables.
	(dbg/%.o, opt/%.o): New rules.
	(all): New target.
	($(PROG)-dbg): New target.
	(clean): Remove the object directories with rm -rf.
	Remove $(PROG)-dbg.
	(depend): Pass $(OPT_OBJS) and $(DBG_OBJS) to depend.txr
	Also: various target-specific assignments for object files
	had to be split for rel and dbg.

	* depend.txr: Updated to handle dbg/ or rel/ prefix on
	object file paths.

	* dep.mk: Regenerated.

2014-12-04  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (clean): add tests.clean as prerequisite.
	(tests): Add tests.clean as prerequiste, remove rm command.
	(retest, tests.clean): New rules.

2014-12-04  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (tests/009/json.out): Use eager assignment
	intead of lazy assignment to set TXR_ARGS.

2014-12-04  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (TXR): New variable. We use this to run txr
	rather than ./$(PROG). This way we can override the variable
	from the command line if necessary.
	(TESTS): Variable removed.
	(TESTS_OUT, TESTS_OK): New variables, replace TESTS.
	(tests): Prerequisites is now $(TESTS_OK), which are
	actual timestamp files. Also depends on $(PROG).
	(tests/%/%): Target specific assignments are now for .out
	targets rather than .ok targets.
	(%.out): New pattern target, made from half of previous %.ok rule.
	(%.ok): Smaller rule, only performs diff between .out and .expected,
	and touches the .ok stamp.
	(%.expected): Bugfix: this rule now just copies .out to .expected,
	and its prerequisite is %.out rather than %.txr.
	Previously it tried to run txr, but it wouldn't use the correct
	options, which depended on the target-specific assignments for
	various .ok files.
	(install-tests): Bugfix: in the "make -s -n" call use the new TXR
	variable to specify the program's path. This fixes the issue that ./
	was prepended to the txr commands, resulting in nonworking run.sh.
	(txr-manpage.html): Use TXR to invoke txr rather than PROG.

2014-12-04  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: Adding empty .SUFFIXES: to disable built-in suffixes.
	Also set MAKEFLAGS to disable all built-in rules.
	The only one rule we used is .c to .o, so we provide it ourselves.

2014-11-27  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register lequal and gequal.

	* lib.c (lequal, gequal, lequalv, gequalv): New functions.

	* lib.h (lequal, gequal, lequalv, gequalv): Declared.

	* txr.1: Documented lequal and gequal.

	* txr.vim, tl.vim: Regenerated.

2014-11-27  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register less and greater to
	the lessv and greaterv functions instead of less and greater.

	* lib.c (lessv, greaterv): New functions.

	* lib.h (lessv, greaterv): Declared.

	* txr.1: Document variadic nature of less and greater.

2014-11-21  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register sort-group.

	* lib.c (sort_group): New function.

	* lib.h (sort_group): Declared.

	* txr.1: Documented.

2014-11-21  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (partition_star_func): Bugfix: doing rplaca(env, seq)
	too early, before the loop which adjusts its value.
	Restructuring this slightly to avoid duplicated code, by moving the
	!first check later.

2014-11-21  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (partition_by_func): Rename one local variable for clarity.
	Remove unessential variable last, and move the next variable
	into loop scope.

2014-11-20  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (wrap_star, wrap): New functions.

	* eval.c (eval_init): Registered wrap and wrap* intrinsics.

	* lib.h (wrap_star, wrap): Declared.

	* txr.1: wrap and wrap* documented.

2014-11-20  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (succ, ssucc, sssucc, pred, ppred, pppred): New functions.

	* eval.c (eval_init): Register new functions as intrinsics.

	* lib.h (succ, ssucc, sssucc, pred, ppred, pppred): Declared.

	* txr.1: Documented.

2014-11-20  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (where): Argument order reversed, with compat support.

	* lib.h (where): Declaration updated.

	* txr.1: Documented.

2014-11-20  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (sel): Accept a function in place of the index list.

	* txr.1: Documented.

2014-11-17  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (split_str): If the separator string is empty,
	then unless opt_compat is 100 or less, provide a more
	consistent behavior, rather than splitting the string
	into characters. This latter behavior was never documented.

	* txr.1: Documented.

	* dep.mk: Updated.

2014-11-15  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (max2, min2): Use the less comparison function
	for generic semantics.

	* lib.h (max2, min2): Parameter names changed to avoid suggesting
	that the operands are numbers.

	* txr.1: Documentation for min and max updated.

2014-11-10  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (opip_s, oand_s, chain_s, chand_s): New global variables.
	(macro_form_p): Forward declaration added.
	(me_opip): New static function.
	(eval_init): Intern new symbols, register opip and oand macros
	to me_opip function. Use chain_s and chand_s in registration
	for chain and chand.

	* txr.1: Document opip and oand

	* tl.vim, txr.vim: Regenerated.

2014-11-06  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (sub, ref, refset, replace, update, search_list):
	Fix cut and paste problem: type_mismatch argument expression
	referring to the C function cons rather than the intended
	object seq.

2014-11-06  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register chand intrinsic.

	* lib.c (do_chand): New static function.
	(chandv): New function.

	* lib.h (chandv): Declared.

	* txr.1: Documented chand.

2014-11-06  Kaz Kylheku  <kaz@kylheku.com>

	Allow then-func to be omitted in iff. Cleanup.

	* eval.c (eval_init): Register iff as requiring only one arg.

	* lib.c (do_iff): Do not check thenfun for nil. Just call it.
	(iff): Default thenfun to identity.

	* txr.1: Documentation updated.

2014-11-05  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (iff): Bugfix: forgotten handling of default
	argument, resulting in : symbol being called as a function.

	* txr.1: Removing description of situation when the then-function
	argument of iff or iffi is specified as nil. This is deprecated
	behavior which can be obtained by using the false function.

2014-10-31  Kaz Kylheku  <kaz@kylheku.com>

	New macros tb and tc.

	* eval.c (me_tb, me_tc): New static functions.
	(eval_init): Registered tb and tc macros.

	* txr.1: Documented tb and tc.

2014-10-30  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (chk_grow_vec): New function.
	(string_extend): Use chk_grow_vec.
	(vec_set_length): Avoid subtractions for comparing numbers.

	* lib.h (chk_grow_vec): Declared.

	* stream.c (snarf_line, string_out_put_string): Use chk_grow_vec.

2014-10-30  Kaz Kylheku  <kaz@kylheku.com>

	Implementing finalization hooks.

	* gc.c (struct fin_reg): New struct type.
	(final_list, final_tail, mark_makefresh): New static variables.
	(mark_obj): Under generational GC, if make_makefresh is in
	effect, set the generation to -1 on all marked objects.
	(sweep_one): In an EXTRA_DEBUGGING  build, call breakpt
	if the object being swept is the one in break_obj.
	Under generational GC, place reachable objects that are
	in generation -1 the freshobj nursery and assign them to generation 0,
	rather than sticking them into the mature generation 1.
	(sweep): Under generational gc, reset the freshobj_idx variable
	here, so that sweep_one has an empty nursery in which
	to place the generation -1 objects.
	(prepare_finals, call_finals): New static functions.
	(gc): Call prepare_finals before sweep, and call call_finals
	just before re-enabling GC and returning. Do not reset freshobj_idx to
	zero; this was done in sweep, which may have added entries into it.
	(gc_finalize): New function.
	(gc_late_init): Register gc_finalize as intrinsic function finalize.

	* txr.1: Documented finalize.

	* HACKING: Documented finalization, described the additional
	meaning of the -1 generation, and added a section on debugging with
	break_obj and breakpt.

2014-10-30  Kaz Kylheku  <kaz@kylheku.com>

	* gc.h (break_obj): Missing extern added on declaration.
	This broke C++ compilation with -DEXTRA_DEBUGGING turned on.

2014-10-29  Kaz Kylheku  <kaz@kylheku.com>

	Vim syntax coloring for standalone TXR Lisp (*.tl) files.

	* genvim.txr (generate): New pattern function, contains
	generation logic so we can do it twice.

	* txr.vim: Regenerated.

	* tl.vim: New file.

2014-10-26  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (type_check): Function moved to header file inline.
	(throw_mismatch): New function.

	* lib.h (throw_mismatch): Declared.
	(type_mismatch): Declaration turned into inline function.

2014-10-25  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (hash_begin): Use coerce macro instead of raw C cast.
	Use cobj_handle so hash argument is validated.

	* parser.l (YY_INPUT): Use convert macro instead of raw C cast.

2014-10-24  Kaz Kylheku  <kaz@kylheku.com>

	GNU Flex's libfl library provides nothing.  Let us not refer to it. It
	only causes build issues on some systems where it is not provided
	in the standard location, or is not cross-compiled properly.

	* Makefile (LEXLIB): Reference to variable removed.

	* configure (lexlib): Variable removed.
	(LEXLIB): config.make variable not generated.

	* parser.l (yywrap): Provide this trivial function as inline.

2014-10-24  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: Removing trailing spaces.
	(GREP_CHECK): New macro.
	(enforce): Rewritten using GREP_CHECK, with new checks.

	* arith.c, combi.c, debug.c, eval.c, filter.c, gc.c, hash.c, lib.c,
	* lib.h, match.c, parser.l, parser.y, rand.c, regex.c, signal.c,
	* signal.h, stream.c, syslog.c, txr.c, unwind.c, utf8.c: Remove
	trailing spaces.

2014-10-22  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Fix incorrect, registration of
	repeat; it must have one optional argument.

2014-10-22  Kaz Kylheku  <kaz@kylheku.com>

	Version 100.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

2014-10-21  Kaz Kylheku  <kaz@kylheku.com>

	Ensure that a hash reorganization doesn't take place
	during a traversal, which could cause items to be visited
	twice or skipped.

	* gc.c (full_gc): Changed from static to exter (full_gc): Changed to
	internal linkage.

	* gc.h (full_gc): Declared.

	* hash.c (struct hash): New member, usecount.
	(struct hash_iter): New member, next.
	(reachable_iters): New static variable.
	(hash_mark): Reset the usecount of every reachable hash table.
	(hash_iter_mark): Add every reachable iterator to reachable_iters
	list.
	(make_hash, make_similar_hash, copy_hash): Initialize usecount.
	(gethash_c): Do not call hash_grow if usecount is nonzero.
	(hash_begin): Initialize next field of hash_iter to null.
	Increment use count on hash table.
	(hash_next): When traversal ends, release use count, and
	null out the hash table reference.
	(do_weak_tables): New static function.
	(do_iters): New static function.
	(hash_process_weak): Weak hash processing logic moved
	to do_weak_tables. Also calls do_iters.

	* txr.1: Describe hash table traversal, and the assurances
	and caveats about inserting and deleting items.

2014-10-21  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (interp_fun): If the function doesn't have
	specials, then don't bother saving and restoring dynamic
	env around the argument binding and evaluation.

2014-10-21  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register notf intrinsic function.

	* lib.c (do_not): New static function.
	(notf): New function.

	* lib.h (notf): Declared.

	* txr.1: Documented notf.

	* share/txr/stdlib/txr-case.txr (bindable): Eliminated.
	(txr-if): Use functional expression, taking advantage of notf.

	* txr.vim: Regenerated.

2014-10-21  Kaz Kylheku  <kaz@kylheku.com>

	* share/txr/stdlib/txr-case.txr: New file.

	* txr.1: Document txr-if, txr-when and txr-case.

	* genvim.txr: Added new macro names.

	* tests/011/txr-case.expected: New file.

	* tests/011/txr-case.txr: New file.

	* txr.vim: Regenerated.

2014-10-20  Kaz Kylheku  <kaz@kylheku.com>

	Source file inclusion implemented: needed for macros.

	* match.c (include_s): New symbol variable.
	(v_load): Function extended to handle include semantics.
	(include): External wrapper function for doing inclusion
	via v_load.
	(syms_init): include_s initialized.

	* match.h (include_s): Declared.
	(include): Declared.

	* parser.y (check_for_include): New static function.
	(clauses_rev): Use check_for_include to replace @(include ..)
	directive.

	* txr.1: Documented include.

	* genvim.txr: Added include symbol.

	* txr.vim: Regenerated.

2014-10-19  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (match_fun): Bugfix: replace incorrect plain return
	with debug_return. This causes a stray debug frame to be left
	on the environment stack which turns to garbage, leading to
	an invalid longjmp in another debug_return elsewhere
	which tries to use that frame. This was diagnosed by valgrind
	indicating accesses below the stack frame, and also by glibc
	"longjmp causes uninitialized stack frame" abort.

2014-10-19  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l (lisp_parse): Bugfix: the error_stream argument
	must be checked to be a stream before we plant it in place
	of std_error, otherwise we will get a type exception thrown
	lower down, which leads to runaway recursion as TXR tries
	to print the error messages on std_error.

	* dep.mk: Regenerated.

2014-10-19  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (r_exprs): New grammar symbol. r_exprs uses
	left-recursive rules to avoid filling the yacc stack, and
	returns the items in reverse order. The output of each
	r_exprs-generating rule consists of a list which gives
	the terminating atom, and then the list contents in reverse order.
	(n_exprs): Becomes wrapper for r_exprs which deals with
	the terminating atom, and reversed items.

2014-10-18  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y: Allow TXR to support large programs, and efficiently so.
	(clauses_rev): New grammar symbol. Uses a left-recursive rule that
	does not consume an amount of parser stack proportional to the number
	of clauses, and sticks to efficient consing, which means that
	the list is built up in reverse.
	(clauses): Now just a wrapper rule for clauses_rev which nreverses
	its output.
	(clauses_opt): Retargetted to use clauses_rev instead of clauses,
	and reverse its output.

2014-10-18  Kaz Kylheku  <kaz@kylheku.com>

	Deal with situation when GC is disabled and the freshobj array runs out
	of room.  This could happen when parsing a really large TXR program,
	since gc is disabled during parsing. Currently it asserts, which
	is not acceptable.

	* gc.c (make_obj): If after gc, the freshobj array has not been
	emptied (obviously because gc is disabled), do not assert.
	Rather, set the full_gc flag to request a full garbage collection
	when gc is re-enabled.  Furthermore, only place newly allocated objects
	into freshobj if full_gc has not been set. Thus, if we exhaust the
	freshobj array while gc is off, the full_gc flag is set, and we
	discontinue use of that array. When gc is re-enabled, we will do a full
	gc pass. A full gc pass ignores freshobj array, so it doesn't matter
	that its use was discontinued.

2014-10-18  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (mf_all): Drop data_lineno parameter. Initialize
	the corresponding member based on whether or not data is nil.
	(do_match_line, mf_from_ml, match_filter, match_fun, extract):
	Do not pass starting line number argument to mf_all.
	This fixes a bug when the line number at @(eof) for an empty
	file comes out as zero.
	(mf_args, v_skip, v_fuzz, v_next, v_gather, v_collect,
	open_data_source, match_files): Use zero and one instead of num(0) and
	num(1).

2014-10-17  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (v_eof): Bugfix: we are at EOF not only when
	the remaining data is nil but when it is (nil). This
	happens for interactive streams.

2014-10-17  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (dest_bind): Remove the restriction of not allowing
	@(expr ...) and @var on the left side of a bind. This
	is useful, and necessary for @(line @(lisp expr)) to work:
	matching computed line numbers and character positions.

	* txr.1: Document use of Lisp on left hand side of bind,
	that there is a restriction on the left hand side of a set,
	and that Lisp can be used in a line or chr directive for
	computed matches.

2014-10-17  Kaz Kylheku  <kaz@kylheku.com>

	* HACKING: New section Type Safety.
	Table of contents regenerated with line numbers.

	* HACKING-toc.txr: New file.

2014-10-17  Kaz Kylheku  <kaz@kylheku.com>

	Converting cast expressions to macros that are retargetted
	to C++ style casts when compiling as C++.

	* lib.h (strip_qual, convert, coerce): New casting macros.
	(TAG_MASK, tag, type, wli_noex, auto_str, static_str,
	litptr, num_fast, chr, lit_noex, nil, nao): Use cast macros.

	* arith.c (mul, isqrt_fixnum, bit): Use cast macros.

	* configure (INT_PTR_MAX): Define using cast macro.

	* debug.c (debug_init): Use cast macro.

	* eval.c (do_eval, expand_macro, reg_op, reg_mac, eval_init):
	Use cast macros.

	* filter.c (filter_init): Use cast macro.

	* gc.c (more, mark_obj, in_heap, mark, sweep_one, unmark): Use
	cast macros.

	* hash.c (hash_double, equal_hash, eql_hash, hash_equal_op,
	hash_hash_op, hash_print_op, hash_mark, make_hash, make_similar_hash,
	copy_hash, gethash_c, gethash, gethash_f, gethash_n, remhash,
	hash_count, get_hash_userdata, set_hash_userdata, hash_iter_destroy,
	hash_iter_mark, hash_begin, hash_uni, hash_diff, hash_isec): Use
	cast macros.

	* lib.c (code2type, chk_malloc, chk_malloc_gc_more, chk_calloc,
	chk_realloc, chk_strdup, num, c_num, string, mkstring, mkustring,
	upcase_str, downcase_str, string_extend, sub_str, cat_str, trim_str,
	c_chr, vector, vec_set_length, copy_vec, sub_vec, cat_vec,
	cobj_print_op, obj_init): Likewise.

	* match.c (do_match_line, hv_trampoline, match_files, dir_tables_init):
	Likewise.

	* parser.l (grammar): Likewise.

	* parser.y (parse): Likewise.

	* rand.c (make_state, make_random_state, random_fixnum, random):
	Likewise.

	* regex.c (CHAR_SET_L2_LO, CHAR_SET_L2_HI, CHAR_SET_L1_LO,
	CHAR_SET_L1_HI, CHAR_SET_L0_LO, CHAR_SET_L0_HI, L0_full, L0_fill_range,
	L1_full, L1_fill_range, L1_contains, L1_free, L2_full, L2_fill_range,
	L2_contains, L2_free, L3_fill_range, L3_contains, L3_free,
	char_set_create, char_set_cobj_destroy, nfa_state_accept,
	nfa_state_empty, nfa_state_single, nfa_state_wild, nfa_state_set,
	nfa_free, nfa_run, regex_destroy, regex_mark, dv_compile_regex,
	reg_derivative, regex_compile, regex_print, regex_run,
	regex_machine_init): Likewise.

	* signal.c (sig_mask): Likewise.

	* stream.c (make_null_stream, stdio_stream_print, stdio_stream_destroy,
	stdio_stream_mark, stdio_maybe_read_error, stdio_maybe_error,
	stdio_put_char_callback, stdio_get_char_callback, stdio_put_string,
	stdio_put_char, stdio_put_byte, stdio_flush, stdio_seek,
	stdio_get_prop, snarf_line, stdio_get_line, stdio_get_char,
	stdio_get_byte, stdio_unget_char, stdio_unget_byte, stdio_close,
	tail_strategy, pipe_close, string_in_stream_mark, string_in_get_line,
	string_in_get_char, string_in_unget_char, string_in_get_prop,
	byte_in_stream_destroy, byte_in_get_byte, byte_in_unget_byte,
	string_out_stream_destroy, string_out_byte_callback,
	string_out_byte_flush, string_out_put_string, string_out_put_char,
	string_out_put_byte, strlist_mark, strlist_out_put_string,
	strlist_out_put_char, make_strlist_output_stream, get_list_from_stream,
	dir_get_line, dir_close, make_stdio_stream_common, make_pipevp_stream,
	make_string_input_stream, make_string_byte_input_stream,
	make_string_output_stream, get_string_from_stream, make_dir_stream,
	stream_set_prop, stream_get_prop, close_stream, get_line, get_char,
	get_byte, unget_char, unget_byte, vformat, put_string, put_char,
	put_byte, flush_stream, seek_stream, open_tail, open_process, run,
	cat_stream_print, cat_get_line, cat_get_char, cat_get_byte,
	cat_unget_byte, cat_unget_char, cat_get_prop, cat_mark,
	make_catenated_stream): Likewise.

	* sysif.c (getcwd_wrap): Likewise.

	* syslog.c (syslog_mark, syslog_put_string, syslog_put_char,
	syslog_put_byte, syslog_get_prop, syslog_set_prop, make_syslog_stream):
	Likewise.

	* txr.c (get_self_path): Likewise.

	* unwind.c (uw_init): Likewise.

	* utf8.c (utf8_from_uc, utf8_to_uc, utf8_to, utf8_dup_from_uc,
	utf8_dup_from, utf8_dup_to, utf8_decode): Likewise.

2014-10-17  Kaz Kylheku  <kaz@kylheku.com>

	Purge stray occurrences of "void *" from code base.

	* lib.c (cobj_print_op): In the format call, cast
	the C pointer to val, since the ~p conversion now
	takes a val rather than void *.
	(cptr_equal_op, obj_print, obj_pprint): Remove cast to
	void *, since obj now already has the type that ~p expects.

	* lib.h (struct any): Use mem_t * instead of void *.

	* parser.h (yyscan_t): Repeat the definition from inside
	the Flex-generated lex.yy.c.
	(yylex_init, yylex_destroy, yyget_extra, yyset_extra): Re-declare
	using yyscan_t typedef in place of void *.

	* parser.l (yyget_column, yyerrprepf): Re-declare using yyscan_t.
	(grammar): Use yyg in place of yyscanner in calls to yyerrprepf.

	* parser.y (yylex, %lex-param): Use yyscan_t instead of void *.
	(parse): Use yyscan_t for local variable.

	* signal.c (stack): Change type from void * to mem_t *.

	* stream.c (vformat): Conversion specifier p extracts val
	instead of void *.
	(run): Use casts that only remove const, not all the way to void *.

	* txr.1: Documented p conversion specifier of format.

	* Makefile (OBJS-y): Initialize with := to make sure it is a
	simple variable, and not a macro.
	(SRCS): New variable, listing source files.
	(enforce): New rule for enforcing coding conventions.
	Currently checks for void * occurrences.

2014-10-16  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (gcd): Fix semantics. If either operand is
	zero, return the other operand.
	(lcm): New function.

	* eval.c (eval_init): Retarget registration of gcd to
	variable argument gcdv function. Register lcm.

	* lib.c (gcdv, lcmv): New functions.

	* lib.h (gcdv, lcm, lcmv): Declared.

	* txr.1: Re-document gcd with coverage of lcm.

	* txr.vim: Regenerated.

2014-10-16  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (gcd, lognot): Bugfix: bignum results
	in fixnum range not normalized.

2014-10-16  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (dest_bind): More detailed log message for variable
	mismatch.

2014-10-16  Kaz Kylheku  <kaz@kylheku.com>

	New @(line) and @(chr) directives.

	* match.c (line_s): New variable.
	(h_chr, v_line): New static functions.
	(syms_init): line_s initialized.
	(dir_tables_init): Register v_line and h_chr.

	* match.h (line_s): Declared.

	* txr.1: Document @(line) and @(chr) directives.

	* txr.vim: Regenerated.

2014-10-15  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (subst_vars): Fix buggy rendering of TXR Lisp expressions
	that evaluate to lists. For instance `@(list)` renders to the
	string "nil", and `@(list 1 2)` renders as "(1 2)". The desired
	behavior is "" and "1 2", respectively.
	(do_output_line): In output directives, there is a similar problem.
	A @(list) in the middle of an output block turns to nil, and
	a @(list 1 2) renders in parentheses as (1 2).  Furthermore,
	there is the additional problem that no filtering is applied
	to the interpolated value. These behaviors are subject to the
	compatibility option, since they change the externally visible
	behavior of TXR programs.

	* txr.1: Document that empty lists in @(output) variable substitutions
	turn into nothing. Document value of 100 for -C option, describing
	the above issue.

2014-10-14  Kaz Kylheku  <kaz@kylheku.com>

	More type safety, with help from C++ compiler.

	* parser.h (scanner_t): New typedef. Cleverly, we use
	yyguts_t as the basis for this, which pays off in
	a few places, getting rid of conversions.
	(parser_t): scanner member redeclared to scanner_t *.
	(yyerror, yyerr, yyerrof, end_of_regex, end_of_char):
	Declarations updated.

	* parser.l (yyerror, yyerrorf, num_esc): scanner argument becomes
	scanner_t * instead of void *.
	(yyscanner): Occurrences replaced by yyg: why should we
	refer to the type-unsafe void *yyscanner, when we know that
	in the middle of the yylex function we have the properly
	typed yyguts_t *yyg.
	(end_of_regex, end_of_char): Argument changes to scanner_t * and name
	strategically changes to yyg, eliminating the local variable and cast.

	* parser.y (sym_helper): scanner argument becomes
	scanner_t * instead of void *.
	(%parse-param}: void *scnr becomes scanner_t *scnr.
	(define-transform, yybadtoken): Use scanner_t * instead of void *.
	(parse): Since yylex_init takes a void **, we use it to initialize
	a local void *, and then assign it to the structure member.

2014-10-14  Kaz Kylheku  <kaz@kylheku.com>

	C++ upkeep.

	TXR's support for compiling as C++ pays off:  C++ compiler finds
	serious bugs introduced in August 2 ("Big switch to reentrant lexing
	and parsing"). The yyerror function was being misused; some of
	the calls reversed the scanner and parser arguments. Since one
	of the two parameters is void *, this reversal wasn't caught.

	* parser.l (yyerror): Fix first two arguments being
	reversed.
	(num_esc): Change previously correct call to yyerror to follow reversed
	arguments, so that it stays correct.

	* parser.y (%parse-param): Change order of these directives
	so that the scnr parameter is before the parser parameter.
	This causes the yacc-generated calls to yyerror to have
	the arguments in the correct order.  It also has the
	effect of changing the signature of yyparse, reversing its parameters.
	(parse): Update call to yyparse to new argument order.

	* parser.h (yyparse): Declaration removed.
	(yyerror): Declaration updated.

	* regex.c (regex_kind_t): New enum typedef.
	(struct regex): Use regex_kind_t rather than an enum
	inside the struct, which has different scoping rules
	under C++.

	* txr.c (get_self_path): Fix signed/unsigned warning.

2014-10-14  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Round of fixes.

2014-10-13  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register greater function as intrinsic.

	* lib.c (gt_f, lt_f): Global variables removed.
	(greater_f): New variable.
	(greater): New function.
	(find_max, pos_max): Use greater_f as default for testfun,
	rather than gt_f.
	(find_min, pos_min): Use less_f as default for testfun,
	rather than lt_f.
	(obj_init): Remove references to gt_f and lt_f.
	GC-protect and initialize greater_f.

	* lib.h (greater_f): Declared.
	(gt_f, lt_f): Declarations removed.

	* txr.1: Documented greater, and use of less and greater
	in pos-min, pos-max, find-min and find-max.

	* txr.vim: Regenerated.

2014-10-13  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr (sortuniq): Remove unnecessary function,
	since (sortuniq list) can be done as (sort (uniq list)).

2014-10-12  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (merge_wrap): New static function
	(eval_init): Register less as intrinsic.  Retarget merge intrinsic to
	merge_wrap for proper argument defaulting which is missing from merge,
	and which we don't want to introduce there since internal calls
	to merge don't erquire it. Change registration of sort so it has
	only one required argument, not two.

	* lib.c (less_f): New global variable.
	(less_tab): New static array.
	(less_tab_init): New static function.
	(less): New function.
	(sort): Default lessfun argument to the less function.
	(obj_init): GC-protect the less_f variable.
	Initialize it with a function object made from the less function.
	(init): Call less_tab_init.

	* lib.h (enum type): New enumeration member MAX_TYPE, an alias
	for the largest type.
	(less_f, less): Declared.

	* txr.1: Documented new less function, and that the lessfun
	argument in sort and merge is optional, defaulting to less.

	* txr.vim: Regenerated.

2014-10-11  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register chr_isblank and chr_isunisp as
	intrinsics.

	* lib.c (chr_isblank, chr_isunisp): New functions.

	* lib.h (chr_isblank, chr_isunisp): Declared.

	* regex.h (spaces): Declaration for existing variable added.

	* txr.1: Documented chr-isblank and chr-isunisp.

	* genvim.txr: Add missing sysif.c.

	* txr.vim: Regenerated.

2014-10-09  Kaz Kylheku  <kaz@kylheku.com>

	Fix gc safety issue in abs_path_p function.

	* stream.c (ap_regex): New static variable.
	(abs_path_p): Remove local reg variable; replace
	uses of reg with ap_regex.
	(stream_init): gc-protect ap_regex.

2014-10-09  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (stream_init): No need to gc-protect
	std_input, std_output, std_debug, std_error and std_null.  These are
	not ordinary variables but macros which expand to locations in the
	variable binding environment that are already protected.  This call was
	actually doing nothing, because the symbol involved in the expression
	std_input is not  yet initialized and so &std_input yields a null
	pointer which causes protect to bail.

2014-10-08  Kaz Kylheku  <kaz@kylheku.com>

	Moving system interface functions to separate module out of
	the eval and stream modules.

	* Makefile (OBJS): Add sysif.o.

	* dep.mk: Regenerated.

	* eval.c (errno_wrap, daemon_wrap, exit_wrap, usleep_wrap, getpid_wrap,
	getppid_wrap, env_hash): Functions moved to sysif.c and changed
	to static functions.
	(eval_init): Registrations of functions moved to sysif.c.

	* lib.c (init): Call sysif_init.

	* stream.c (w_stat, statf, mkdir_wrap, chdir_wrap, getcwd_wrap,
	makedev_wrap, minor_wrap, major_wrap, mknod_wrap): Functions
	moved to sysif.c and become static functions.
	(stream_init): Registration of stat moved to sysif.c.
	(open_files, open_files_star): Bugfix: no longer erroneously included
	in #ifdef HAVE_UNISTD_H block.

	* stream.h (mkdir_wrap, chdir_wrap, getcwd_wrap, makedev_wrap,
	minor_wrap, major_wrap, mknod_wrap, symlink_wrap, link_wrap,
	readlink_wrap): Declarations removed.

	* sysif.c: New file.

	* sysif.h: New file.

2014-10-08  Kaz Kylheku  <kaz@kylheku.com>

	Add test case for recent breakage.

	* tests/006/freeform-3.expected: New file.

	* tests/006/freeform-3.txr: New file.

	* tests/006/passwd: New file.

	* Makefile (TXR_ARGS): Set up for new test case.

2014-10-08  Kaz Kylheku  <kaz@kylheku.com>

	Fix 2011-12-03 regression. The freeform directive code
	relies on lazy_str_get_trailing_list and the behavior
	of that function changed because (split-str "" any-separator)
	changed from returning nil to returning the empty string.
	The resulting behavior change of lazy_str_get_trailing_list was later
	described in the documentation, thereby codifying it.

	This patch changes the lazy_str_get_trailing_list behavior,
	which is poor, and causes infinite looping. We do not want
	an extra empty string prepended, because it looks like
	a spurious line.

	* lib.c (lazy_str_get_trailing_list): if split_str produces
	a the list (""), then just return the unmaterialized list from
	the lazy string without prepending that one-element list to it.

	* txr.1: Updated documentation for lazy-str-get-trailing-list.

2014-10-05  Kaz Kylheku  <kaz@kylheku.com>

	Version 99.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

	* Makefile: Improve binary packaging rules.

	* regex.c: #include <stdarg.h> added.

2014-10-04  Kaz Kylheku  <kaz@kylheku.com>

	Printing of regular expression objects implemented.

	* regex.c (regex_print): New static function.
	(regex_obj_ops): Registered regex_print.  (print_class_char,
	paren_print_rec, print_rec): New static functions.

	* dep.mk: Regenerated.

2014-10-04  Kaz Kylheku  <kaz@kylheku.com>

	Keep regex source code in regex objects, in anticipation
	of pretty-printing. Fix object construction bugs.

	* regex.c (struct regex): New member, source.
	(regex_mark): Ensure source is visited by garbage collector.
	(regex_compile): Store regex_sexp in source.
	Fix violations of section 3.2 of HACKING document.

2014-10-03  Kaz Kylheku  <kaz@kylheku.com>

	Eliminating the extra list wrapping applied to regular
	expression objects in the syntax tree. The parser
	just puts out a #<regex ...> instead of (#<regex ...> regex-syntax).

	* eval.c (do_eval): We no longer need the hack of
	treating (#<regex> ...) as a special form which
	evaluates to #<regex>.
	(expand): We no longer have to skip over regex syntax,
	so the case is removed.

	* match.c (h_var, do_txeval, do_match_line): regexp cases are no longer
	subcases of consp but stand on their own. In do_match_line, we
	introduce a COBJ case into the type switch for regexes.

	* parser.y: regexes are now compiled in the regex and lisp_regex
	grammar rules instead of the dependent rules, and are not wrapped in
	extra syntax.

2014-10-03  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (h_var): Fix regression introduced in 2014-08-11
	commit. The incompleteness of that change broke the case of an unbound
	variable followed by a bound variable. The value of the
	second variable was still being wrapped in the old complicated
	representation before being pushed to the front of the spec.

	* txr.1: Replace bogus text which says that variables are not
	bound to regexes, and so regex matches from variable substitutions
	do not arise. This works fine after this change.

2014-10-03  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: rules that rely on values from config.make
	now have config.make as a prerequisite.

2014-10-02  Kaz Kylheku  <kaz@kylheku.com>

	Using unified COBJ representation for both regex kinds,
	rather than the list-based notation for derivative-based
	regexes, and an encapsulated COBJ for NFA-based regexes.

	* lib.c (compiled_regex_s): Variable removed.
	(obj_init): Initialization of compiled_regex_s removed.

	* lib.h (compiled_regex_s): Declaration removed.

	* regex.c (struct regex, regex_t): New type.
	(regex_destroy): Object is now a regex_t, not nfa_t.
	(regex_mark): New function.
	(regex_obj_ops): Register regex_mark operation.
	(reg_nullable, reg_derivative): Remove cases that handles
	compiled_regex_s.
	(regex_compile): Output of dv_compile_regex becomes
	a cobj nwo. Output of nfa_compile_regex must be
	embedded in regex_t structure.
	(regexp): Drop the check for compiles_regex_s.
	(regex_nfa): Function removed.
	(regex_run, regex_machine_init): Use cobj_handle to retrieve regex_t *
	pointer and dispatch appropriate code based on regex->kind.

2014-09-30  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr: Add PayPal donation button.

	* txr.1: Avoid escapes at the end of a line; man2html doesn't
	handle this properly.

2014-09-30  Kaz Kylheku  <kaz@kylheku.com>

	* genman.txr: TXR is now bolded in the title.

	* txr.1: More formatting and wording fixes.

2014-09-26  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (do_and): Fix andf again: (andf) not producing
	a function that returns t, as documented.

2014-09-26  Kaz Kylheku  <kaz@kylheku.com>

	Version 98.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

	* dep.mk, txr.vim: Regenerated.

2014-09-26  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Substantially revised with rich troff markup,
	and restructured in some places.

	* genman.txr: No longer generate the whole document in
	monospaced font. Add hyperlinks.

2014-09-25  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (do_and, do_or): Fix broken andf and orf,
	lacking the semantics of returning the last value,
	or the first true value, respectively.

2014-09-22  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (txr-manpage.pdf): New target.

2014-09-10  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (compat_fixup): void return changed to int.
	Returns minimum supported emulation.

	* lib.h (compat_fixup): Declaration fixed.

	* txr.c (compat): Replace hard-coded min version
	by return value of compat_fixup.

2014-09-09  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (help): List new --compat option.
	(requires_arg, do_fixnum_opt, compat, array_dim, gc_delta): New static
	functions.
	(txr_main): Use do_fixnum_opt for handling options with integer
	argument. Add --compat alias for -C.

	* txr.1: Documented --compat. Added missing description of --debugger.

2014-09-09  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (txr_main): Cleaning up option handling code.
	Better checking for misused long options.

2014-09-09  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register intrinsic partition* function.

	* lib.c (partition_star_func): New static function.
	(partition_star): New function.

	* lib.h (partition_star): Declared.

	* txr.1: Documented partition*.

2014-09-09  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register intrinsic partition function.

	* lib.c (partition_func): New static function.
	(partition): New function.

	* lib.h (partition): Declared.

	* txr.1: Documented partition.

2014-09-09  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (help): Revised help text.

2014-09-08  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (MALLOC_DELTA_THRESH): Macro remaned to DFL_MALLOC_DELTA_THRESH.
	(opt_gc_delta): New global variable.
	(make_obj): Use opt_gc_delta rather than MALLOC_DELTA_THRESH.
	(gc_set_delta, gc_wrap): New static functions.
	(gc_late_init): New function.

	* gc.h (gc_late_init): Declared.

	* genvim.txr: scan gc.c also.

	* lib.c (init): call gc_late_init.

	* txr.1: Document new --gc-delta option and the functions
	gc and gc-set-delta.

	* txr.c (help): Help text for --gc-delta.
	(txr_main): Parse --gc-delta option.

	* txr.h (opt_gc_delta): Declared.

2014-09-06  Kaz Kylheku  <kaz@kylheku.com>

	Make the garbage collector aware of malloced bytes, to
	prevent skyrocketing memory use when the program manipulates
	heap objects that have large amounts of malloc memory
	attached, like very large bignums.

	* gc.c (MALLOC_DELTA_THRESH): New preprocessor symbol.
	(prev_malloc_bytes): New static variable.
	(make_obj): when the value of malloc_bytes jumps by MALLOC_DELTA_THRESH
	or more since the last gc, trigger gc.

2014-09-03  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (symbol_setname): New static function.
	(obj_init): Change exception symbol names with underscores
	to use friendly dashes instead.
	(compat_fixup): New function.

	* lib.h (compat_fixup): Declared.

	* txr.1: Change occurrences of exception symbols from
	underscores to dashes.

	* txr.c (txr_main): Call compat_fixup when -C option
	is processed.

2014-09-02  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Document -C option.

	* txr.c (opt_compat): New global variable.
	(help): Describe -C option.
	(txr_main): Process -C, and set opt_compat.
	Ensure -C does not clump.

	* txr.h (opt_compat): Declared.

2014-09-02  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Update registration of lisp-parse and read
	to account for new parameter.

	* lib.c (syntax_error_s): New symbol_variable.
	(obj_init): New symbol variable initialized.

	* lib.h (syntax_error_s): Declared.

	* parser.h (lisp_parse): Declaration updated.

	* parser.l (lisp_parse): Takes third parameter.

	* txr.1: Third parameter of read described.

	* txr.c (txr_main): Pass colon_k to third parameter of lisp_parse
	to obtain exception throwing behavior.

	* unwind.c (uw_init): Register syntax-error as subtype of error.

2014-09-02  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (arith_init): Register some variables: *flo-dig*,
	*flo-min*, *flo-max*, *flo-epsilon*, *pi* and *e*.

	* genvim.txr: Include arith.c in scan for symbols.

	* lib.c (init): arith_init() must now be called after eval_init().

	* txr.1: Documented new variables..

	* txr.vim: Updated.

2014-08-29  Kaz Kylheku  <kaz@kylheku.com>

	Version 97.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

	* dep.mk: Regenerated.

2014-08-29  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand_quasi): Regression: fix broken handling
	of @{var mod} syntax triggering a bogus assertion. Mods are the third
	element in the abstract syntax now, not fourth. There is no next link.
	Removing bogus comment referring to a nonexistent function.

2014-08-29  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (v_load): Fix regression introduced in 94: broken @(load).

2014-08-25  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (top): Renamed to gc_prot_top, turned extern.
	(prot1, rel1, mark): Follow rename.

	* gc.h (gc_prot_top): Declared.

	* signal.h (extended_jmp_buf): New member, gc_pt.
	(extended_setjmp): Save and restore gc_prot_top.

2014-08-25  Kaz Kylheku  <kaz@kylheku.com>

	GC correctness fixes: make sure we pin down objects for which we borrow
	low level C pointers, while we execute code that can cons memory.

	* lib.c (list_str): Protect the str argument.
	(int_str): Likewise.

	* regex.c (search_regex): protect the haystack string,
	while using the h pointer to its data, since regex_run
	can use the derivative-based engine which conses.

	* stream.c (vformat_str): Protect str argument, since
	put_char might conceivably cons.
	(vformat): Protect fmtstr.

2014-08-14  Kaz Kylheku  <kaz@kylheku.com>

	Version 96.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

	* txr.vim: Regenerated.

2014-08-13  Kaz Kylheku  <kaz@kylheku.com>

	Uprooting stupidities in handling of output variables.

	* parser.y (o_elems_transform): Remove useless function which
	was only unwrapping the strange parse of output vars.
	(o_elems_opt, rep_elem, quasilit, wordsqlit): Eliminate
	o_elems_transform call.
	(o_var, q_var): Eliminate the phrase structure rules which
	match an extra o_elem or quasi_item, and which incorporate
	them into the var syntax tree element. Place the modifiers
	into the third position, not fourth.

	* eval.c (subst_vars): Eliminate handling of "pat"
	element. Actually that was not even there thanks to
	o_elems_transform being applied: dead code. Pull modifiers
	from the third element of the var form now, not fourth.

	* match.c (subst_vars): Similar changes as in the match.c
	subst_vars function. Here the pat variable is even more obviously
	useless; if it is not nil, it is just punted back to the spec.

2014-08-13  Kaz Kylheku  <kaz@kylheku.com>

	Fix regression in previous change: we must match a compound text
	element whole, and not break it up.

	* match.c (search_match): Take a spec argument.
	(h_var): Turn a text element into a one-element spec and process
	with search_match.

	* txr.1: Updated text about matching of variables
	followed by a directive or function, and about consecutive
	variables via directive.

2014-08-12  Kaz Kylheku  <kaz@kylheku.com>

	When a variable is delimited by some form other than
	the contents of a variable, fixed string or regex, we now
	use the entire tail of the specline to find the match.
	So for instance @var@(trailer)foo works as intuition
	might expect.

	* match.c (search_form): Static function removed.
	(search_match): New static function based on search_form.
	Does not handle regexes, and does not update c->bindings.
	(h_var): Renamed local variable pat to next. Added a few
	missing rlcp's. Combined the cases when pat is a cons to
	one block so consp isn't repeatedly tested. Function now
	handles a var followed by (sys:text ...) elements specially;
	the first element of the text block is pulled out and
	matched. Implemented "var delimiting spec" general case
	which matches the entire tail of the spec at successive
	character positions until a match is found, and the skipped
	text goes into the variable.

2014-08-11  Kaz Kylheku  <kaz@kylheku.com>

	First cut at restructuring how variable matching works in the pattern
	language. The goal is to remove the strict behavior of using only one
	element of context after a variable.
	variable form at parse time: we unravel that first.

	* parser.y (grammar): Simplifying the phrase structure
	rule for the var element. All the variants that have
	a trailing elem are removed. The abstract syntax
	changes; the modifier moves to the third position in the
	list.

	* match.c (h_var): Matching change: the element which follows
	a variable is now pulled from the specline rather than the variable
	syntax, which is how it should have been done in the first place. The
	modifiers are pulled from a different spot in the variable syntax.

2014-08-09  Kaz Kylheku  <kaz@kylheku.com>

	* filter.c (filter_init): Expose the trie-lookup-begin,
	trie-value-at and trie-lookup-feed-char functions as intrinsics.

	* txr.1: Document exposed functions.

2014-08-08  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: ret operator does not generate functions
	that take any number of arguments.

	* eval.c (me_ret): Generate (op identity (progn @rest <expr>))
	rather than of (op identity <expr>).

	* txr.1: Update misleading equivalence.

2014-08-07  Kaz Kylheku  <kaz@kylheku.com>

	Version 95.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

2014-08-07  Kaz Kylheku  <kaz@kylheku.com>

	No getppid on MinGW.

	* configure: Add test for getppid.

	* eval.c (getppid_wrap, eval_init): use HAVE_GETPPID

2014-08-07  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l (yyerr): Function removed; it is not used in the lexer,
	and converted to a macro in the parser.

	* parser.y (define_transform): take a parser argument rather
	than scanner. Set up scnr local variable for yyerr macro.
	Remove scnr argument from macro calls.
	(yyerr): New macro.
	(grammar): Remove scnr argument from yyerr calls.

2014-08-07  Kaz Kylheku  <kaz@kylheku.com>

	Reentrant parser regression

	* parser.y (yybadtok): New macro.
	(yybadtoken): Function must take parser argument.
	(grammar): Replace uses of yybadtoken with yybadtok.

	* parser.h (yybadtoken): Declaration updated.

	* parser.l (grammar): Fix incorrect yyprepf calls
	that are missing the yyscanner parameter.

2014-08-05  Kaz Kylheku  <kaz@kylheku.com>

	Version 94.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

	* txr.vim, dep.mk: Updated.

2014-08-05  Kaz Kylheku  <kaz@kylheku.com>

	* rand.c (make_random_state): Make the seeding behavior
	portable when the seed is a fixnum or bignum. The goal is that the same
	values of seed should produce the same random sequences on any
	platform.

2014-08-05  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Fix incorrect registration of
	random-fixnum, which doesn't allow it to be called
	with no arguments.

2014-08-05  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y: Back port from Berkeley Yacc to GNU Bison.
	We need a prototype of yylex that is in scope of the grammar,
	but YYSTYPE is not defined there.

	* parser.l: Bison 3 declares yyparse in y.tab.h, so we have to
	reorder some #includes.

2014-08-02  Kaz Kylheku  <kaz@kylheku.com>

	Big switch to reentrant lexing and parsing.

	* parser.l (YY_INPUT): Stop relying on removed yyin_stream;
	refer to stream via yyextra.
	(yyin_stream, lineno, errors, spec_file_str,
	prepared_error_message): Global variables removed.
	(yyget_column, yyset_column): Missing prototypes not generated by flex
	in bison bridge mode have to be added by us to avoid
	warning.
	(yyerror): Takes parser and scanner as parameters.  Prepared error
	message is now in the parser context.  Calls to other error handling
	functions receive scanner context.
	(yyerr): New function.
	(yyerrorf, yyerrprepf): Takes scanner argument, chases extra data to
	get to parser, and refers to parser variables instead of globals.
	(num_esc): Scanner argument added.
	(%option reentrant, %option bison-bridge, %option extra-type): New
	flex options.
	(grammar): yyscanner added everywhere.
	(end_of_char): Takes scanner argument.
	(parse_init): Removed references to yyin_stream and
	prepared_error_message.
	(parse_reset): Function renamed to open_txr_file. Returns
	results via pointers instead of setting global variables.
	(regex_parse, lisp_parse): Use reentrant parser interface.

	* parser.y (yyerror): Prototype removed.
	(yylex): Prototype moved after grammar, with new arguments.
	(sym_helper, define_transform): Take scanner argument.
	(make_expr): Takes parser argument.
	(rlrec): New static function.
	(rl): Function turned into macro.
	(mkexp, symhlpr): New macros.
	(%purse-parser, %parse-param, %lex-param): New Yacc options.
	(grammar): Actions re-worked for reentrance. Parser and scanner
	contexts are passed down to helper functions, in some cases
	via the three new macros. The result of the parse is stored
	in the syntax_tree member of the parser_t structure instead
	of a global. The yylex function receives the scanner instance.
	(get_spec): Function removed.
	(parse): New function.

	* parser.h (lineno, errors, yyin_stream, spec_file_str):
	Declarations removed.
	(parser_t): New struct.
	(yyerr): New function declared.
	(yyparse, yyerror, yyerrorf, end_of_regex, end_of_char,
	yylex, yylex_destroy): Declarations updated.
	(yylex_init, yyget_extra, yyset_extra): Declared.
	(parse_reset, rl): Declaration removed.
	(open_txr_file): Declaration added.
	(parse): New function.

	* match.c (v_load): Use new reentrant parser interface.

	* txr.c (txr_main): Stop using parser-related global variables;
	call parser using new reentrant interface.

2014-08-02  Kaz Kylheku  <kaz@kylheku.com>

	* signal.c (interrupt_count): New global variable.
	(sig_handler): Increment and decrement interrupt count.
	If the interrupt count is already positive, treat
	that as if async signals were not enabled: do not
	invoke handlers.

2014-08-01  Kaz Kylheku  <kaz@kylheku.com>

	* configure (have_sys_time): New variable.
	Added check for setitimer/getitimer which also
	checks for <sys/time.h>.

	* signal.c (sig_init): Register itimer-real, itimer-virtual,
	itimer-prof variables and getitimer and setitimer functions.
	(tv_to_usec): New static function.
	(getitimer_wrap, setitimer_wrap): New functions.

	* signal.h (getitimer_wrap, setitimer_wrap): Declared.

	* txr.1: Documented itimers.

2014-08-01  Kaz Kylheku  <kaz@kylheku.com>

	* signal.c (set_sig_handler): Don't use SA_ONSTACK
	except for signals for which we use alt stack.

	* signal.h (sig_save_enable): Do sig_check before
	enabling async signals. This caused the !async_sig_enabled assertion
	to trip inside make_obj.

2014-08-01  Kaz Kylheku  <kaz@kylheku.com>

	* signal.c (sig_hup, sig_int, sig_quit, sig_ill, sig_trap, sig_abrt,
	sig_bus, sig_fpe, sig_kill, sig_usr1, sig_segv, sig_usr2, sig_pipe,
	sig_alrm, sig_term, sig_chld, sig_cont, sig_stop, sig_tstp, sig_ttin,
	sig_ttou, sig_urg, sig_xcpu, sig_xfsz, sigtalrm, sig_prof, sig_poll,
	sig_sys, sig_winch, sig_iot, sig_stkflt, sig_io, sig_lost, sig_pwr):
	Remove unused global variables variables.

	* signal.h: Remove declarations thereof.

2014-07-30  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (getpid_wrap, getppid_wrap): New static functions.
	(eval_init): Registered getpid and getppid intrinsics.

	* signal.c (kill_wrap): New static function.
	(sig-init): Registered kill intrinsic function.

	* txr.1: Documented getpid, gettpid and kill.

2014-07-30  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l: Allow unquotes and splices in QSPECIAL and BRACED states.

	* parser.y (quasi_item): Support splices as items.

	* genvim.txr: Syntax highlighting support for unquotes in
	quasiliterals.

	* txr.vim: Updated.

2014-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register uniq function.

	* lib.c (uniq): New function.

	* lib.h (uniq): Declared.

	* txr.1: Documented uniq.

2014-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (repeatv): Renamed to repeat. Turned into function
	with one optional argument, reflecting existing behavior.
	(eval_init): Registration of repeat updated.

	* txr.1: Fixed incorrect documentation which falsely suggests
	that repeat takes multiple lists, and doesn't mention
	the optional count.

2014-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (plus, minus, mul): Fix missing breaks
	to switch statements, leading to strange error
	messages when wrong types are passed in.

2014-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register nconc as intrinsic.

	* lib.c (nconcv): New function.

	* lib.h (nconcv): Declared.

	* txr.1: Documented nconc.

2014-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (reduce_left, reduce_right): Nullify incoming sequence
	argument so empty vectors and strings can be processed.

2014-07-29  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (giterate_func, giterate): Adjusting semantics of giterate to
	include seed item in the sequence. The while test is applied to
	each item before it is passed through the function. Also,
	eliminated useless rplacd operation.

	* txr.1: Updated documentation of giterate.

2014-07-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register partition-by intrinsic.

	* lib.c (partition_by_func): New static function.
	(partition_by): New function.

	* lib.h (partition_by): Declared.

	* txr.1: Documented partition-by.

2014-07-28  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (rising_product): Fix wrong m == n case,
	which breaks the n_perm_k function for k == 1.

	* txr.1: Fix typo: n-choose-k written in place of n-perm-k.

2014-07-27  Kaz Kylheku  <kaz@kylheku.com>

	Fix 2014-02-05 safety regression: unchecked use of non-function objects
	in some contexts that require functions.

	* lib.c (funcall, funcall1, funcall2, funcall3, funcall4):
	check type(fun) before dereferencing to see whether there
	are optional args.

2014-07-27  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (giterate_func, giterate): New static functions.
	(eval_init): Registered giterate as intrinsic.

	* txr.1: Documented giterate.

2014-07-26  Kaz Kylheku  <kaz@kylheku.com>

	* unwind.h (uw_block_begin): Get rid of the unused typedef trick,
	replace with do { } while (0), since we don't have any instances of a
	uw_block_begin followed by declarations.
	(uw_catch_begin): Move SYMVAR and EXCVAR inside the do/while block,
	so that the expansion doesn't begin with a declaration.

2014-07-23  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile, arith.c, arith.h, combi.c, combi.h, configure, debug.c,
	debug.h, eval.c, eval.h, filter.c, filter.h, gc.c, gc.h, hash.c,
	hash.h, lib.c, lib.h, match.c, match.h, parser.h, parser.l, parser.y,
	rand.c, rand.h, regex.c, regex.h, signal.c, signal.h, stream.c,
	stream.h, syslog.c, syslog.h, txr.c, txr.h, unwind.c, unwind.h,
	utf8.c, utf8.h: Synchronize license header with LICENSE.

2014-07-22  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (subst_vars): Bugfix: I neglected to apply the
	filter which is in effect to the result of interpolating a TXR Lisp
	expression, oops!

2014-07-22  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (METANUM): Forgotten %right declaration for this
	token has been resulting in a shift-reduce conflict.

2014-07-22  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Add a check, in the case that we cannot make an
	executable, whether this is due to being required to use C99.
	For instance, the Solaris environment requires compilation
	using the C99 dialect if _XOPEN_SOURCE is set to 600 or higher.

	* debug.c: When compiling as C99, we have to obey the special
	C99 conventions for instantiating inline functions.

	* hash.c: Likewise.

	* lib.c: Likewise.

	* parser.y: Likewise.

	* unwind.c: Likewise.

2014-07-21  Kaz Kylheku  <kaz@kylheku.com>

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

	* arith.c (log2): Change to static.

2014-07-22  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (me_case): Fix quoting issue in expansion.

2014-07-20  Kaz Kylheku  <kaz@kylheku.com>

	* signal.c (set_sig_handler): Set up and tear down alternate
	stack for SIGBUS also, not only for SIGSEGV. On Linux,
	when stack growth collides with another memory mapping,
	it triggers a SIGBUS not SIGSEGV, which occurs when the
	process limit on stack size is exceeded. In either
	situation, we need an alternative stack.

2014-07-20  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (caseq_s, caseql_s, casequal_s, memq_s, memql_s, memqual_s,
	eq_s, eql_s, equal_s): New symbol variables.
	(me_case): New static function.
	(eval_init): Initialize new variables. Register caseq, caseql and
	casequal macros.
	Re-register memq, memql, memqual, eq, eql and equal using
	new symbol variables.

	* txr.1: Document case, caseql and casequal.

2014-07-20  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register juxt as intrinsic.

	* lib.c (do_juxt): New static function.
	(juxtv): New function.

	* lib.h (juxtv): Declared.

	* txr.1: Documented juxt.

2014-07-20  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (divi): Support one-argument form.
	Use "/" name in error reporting, not "divi".

	* eval.c (eval_init): Change registration of / so only
	one argument is required out of two.

	* txr.1: Document one-argument division.

2014-07-20  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Fixed highlighting issues in numbers followed by newline.

	* txr.vim: Regenerated.

2014-07-19  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (search_str): Support negative starting index.
	Hoist uselessly repeated c_str operation out of loop.

	* txr.1: Document negative starting index for search-str.

2014-07-19  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (hash_construct): Nullify the pairs argument so that
	it works correctly with an empty vector.

	* txr.1: Write missing documentation for hash-construct.

2014-07-19  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (mapdov): New function.
	(eval_init): Register mapdo intrinsic.

	* lib.c (mapdo): New function.

	* lib.h (mapdo): Declared.

	* txr.1: Documented mapdo.  Documented zero-argument case
	for mapcar, mapcar*, mappend and mappend*.

2014-07-19  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (put_strings, put_lines): New functions.
	(stream_init): Registered new functions as intrinsics.

	* stream.h (put_strings, put_lines): Declared.

	* txr.1: Documented.

2014-07-19  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register get-lines as a synonym for lazy-stream-cons.

	* stream.c (get_string): New function.

	* stream.h (get_string): Declared.
	(stream_init): get_string registered as get-string intrinsic.

	* txr.1: Documented get-string, and get-lines as a synonym for
	lazy-stream-cons.  Documented the behavioral difference of
	lazy-stream-cons lazy lists for real-time and non-real-time streams.

2014-07-18  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (conftest, conftest2): Link math
	library so we can test for math functions.

	* arith.c (log2_init): New static function.
	(log2, logtwo): New functions.
	(l2): New static variable.
	(arith_init): Call log2_init.

	* configure (lang_flags): Switching _XOPEN_SOURCE
	from 500 to 600 to reveal log2.
	Adding test for log2.

	* eval.c (eval_init): Register log2 intrinsic.

	* lib.h (logtwo): Declared.

	* txr.1: Documented log2.

2014-07-15  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (v_do, v_require): Set up and tear down environment frame,
	like other situations that evaluate TXR Lisp from the pattern language.
	Otherwise obscure things will go wrong.
	(h_do): Same as above, and additionally, add the forgotten
	call to install the bindings into the match context.

2014-07-15  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (h_eol): Fix broken horizontal @(eol).
	It should be returning next_spec_k, rather
	than bindings, which indicate a complete match.

2014-07-15  Kaz Kylheku  <kaz@kylheku.com>

	* tests/001/query-1.txr: Remove bogus public domain header.

	* tests/001/query-2.txr: Likewise.

	* tests/001/query-3.txr: Likewise.

	* tests/001/query-4.txr: Likewise.

	* tests/002/query-1.txr: Likewise.

2014-07-15  Kaz Kylheku  <kaz@kylheku.com>

	Fix old, known syntax highlighting problems between symbols,
	integers and floating literals.

	* genvin.txr (txr_num): The general solution is to over-match
	a number by one character: a non-token constituent, and then
	subtract that from the highlight region using me=e-1.
	This solves the prefix ambiguities between numbers and symbols.
	(txr_badnum): New match: matches floating literals with trailing
	junk, which are highlighted as errors.
	(txr_directive, txr_list, txr_bracket, txr_mlist, txr_mbracket):
	All of these contain a txr_badnum.

	* txr.vim: Regenerated.

2014-07-15  Kaz Kylheku  <kaz@kylheku.com>

	Fix broken regex highlighting.

	* genvim.txr (txl_regex): Missing syntactic region added.
	(txr_regex): Start pattern is just a slash; no optional # in front.

	* txr.vim: Regenerated.

2014-07-14  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (txr_main): Allow Lisp code executed via -e and -p options to
	see the bindings set up by prior -D options.

2014-07-14  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register interpose and lconsp as intrinsics.

	* lib.c (lconsp, interpose): New functions.
	(lazy_interpose_func, lazy_interpose): New static functions.

	* lib.h (lconsp, interpose): Declared.

	* txr.1: Documented lconsp and interpose.

2014-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Version 92.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* share/txr/stdlib/ver.txr: Likewise

2014-07-10  Kaz Kylheku  <kaz@kylheku.com>

	* tests/011/macros-2.txr: Added test for labels shadowing macro,
	and let shadowing symacro.

	* tests/011/macros-2.expected: Regenerated

	* txr.vim: Regenerated.

2014-07-10  Kaz Kylheku  <kaz@kylheku.com>

	Implementing local function binding constructs.

	* eval.c (fbind_s, lbind_s, flet_s, labels_s): New symbol globals.
	(env_fb_to_fb): New static function.
	(lookup_mac): Implement the same shadow check for function macros
	that is done for symbol macros, because we now have local functions
	that can shadow local macros.
	(fbindings_helper, op_fbind, make_fun_shadowing_env,
	expand_fbind_vars, me_flet_labels): New static functions.
	(expand): Add cases for fbind and lbind.
	(eval_init): Intern the four new symbols.
	Register sys:fbind and sys:lbind operators.
	Register flet and labels macros.

	* txr.1: Documented flet and labels.

2014-07-08  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bindings_helper): New parameter to indicate that
	the caller needs the return value, so the function
	can avoid consing up a list that will be thrown away.
	(op_let): Pass nil argument to new parameter of bindings_helper.
	(op_each, op_for): Pass t to indicate that the return value
	is needed.

2014-07-08  Kaz Kylheku  <kaz@kylheku.com>

	* LICENSE: Adding copyright for MPI Library.

	* METALICENSE: Adding notes about MPI.

2014-07-07  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: install the LICENSE and METALICENSE files into the data
	directory.

	* txr.c (help): Help text updated to document --license option.
	(license): New function.
	(txr_main): Implement --license option.

	* unwind.h (uw_catch): Add cast to suppress warning about unused symbol.

	* txr.1: Document --license option.

2014-07-07  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (replace_list, sel): fix use of unused variable.

2014-07-07  Kaz Kylheku  <kaz@kylheku.com>

	* LICENSE: Small wording change. Add pointer to METALICENSE.

	* METALICENSE: New file.

2014-07-07  Kaz Kylheku  <kaz@kylheku.com>

	* LICENSE: Switching to simplified two-clause BSD license,
	but with modifications. Adding back the no-liability
	part of the disclaimer, but with abbreviated text.
	Also, rewriting the initial paragraph to make it clear
	that the two conditions cover redistribution, and that
	use of the software is tantamount to agreeing with the
	disclaimer.

2014-07-07  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Spell check.

2014-07-06  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Corrections from Roman Mishin

2014-07-03  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (apf_s, ipf_s): New symbol variables.
	(me_ap, me_ip): Generate a much simpler macro-expansion:
	a call to apf or ipf, rather than lambda syntax.
	(me_ado, me_ido): New static functions.
	(eval_init): Initialize apf_s and ipf_s variables.
	Use them in the registration calls for apf and ipf.
	Register ado and ido macros.

	* txr.1: Streamlined documentation for ap and ip,
	and added ado and ido.

2014-07-03  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (apf, ipf): Bugfix: do_apf and do_ipf
	should be registered as variadic functions.

2014-07-02  Kaz Kylheku  <kaz@kylheku.com>

	Version 91.

	* RELNOTES: Updated.

	* configure, txr.1: Bumped version.

	* dep.mk, txr.vim: Regenerated.

2014-07-02  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: use $(EXE) in install: recipe.

	* configure: set up EXE variable in config.make, not exe.

2014-07-02  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Documented usleep.

2014-07-02  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (dwim_loc): Support indexing using a list of positions,
	such as obtained by the where function.

	* lib.c (replace_list, replace_str, replace_vec): Allow the
	from argument to be a list of index positions, possibly empty.

	* txr.1: Condensed syntactic descriptions under dwim operator.
	Range Indexing section no longer says that the value nil
	can be used as either endpoint of a range. This will not
	work any longer since a "from" value of nil looks like an
	empty list of indexes. Documented new behavior under
	replace, and shortened documentation for replace-list,
	replace-str and replace-vec.

2014-06-30  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (sel): Bugfix: not implemented correctly for sequences
	which are lists.

2014-06-28  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (bit): New function.

	* eval.c (eval_init): Register bit as intrinsic.

	* lib.h (bit): Declared.

	* mpi-patches/add-bitops (mp_bit): New function.

	* txr.1: Documented bit

2014-06-28  Kaz Kylheku  <kaz@kylheku.com>

	* mpi-patches/add-bitops (mp_and, mp_or, mp_xor, mp_shift): Plug memory
	leaks caused by wrongly initializing the temporary destination operand
	for mp2_comp with a size, which mp2_comp then clobbers by doing the same
	thing.  Also plug memory leaks that happen in in out-of-memory return
	case.

2014-06-27  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (where, sel): Extend into hashes.

	* txr.1: document hash support for select and where.

2014-06-27  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: apply_intrinsic and iapply must not destructively
	manipulate argument lists.

	* eval.c (apply_frob_args): Rewrite to non-destructive
	one-pass version.
	(iapply): Likewise.

	* lib.c (term): New function.

	* lib.h (term): Declared.

2014-06-26  Kaz Kylheku  <kaz@kylheku.com>

	Fixes to bignum bit operations affecting pretty much all bit operations
	when bit field operands are negative, affecting logand, logor, logxor,
	lognot, logtrunc, logtest and ash. In addition, logtest was found to
	return the logical inverse of its correct value.

	* arith.c (logtest): Fix broken boolean polarity
	of return value.

	* mpi-patches/add-bitops (mp_2comp): Fix incorrect
	treatment of negative values.
	(mp_and): Fix incorrectly ordered statements, which
	cause failure when operands are negative.

2014-06-26  kaz kylheku  <kaz@kylheku.com>

	* eval.c (iapply_s): new global variable.
	(iapply, me_ip): new static functions.
	(do_apf): Bugfix: use apply_intrinsic, not apply.
	(do_ipf, ipf): New static functions.
	(eval_init): initialize iapply_s. register me_ip macro
	expander, and the iapply and ipf functions.

	* txr.1: Documented iapply, ipf and ip.

2014-06-26  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (last): Bugfix: reversed null test.

2014-06-26  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): register range_regex and tok_where
	as intrinsics.

	* lib.c (tok_where): New function.

	* lib.h (tok_where): Declared.

	* regex.c (range_regex): New function.

	* regex.h (range_regex): Declared.

	* txr.1: Documented tok-where and range-regex.

2014-06-26  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (search): Bugfix in type mismatch error message:
	trying to print cons function pointer as value.

2014-06-26  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (mapcarv): Use mapcar_listout, so list_of_lists can be
	a non-list sequence.
	(eval_init): Register transpose and zip as intrinsics.

	* lib.c (curry_12_1_v): New static function.
	(transpose, mapcar_listout): New functions.
	(mapcar): Redefined in terms of mapcar_listout.

	* lib.h (transpose, mapcar_listout): Declared.

	* txr.1: Documented transpose and zip.

2014-06-20  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: macros not being expanded in expansions embedded in
	quasilierals: i.e. the forms X and Y in `@{X}`
	and `@{X Y}`, where X and Y can be Lisp symbol macros or compound
	forms that is a macro call.

	* eval.c (expand_quasi): Handle the var forms in a quasi.

	* parser.y (n_exprs_opt, q_var): New grammar nonterminals.
	q_var is a clone of o_var, but with different construction behavior.
	It fixes the bug that o_var applies expand_meta to embedded
	Lisp forms, which is not appropriate for TXR Lisp quasiliterals.
	(quasi_item): Derive q_var rather than o_var.

2014-06-20  Kaz Kylheku  <kaz@kylheku.com>

	Optimization: add missing tail updates to some list
	collecting loops.

	* lib.c (tuples_func, where, sel): Catch return value of
	list_collect and update tail variable.

	* match.c (do_txeval): Likewise.

	* parser.y (expand_meta): Likewise for list_collect_nconc.

2014-06-20  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (do_apf, apf): New functions.
	(eval_init): Register apf as intrinsic.

	* txr.1: Document apf.

2014-06-20  Kaz Kylheku  <kaz@kylheku.com>

	Improve error reporting.

	* eval.c (eval_error): Use last_form_evaled if form is null.
	(apply): Substitute apply symbol if ctx_form is null.
	(apply_intrinsic): Do not pass fake (apply) context form to
	apply, just pass nil.

2014-06-19  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (identity_s): New global variable.
	(me_ret, tf, nilf, do_retf, retf): New static functions.
	(eval_init): Initialize identity_s, and use it for registration
	of identity. Register ret macro, and the retf, tf and nilf
	functions.

	* txr.1: Documentation for ret, retf, tf and nilf.

2014-06-19  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: dwim operator contradicts the documentation
	and intended design.

	* eval.c (do_eval): When calling do_eval_args to evaluate
	the arguments of a compound form that is a function call,
	do not pass down the lookup function, but substitute &lookup_var.
	Passing down the lookup function means tha all evaluation
	enclosed in (dwim ...) or [...] follows the Lisp-1 style.

2014-06-19  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (me_ap): New static function.
	(eval_init): Use new list_f instead of func_n0v(identity).
	Register multi as intrinsic.  Register me_ap as ap macro.

	* lib.c (list_f): New global variable.
	(multi): New function.
	(multi_sort): Use list_f in place of func_n0v(identity).
	(obj_init): gc-protect and initialize list_f.

	* lib.h (list_f, multi): Declared.

	* txr.1: Documented multi and ap.

2014-06-18  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register member and member_if as intrinsics.

	* lib.c (member, member_if): New functions.

	* lib.h (member, member_if): Declared.

	* txr.1: Documented.

	* txr.vim: Regenerated.

2014-06-17  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (generic_funcall): Bugfixes: support symbols.
	Removed dubious statement which clamps nargs to the number
	of fixed parameters, breaking variadic calls.
	Test case: (mapcar 'list '(1 2)) -> ((1) (2))
	Note: generic_funcall is only used when non-function objects
	are used as functions; variadic funcalls were not broken.

2014-06-17  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (generic_funcall): Bugfixes: support symbols.
	Removed dubious statement which clamps nargs to the number
	of fixed parameters, breaking variadic calls.
	Test case: (mapcar 'list '(1 2)) -> ((1) (2))

2014-06-17  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Fix broken examples for some and none functions.

2014-06-17  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (not_null): New static function.
	(eval_init): Use null_f in existing registration of null
	and not. Add registration for not_null as "true",
	and for null_f as "false".

	* txr.1: Documented true and false.

2014-06-17  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): register tuples as intrinsic.

	* lib.c (tuples_func): New static function.
	(tuples): New function.

	* lib.h (tuples): Declared.

	* txr.1: Documented.

2014-06-16  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (obj_print): Render character DC00 as "pnul".
	Clean up code which chooses rendering for characters.
	Print C0 and C1 control characters, as well as D800-DFFF,
	FFFE and FFFF and characters above FFFF using hex;
	others are printed using the #\<char> notation.

	* parser.y (char_from_name): map "pnul" to DC00.

	* txr.1: Documented pnul, clarified character
	printing rules, and added a cautionary note about
	possible ambiguity in printing.

2014-06-16  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register pos_max, pos_min, find_max,
	find_min and seqp as intrinsics.

	* lib.c (gt_f, lt_f): New variables.
	(to_seq): renamed to toseq.
	(seqp): New function.
	(minmax): New static function.
	(replace_str, replace_vec): Follow to_seq renaming.
	(find_max, find_min, pos_max, pos_min): New functions.
	(obj_init): gc-protect and initialize gt_f and lt_f.


	* lib.h (gt_f, lt_f): Declared.
	(to_seq): Declaration updated to toseq.
	(seqp, find_max, find_min, pos_max, pos_min): Declared.

	* txr.1: Updated.

2014-06-15  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): where and sel registered as intrinsics
	where and select.

	* lib.c (generic_funcall): Support a sequence as an argument
	to a sequence.
	(where, sel): New functions.

	* lib.h (where, sel): Declared.

	* txr.1: Documented.

2014-06-15  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: range and range* broken when "to" argument is
	omitted. This was broken in version 89, by the
	2014-04-08 commit.

	* eval.c (rangev_func, range_star_v_func): Only perform
	numeric tests between from and to if to is not nil.

2014-06-12  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: Install share/txr/stdlib/*.txr material.

	* match.c (do_txeval): If a variable is not in the bindings, fall
	back on treating it as a TXR Lisp dynamic variable. This allows
	us to refer to the stdlib variable from a quasistring in a
	@(load ...) directive.

	* txr.c (sysroot_init): Register new variable, *txr-version*.

	* share/txr/stdlib/ver.txr: New file.

2014-06-12  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (v_load): use the abs_path_p function instead of
	checking for leading slash.

	* stream.c (abs_path_p): New function.
	(stream_init): Register abs_path_p as abs-path-p.

	* stream.h (abs_path_p): Declared.

	* txr.1: Documented abs-path-p.

	* dep.mk: Updated.

2014-06-11  Kaz Kylheku  <kaz@kylheku.com>

	Version 90

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped.

	* txr.spec: Bumped version.

	* txr.vim, dep.mk: Regenerated.

	* RELNOTES: Updated

2014-06-11  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (txr.o): Pass TXR_VER preprocessor symbol on gcc command
	line.
	(PREINSTALL): New variable holding a step for the install recipe.
	(pax tar zip): New targets.

	* configure (txr_ver): Version now added to config.make, passed
	through to txr.c.
	(gen_config_make): bindir, datadir and mandir are established
	using gmake's regular macro assignment (=) rather than
	expanding assignment (:=). This allows us to override the
	prefix variable after configure time.

	* lib.h (wli_noex): New macro.
	(wli): Retarget to wli_noex, so that argument is subject
	to macro replacement.

	* txr.c (version): Use TXR_VER defined on compiler command line,
	rather than hard-coded string literal.

2014-06-10  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Change registration of string_cmp
	to cmp_str. Add registrations for str_eq, str_lt,
	str_gt, str_le, and str_lt.

	* lib.c (string_cmp): Name changes to cmp_str, and the
	function fixed so that it actually works.
	The name change doesn't affect anyone because the function
	was too broken to use due to the incorrect type dispatch.
	(string_lt): Name changes to str_lt.
	(str_eq, str_gt, str_le, str_ge): New functions.

	* lib.h (string_cmp, string_lt): Declarations renamed.
	(str_eq, str_gt, str_le, str_ge): New declarations.

	* txr.1: Document string-cmp to cmp-str rename, that
	string-lt is deprecated, and the new str<, str>,
	str>=, str<= and str= functions.

2014-06-10  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (PROG): Removing ./ prefix from variable name; adding it
	to invocations of $(PROG) in some rules.
	(txr.o): Pass several strings as macros on the command line:
	TXR_REL_PATH, EXE_SUFF and PROG_NAME.

	* configure (bindir, datadir, mandir): These variables become
	just relative paths from the prefix.

	* txr.c (sysroot): Use the TXR_REL_PATH, EXE_SUFF and PROG_NAME
	preprocessor symbols defined on the command line to avoid
	hard-coding strings like "bin/txr" and "bin/txr.exe" which
	actually should reflect the value of the bindir variable.

2014-06-10  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (get_self_path): Fix spelling of GetModuleFileName.
	Add missing parentheses in expression.
	(sysroot_init): On Windows, filter progpath to change
	backslashes to forward slashes.

2014-06-10  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l (yylex_destroy): The FLEX_ version are prefixed with YY_
	in old flexes too.

2014-06-09  Kaz Kylheku  <kaz@kylheku.com>

	New variable stdlib, with a sysroot mechanism to compute
	the path based on the "sysroot" where it is actually installed.

	* txr.c (progname_8u, progpath): New static variables.
	(get_self_path, sysroot_helper, sysroot, sysroot_init): New
	static functions. Sysroot creates a stdlib variable.
	(main): Initialize progname_u8 value, and call sysroot_init.

2014-06-09  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (match_str): Extended to suffix testing, with a negative
	start argument.

	* txr.1: Documented.

2014-06-09  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: fix broken tests; numerous test cases output
	bindings, and need the -B option. One test case does not
	need the -l option which now implies -B.

2014-06-09  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (txr_main): New option --args.
	Also, put in missing check for -f being erroneously clumped.

	* txr.1: Documented.

2014-06-09  Kaz Kylheku  <kaz@kylheku.com>

	The dumping of bindings and printing of false must now
	be explicitly requested by the -B option.

	* match.c (opt_nobindings): Variable removed.
	(opt_print_bindings): New variable.
	(extract): Print bindings or "false" if opt_print_bindings is true.

	* stream.c (output_produced): Variable removed.
	(stdio_put_string, stdio_put_char, stdio_put_byte): Remove
	update of output_produced.

	* stream.h (output_produced): Declaration removed.

	* txr.1: Documentation updated.

	* txr.c (txr_main): Option 'b' does nothing. 'B', 'l', 'a',
	and '--lisp-bindings' set opt_print_bindings to 1.

	* txr.h (opt_nobindings): Declaration removed.
	(opt_print_bindings): Declared.

	* unwind.c (uw_throw): When exiting due to a query error or
	file error, print false when opt_print_bindings is true.

2014-06-06  Kaz Kylheku  <kaz@kylheku.com>

	Fixing issue with list-like iteration over generic sequences,
	namely that empty strings and vectors are not nil.
	The nullify function is introduced. It is also exposed to
	users, as is the existing make_like function.

	* eval.c (mapcarv, mappendv, lazy_mapcar, lazy_mapcarv):
	Use nullify to handle non-list inputs correctly.
	(eval_init): Registering make_like and nullify as intrinsics.

	* lib.c (copy_list, to_seq, list_collect_nconc, list_collect_append,
	reverse, lazy_appendv_func, lazy_appendv, ldiff, memq, memql,
	memqual, remq, remql, remqual, remove_if, keep_if, rem_lazy_rec,
	remq_lazy, remql_lazy, remqual_lazy, remove_if_lazy, keep_if_lazy,
	countqual, countql, countq, count_if, some_satisfy, all_satisfy,
	none_satisfy, do_chain, chainv, do_and, andv, do_or, orv,
	cat_vec, assoc, assql, mapcar, mapcon, mappend, sort, multi_sort,
	find, find_if, posqual, posql, posq, pos, pos_if, set_diff,
	search): Use nullify for correctness. Some functions fixed
	so return sequence matches type of input sequence.
	(nullify): New function.

	* lib.h (nullify): Declared.

	* txr.1: Documented nullify and ake-like.

2014-06-06  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register new search function as intrinsic.

	* lib.c (search_list): New static function.
	(search): New function.

	* lib.h (search): New function declared.

	* txr.1: Documented.

	* txr.vim: Regenerated.

2014-06-05  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l: Adding an explicit lexical rule to
	catch backslashes occurring within a regex, not followed by a
	character. This can happen in dynamically parsed regexes
	such as "abc\\".

2014-06-05  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l (yylex_destroy): Only rely on the FLEX_ version
	numbers if they are defined. In a newer flex, they are prefixed
	by YY_.

2014-06-05  Kaz Kylheku  <kaz@kylheku.com>

	* configure (lang_flags): Removing -D_BSD_SOURCE
	from lang_flags. Adding a test for determining
	which flag reveals BSD functions. This is due to the
	braindamaged way feature selection macros work on
	FreeBSD. There is no way to say "give me only the
	functions from a certain version of the Unix spec,
	plus traditional BSD functions", so we have to resort to
	using the internal symbol __BSD_VISIBLE. Also, changing
	the detection test for daemon function to the
	pointer-based approach.

2014-06-04  Kaz Kylheku  <kaz@kylheku.com>

	* configure (lang_flags): drop -D_POSIX_C_SOURCE=199309L.
	This is subsumed by -D_XOPEN_SOURCE=500.

2014-06-04  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Typo in diagnostic output: wspawnlp.

2014-06-04  Kaz Kylheku  <kaz@kylheku.com>

	Changes for FreeBSD 9.

	* configure: Use pointer-based test for timegm, because
	-Werror=implicit-function-declaration does not work in the
	gcc 4.2 used on FreeBSD 9.

	* parser.l: Check for Flex 2.5.9 and earlier which don't
	have yylex_destroy. Thanks to Marcus Breiing.

2014-06-04  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Changes for building on Solaris 10 using the
	/usr/bin/xpg4/sh shell. Solaris' /bin/sh does not like test
	-e. Adding break to the new shell existence testing loop so we
	use the first shell in the list. Solaris wants _XOPEN_SOURCE=500
	to reveal certain functions. Fix breakage in the make utility
	detection, and also use the $make variable everywhere instead
	of make.

2014-06-04  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Defend against legacy, non-POSIX /bin/sh implementations.
	We boostrap using #!/bin/sh, but try to detect a better shell
	and re-execute the script with that shell. Furthermore, we now
	set up the SHELL variable in config.make, so that make uses that
	shell for executing build recipes.

2014-06-03  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_lisp1): Function removed.
	(op_dwim, dwim_locs): Removing silly logic of separately calling
	eval_lisp1 on the functor, and eval_lisp1_args on its arguments, since
	lisp1 evaluation treats all position the same way.

2014-06-03  Kaz Kylheku  <kaz@kylheku.com>

	Documenting the return value of rplaca and rplacd, and changing
	it to be the cell, rather than the new value.

	* eval.c (transform_op): Fix use of rplacd that uses return value.
	(force): Likewise.

	* lib.c (rplaca, rplacd): Return cons.
	(rem_lazy_rec, obj_init): Fix use of rplacd that uses return value.

	* txr.1: Documented.

2014-05-20  Kaz Kylheku  <kaz@kylheku.com>

	The call operator should be a function!

	* eval.c (call): New static function.
	(eval_args, op_call): Static functions removed.
	(eval_init): call_s registered as operator rather than function.

	* txr.1: Updated.

2014-05-10  Kaz Kylheku  <kaz@kylheku.com>

	Version 89

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped. 

	* txr.spec: Bumped version.

	* RELNOTES: Updated

2014-05-10  Kaz Kylheku  <kaz@kylheku.com>

	String type related bugfixes: neglecting to handle all three kinds in
	some places. In particular, the test case

	  echo : | ./txr -c '@a:@a' -

	breaks because of neglected LIT in do_match_line.

	* arith.c (tofloat, toint): Handle LIT type in switch.

	* lib.c (ref, refset, replace, update): Handle LSTR type.

	* match.c (do_match_line, do_output_line): Handle LSTR and LIT
	objects in switch.

2014-04-14  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (get_line, get_char, get_byte): Fix outdated, incorrect
	optional argument defaulting logic.

2014-04-13  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c, gc.c, rand.c, regex.c, signal.c: Remove inclusion of unneeded
	headers.

2014-04-11  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (make_var_shadowing_env): Remove unnecessary test for
	colon symbol.

2014-04-08  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (rangev_func, range_star_v_func): Use numeric
	equivalence comparison for end test, rather than eql.

2014-04-07  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (eql): Bugfix: not handling floating-point types!
	Two objects which are equal floating-point values must be considered
	eql even if they are distinct objects (not eq).

2014-04-04  Kaz Kylheku  <kaz@kylheku.com>

	Version 88

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped. Generational GC is now
	enabled by default.

	* txr.spec: Bumped version.

	* RELNOTES: Updated

	* txr.vim: Regenerated.

2014-03-29  Kaz Kylheku  <kaz@kylheku.com>

	* gc.c (CHECKOBJ_VEC_SIZE, FRESHOBJ_VEC_SIZE): Increase
	to 8 * HEAP_SIZE from 2 * HEAP_SIZE to reduce frequency
	of garbage collections.

2014-03-29  Kaz Kylheku  <kaz@kylheku.com>

	* HACKING: Updating generational GC notes in light of changes.

2014-03-29  Kaz Kylheku  <kaz@kylheku.com>

	Change to how locations are passed around, for the sake of generational
	GC. The issue being solved here is the accuracy of the gc_set function.
	The existing impelmentation is too conservative. It has no generation
	information about the memory location being stored, and so it assumes
	the worst: that it is a location in the middle of a gen 1 object.
	This is sub-optimal, creating unacceptable pressure against the
	checkobj array and, worse, as a consequence causing unreachable gen 0
	objects to be tenured into gen 1.

	To solve this problem, we replace "val *" pointers with a structure
	of type "loc" which keeps track of the object too, which lets us
	discover the generation.

	I tried another approach: using just a pointer with a bitfield
	indicating the generation.  This turned out to have a serious issue:
	such a bitfield goes stale when the object is moved to a different
	generation. The object holding the memory location is in gen 1, but the
	annotated pointer still indicates gen 0. The gc_set function then
	makes the wrong decision, and premature reclamation takes place.

	* combi.c (perm_init_common, comb_gen_fun_common,
	rcomb_gen_fun_common, rcomb_list_gen_fun): Update to new interfaces
	for managing mutation.

	* debug.c (debug): Update to new interfaces for managing mutation.
	Avoid loc variable name.

	* eval.c (env_fbind, env_fbind): Update to new interfaces
	for managing mutation.
	(lookup_var_l, dwim_loc): Return loc type and update to new interfaces.
	(apply_frob_args, op_modplace, op_dohash, transform_op, mapcarv,
	mappendv, repeat_infinite_func, repeat_times_func): Update to new
	interfaces for managing mutation.

	* eval.h (lookup_var_l): Declaration updated.

	* filter.c (trie_add, trie_compress, trie_compress_intrinsic,
	* build_filter, built_filter_from_list, filter_init): Update to new
	* interfaces.

	* gc.c (gc_set): Rewritten to use loc type which provides the exact
	generation. We do not need the in_malloc_range hack any more, since
	we have the backpointer to the object.
	(gc_push): Take loc rather than raw pointer.

	* gc.h (gc_set, gc_push): Declarations updated.

	* hash.c (struct hash): The acons* functions use loc instead
	of val * now.
	(hash_equal_op, copy_hash, gethash_c, inhash, gethash_n, pushhash,
	remhash, set_hash_userdata, hash_next, group_by, hash_keys,
	hash_values, hash_pairs, hash_uni, hash_isec, hash_update,
	hash_update_1): Updated to new interfaces for managing mutation.
	(hash_grow): Needs hash table argument to call the new form of set.
	(hash_process_weak): We need to use valptr to recover the val *
	from the loc that we receive from some functions now.

	* hash.h (gethash_c, gethash_f): Declarations updated.
	(gethash_l): Inline function's prototype changes.

	* lib.c (rplaca, rplacd, car_l, cdr_l, listref_l, tail, lastcons, last,
	ltail, list_collect, list_collect_nconc, list_collect_append, nreverse,
	lazy_appendv_func, lazy_appendv): Update to new interfaces.
	(malloc_low_bound, malloc_high_bound): Static variables removed.
	(adjust_bounds): Static function removed.
	(chk_malloc, chk_malloc_gc_more, chk_calloc, chk_realloc):
	Calls to adjust_bounds removed.
	(in_malloc_range): Function removed.
	(get_plist_f, string_extend, length_str, replace_str, make_sym,
	delete_package, intern, rehome_sym, get_user_package,
	get_system_package, get_keyword_package, func_get_env, vec_set_length,
	vecref, vecref_l, vec_push, simple_lazy_stream_func, lazy_stream_func,
	lazy_str, lazy_str_force, lazy_str_force_upto, acons_new, acons_new_c,
	aconsql_new, aconsql_new_c, alist_nremove, alist_nremove1, merge,
	sort_list, refset, obj_init): Update to new interfaces.

	* lib.h (loc): New typedef.
	(gc_set): Interface change.
	(mkloc_fun): New inline function.
	(mkloc, mkcloc, nulloc, nullocp, deref, valptr): New macros
	(set): Interface change: takes loc as first argument,
	rather than lvalue expression.
	(mpush): Interface change: second argument is loc, rather
	than lvalue.
	(keyword_package, user_package, system_package, gensym_counter): Use
	deref rather than dereference operator.
	(in_malloc_range): Declaration removed.
	(car_l, cdr_l, listref_l, tail, lastcons, ltail, getplist_f,
	get_user_package, get_system_pckage, get_keyword_package,
	vecref_l, acons_new_c, aconsql_new_c): Declarations updated.
	(list_collect_decl): Updated to follow new interfaces.

	* match.c (dest_set, h_coll, v_gather, v_collect, v_cat, v_output,
	v_filter): Updated to follow new interfaces.

	* parser.y (expand_meta, rlset): Updated to follow new interfaces.

	* rand.h (random_state): Use deref.

	* stream.c (string_in_get_line, string_in_get_char,
	string_in_unget_char, strlist_out_put_string, strlist_out_put_char):
	Updated to follow new interfaces.

	* stream.h (std_input, std_output, std_debug, std_error,
	std_null): Use deref macro.
	(lookup_var_l): Declaration updated.

	* syslog.c (syslog_put_string, syslog_put_char, syslog_put_byte,
	syslog_set_prop): Updated to follow new interfaces.

	* unwind.c (uw_register_subtype): Updated to follow
	new interfaces.

2014-03-29  Kaz Kylheku  <kaz@kylheku.com>

	Generational GC tweaks.

	* gc.c (make_obj): If we have room in the freshobj array,
	but are out of objects, then call more. Without this,
	we don't take proper advantage of this nursing area.
	(gc): Set the full_gc flag after doing gc, in preparation
	for next time. If we know full GC is coming, we can
	adjust some behaviors. Increase the threshold for calling the more()
	function to be the same as in the non-generational case:
	less than 3/4 of the size of a heap scavenged.
	(gc_set): Now does nothing if it is known that
	a full gc is coming. Also, in the checkobj array overflow
	case when we invoke gc, there is no point in adding obj
	to the array, since it must have been promoted to the mature
	generation.
	(gc_mutated): Don't bother storing the object in the
	array if a full GC is coming.

2014-03-29  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (string_time): If possible, change the timezone in the
	struct tm from "GMT" to "UTC", so that the time_string_utc
	function will use UTC for the %Z format.

2014-03-27  Kaz Kylheku  <kaz@kylheku.com>

	Fix a bug arising from putting generation 1 objects into the
	checkobj array (via the mut macro that expands to gc_mutated).
	The garbage collector assumes that checkobj has only generation 0
	objects, which all exist in the freshobj array, which is subject
	to a sweep. So gen 1 objects in checkobj are never cleaned up
	properly: they do not have their REACHABLE flag reset, or
	their generation restored to 1. To fix this, a new array for these
	objects is introduced separate from checkobj.

	* gc.c (MUTOBJ_VEC_SIZE): New preprocessor symbol.
	(mutobj, mutobj_idx): New static array and integer.
	(mark_obj): Check for REACHABLE flag before checking the full_gc
	flag and generation, since those cost additional memory accesses.
	(mark): Mark the objects in the new mutobj array.
	(sweep): Sweep the objects in the mutobj array.
	(gc): Reset mutobx_idx to zero after gc.
	(gc_set): Rearrange logic. In the case that the checkobj array
	is full and a gc is done to make room, there is no point in
	adding to the array: the gc pass moves all babies to generation 1,
	so the object that was passed into the function is no longer a baby.
	(gc_mutated): Rewrite in terms of mutobj rather than checkobj,
	fixing the bug.

	* HACKING: Improved documentation of GC. Describe mut macro
	and mutobj array.

2014-03-27  Kaz Kylheku  <kaz@kylheku.com>

	More generational GC fixes. One GC fix.

	* combi.c (perm_init_common, comb_gen_fun_common,
	rcomb_gen_fun_common): Use set macro instead of plain assignment.

	* hash.c (hash_grow, copy_hash, hash_update_1): Use set macro
	instead of plain assignment.

	* lib.c (nreverse, lazy_appendv_func, lazy_appendv,
	vec_push, refset): Use set macro instead of plain assignment.
	(make_package): Assign all fields of the newly created PKG
	object before calling a function which can trigger GC.

	* parser.y (rlset): Use set macro.

2014-03-27  Kaz Kylheku  <kaz@kylheku.com>

	Fix generational GC regression caused by fixes
	in in 2014-03-12, when prof was introduced.
	The attempt to fix a bug made things worse.

	* lib.c (adjust_bounds): New static function.
	(chk_malloc, chk_calloc, chk_realloc): Replace existing logic with
	call to adjust_bounds.
	(chk_malloc_gc_more): Bugfix: add missing call to adjust_bounds.

2014-03-26  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Update for WLL's and QLL's.

	* txr.vim: Regenerate.

2014-03-25  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (me_quasilist): New static function.
	(eval_init): Register me_quasilist as quasilist macro expander.

	* lib.c (quasilist_s): New global variable.
	(obj_init): quasilist_s initialized.

	* lib.h (quasilist_s): Declared.

	* match.c (do_txreval): Handle quasilist syntax.

	* parser.l (QWLIT): New exclusive state.
	Extend lexical grammar to transition to QWLIT state upon
	the #` or #*` sequence which kicks off a word literal,
	and in that state, piecewise lexically analyze the QLL,
	mostly by borrowing rules from quasiliterals.

	* parser.y (QWORDS, QWSPLICE): New tokens.
	(n_exprs): Integrate splicing form of QLL syntax.
	(n_expr): Integrate non-splicing form of QLL syntax.
	(litchars): Propagate line number info.
	(quasilit): Fix "string literal" wording in error message.

	* txr.1: Introduced WLL abbreviation for word list literals,
	cleaned up the text a little, and documented QLL's.

2014-03-25  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand_quasi): Bugfix: incorrect logic, failing
	to macro-expand the embedded forms in a quasiliteral except
	when they are the very first item.

2014-03-25  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (yybadtoken): Add missing cases for new token
	types WORDS and WSPLICE.

2014-03-25  Kaz Kylheku  <kaz@kylheku.com>

	Introducing word list literals.

	* parser.l (WLIT): New exclusive start state.
	Extend lexical grammar to transition to WLIT state upon
	the #" or #*" sequence which kicks off a word literal,
	and in that state, piecewise lexically analyze the literal,
	mostly by borrowing rules from other literals.

	* parser.y (WORDS, WSPLICE): New tokens.
	(n_exprs): Integrate splicing form of word list literal syntax.
	(n_expr): Integrate non-splicit for of word list literal syntax.
	(litchars): Propagate line number info.
	(wordslit): New grammar rule.

	* txr.1: Updated.

2014-03-23  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register last function as intrinsic.

	* lib.c (last): New function.

	* lib.h (last): Declared.

	* txr.1: Documented last.

2014-03-23  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register empty as intrinsic.

	* lib.c (copy): Bugfix: handle lazy strings. Also, handle hash
	tables via copy_hash.
	(length): Bugifx: handle lazy strings. Also, handle hash tables
	via hash_count.
	(empty): New function.

	* lib.h (empty): Declared.

	* txr.1: Documented.

2014-03-23  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (not_s): New symbol var.
	(me_unless, me_while, m_until): New static functions.
	(eval_init): Register macros unless, while and until.

	* txr.1: Document unless, while and until.

2014-03-22  Kaz Kylheku  <kaz@kylheku.com>

	Version 87

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped.

	* RELNOTES: Updated

	* txr.vim: Regenerated.

2014-03-22  Kaz Kylheku  <kaz@kylheku.com>

	* utf8.c (w_fopen, w_popen, w_freopen, w_remove, w_rename): Revert
	2014-03-14 changes.

2014-03-21  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (me_when): New static function.
	(eval_init): Register "when" macro.

	* txr.1: Documented when macro.

2014-03-19  Kaz Kylheku  <kaz@kylheku.com>

	Second round of bugfixing on the theme of the previous commit.
	Here were are changing the output clause to recognize all special
	clause tokens that are not used in output and turning them into
	regular Lisp.  So @(if a b c) in an output clause works once again,
	recognized as IF exprs_opt ')' syntax, and turned into Lisp. Other
	things work that didn't work before like @(and), @(or) and so forth.

	* parser.y (make_expr): New static function.
	(not_a_clause): New nonterminal.
	(out_clause): Remove error-catching productions for match-side
	clauses.
	(o_elems): Now consists of a mixture of o_elems and not_a_clause's.

2014-03-19  Kaz Kylheku  <kaz@kylheku.com>

	Fixing gaping bug in the handling of @-delimited expressions
	within quasiliterals. This has been a problem for years.
	Quasiliteral strings existed very early before TXR Lisp was introduced.
	So it made sense that when @ is seen in a quasiliteral, the
	lexical analyzer pushed into the SPECIAL state in which directives
	are recognized, like in the pattern language. I noticed
	this because there is an @(if) directive now, which prevents
	`@(if ...)` from being valid.

	* parser.l (QSPECIAL): New scanner state. This is a state
	similar to SPECIAL that we enter into when @ is seen in a QSLIT state.
	In this state we recognize constructs like braced variables, but not
	certain other features like directives.

2014-03-19  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (int_flo): Fix non-handling of negative values.

2014-03-19  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (tofloat, toint): New functions.

	* arith.h (tofloat, toint): Declared.

	* eval.c (eval_init): tofloat and toint registered
	as intrinsics.

	* txr.1: Documented.

2014-03-16  Kaz Kylheku  <kaz@kylheku.com>

	Version 86

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped.

	* RELNOTES: Updated

	* dep.mk: Regenerated.

2014-03-16  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (win_make_cmdline): I think I cracked the code of
	passing escaped arguments to Microsoft's popen and system
	functions. The first argument cannot be quoted, but the
	subsequent ones can. It is the quoting of the first argument
	that causes the whole thing to be quoted. So we just
	avoid quoting the first argument. (If it has spaces, too bad;
	don't do that).
	(open_process): Fix neglected optional argument handling
	in Windows version of this function.

2014-03-16  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Detect _wspawn* functions.

	* stream.c (run): Implement using _wspawnvp on MinGW.

2014-03-15  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l: Bugfix. When handling a backslash-newline continuation
	in the SPECIAL, NESTED and BRACED states, do not pop the state in all
	three, only in SPECIAL (to terminate the @\ continuation).

	* txr.1: Eliminate wrong claim that string literals do not split across lines,
	which is directly contradicted two paragraphs later.  Document that
	quasiliterals also split.

	* genvim.txr (txr_regex, txl_regex): These definitions change from "syn match"
	to "syn region" so that the backslash-newline continuation can be properly
	handled.
	(txr_string, txr_quasilit): Correctly handle split literals.

	* txr.vim: Regenerated.

2014-03-15  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (text): Allow the EMPTY token (the @(empty) syntax)
	to be a text.

	* txr.1: Documented @(empty).

2014-03-14  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l (regex_parse, lisp_parse): Fix neglected handling of
	optional arguments. This problem can cause the symbol : to be
	planted as the std_error stream, resulting in an error loop
	that blows the stack.

	* regex.c (regex_compile): Likewise.

2014-03-14  Kaz Kylheku  <kaz@kylheku.com>

	* utf8.c (w_fopen, w_popen, w_freopen, w_remove, w_rename): We
	have similar functions in the MSVCRT library used by MinGW,
	so if _WIN32 is defined, our functions now just wrap those.

2014-03-14  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (run): Fix MinGW build failures. The run function doesn't
	work right with arguments, though: the win command line is broken.

2014-03-14  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Make seed argument optional in make-random-state.

	* rand.c (make_random_state): Do argument defaulting on seed.
	Also, mix getpid() into the seed.
	(random_fixnum): Bugfix: do proper defaulting on optional
	agument, rather than relying on nil.
	(random): Fix 2014-02-05 regression. This was totally broken,
	ignoring the random state passed in and using the global
	random state. This function must only use the state passed in;
	there is no defaulting to the global random state.

	* txr.1: Documenting that seed is optional in make-random-state.
	Describing what guarantees can be expected with regard to
	calls made close together temporally.

2014-03-13  Kaz Kylheku  <kaz@kylheku.com>

	Implementing @(if)/@(elif)/@(else) in the pattern language.
	Input side for now; output later.

	* parser.y (if_clause, elif_clauses_opt, else_clause_opt): New nonterminals.
	(IF, ELIF, ELSE): New tokens.
	(yybadtoken): Handle IF, ELIF, ELSE.

	* parser.l: Recognize and return new tokens IF, ELIF and ELSE.

	* txr.1: Documented.

	* genvim.txr: Updated with if, elsif and else directive keywords.

	* txr.vim: Regenerated

2014-03-13  Kaz Kylheku  <kaz@kylheku.com>

	On platforms with sigaltstack, TXR programs can now catch the
	segmentation fault that occurs when running out of stack space,
	and escape by throwing an exception.

	Also, bugfix: save and restore the gc enable/disable state.  Without
	this, if we are ever running cod in a gc disabled state and it jumps
	out, gc stays disabled.

	* configure: added check for sigaltstack.

	* gc.h (gc_enabled): Declaration added for existing variable.

	* signal.c (is_cpu_exception): New static function.
	(sig_handler): For cpu_exception type signals that pertain
	to the execution of some instruction, turn on async_sig_enabled,
	so that the signal is not deferred. Otherwise we will just
	return without calling the user-defined handler, restart
	the instruction and get into a loop. Also, disable gc around
	the handler just in case. One issue is that we might be on
	an alternate stack, which gc won't like.
	(setup_alt_stack, teardown_alt_stack): New static functions.
	(set_sig_handler): If we have sigaltstack, and are asked
	to set up a SEGV handler, then set it up on the alternate
	stack.

	* signal.h (extended_jmp_buf): Adding new member, gc.
	(extended_setjmp, extended_longjmp): use gc member
	to save and restore the gc_enable state across
	setjmp and longjmp.

2014-03-13  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (open_process): If execvp fails, use errno as the
	exit status.
	(sh, run): New static functions.
	(stream_init): sh and run registered as intrinsics.

2014-03-12  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (iffi): Bugfix: was still using incorrect, outdated optional
	argument defaulting logic.

2014-03-12  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (plus_s, prof_s): New symbol global variables.
	(op_prof, me_pprof): New static functions.
	(eval_init): Intern prof symbol, store in prof_s.
	Captured interned + symbol in plus_s. Register prof operator and pprof
	macro.

	* gc.c (gc_bytes): New global variable.
	(more): Use nse function chk_malloc_gc_more instead of chk_malloc.
	(make_obj): Increment gc_bytes.

	* lib.c (malloc_bytes): New global variable.
	(chk_malloc, chk_realloc): Increment malloc_bytes.
	(chk_calloc): Bugfix: incorrect size in recursion into oom_realloc.
	Incorrect calculation of malloc_high_bound.  Increment malloc_bytes.
	(chk_malloc_gc_more): New function.

	* lib.h (alloc_bytes_t): New typedef.
	(malloc_bytes, gc_bytes): Declared.
	(chk_malloc_gc_more): Declared.

	* stream.c (format_s): New symbol global.
	(stream_init): format_s inited.
	format_s used to register formatv function.

	* stream.h (format_s): Declared.

	* txr.1: Documented prof and pprof.

	* genvim.txr: Recognize reg_fun calls with intern
	followed by a preceding assignment or other syntax.

	* txr.vim: Updated.

2014-03-11  Kaz Kylheku  <kaz@kylheku.com>

	* configure: new test for fcntl.

	* stream.c (open_process): Fixed off-by one erroneous value of nargs,
	causing memory leak of one string. Fixed memory leak on fork failure.
	Fixed a deadlock that can occur in the pipe close function when
	multiple pipes are in existence. This is fixed by setting the
	FD_CLOEXEC flag on the pipe file descriptor. Without this, one child
	process can hold another's pipe open, causing that other one not to
	terminate when we're trying to shut it down, resulting in that child
	blocked on a write, while we block on waitpid.

2014-03-11  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (open_process): In the event of fdopen failure,
	kill the child process less abruptly by hitting it with SIGINT and
	SIGTERM, rather than with SIGKILL. Also, collect the child
	process with waitpid.

2014-03-11  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Registration of url_encode and url_decode
	moved to filter.c.

	* filter.c (trie_compress_intrinsic, html_encode, html_decode): New
	static functions.
	(filter_init): Register make_trie, trie_add, trie_compress_intrinsic,
	filter_string_tree, filter_equal, html_encode and html_decode
	as intrinsics. Move registration of url_encode and url_decode here.

	* genvim.txr: Look for registrations in filter.c too.

	* txr.1: Documented.

	* txr.vim: Updated.

2014-03-11  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (open_process): Close the original pipe file descriptor
	in the child process after dup2-ing it to standard input or standard
	output, so the child doesn't have to references to the pipe.

2014-03-10  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (pipe_close): Restructured the function a bit.
	Do not throw exceptions for normal process terminations, only for
	abnormal ones (terminated by a signal). Return the termination
	status instead of just t.

	* txr.1: Fixed the neglected documentation of the optional boolean
	argument of close-stream. Described the behaviors with regard
	to pipes in more detail.

2014-03-09  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (v_trailer): Fix segfault. The code which
	helps implement the special interaction between @(accept) and
	@(trailer) was not handling the situation when there is not
	current unwind exit point.

2014-03-09  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l: Syntactic tweak. Do not allow the "extra"
	constituent chars # or ^ to start the symbol name after an @.
	Prior to this change @^a is a "meta-symbol" whose name is "^a",
	but ^a is the ^ quasiquote notation followed by symbol a.
	After this change @^a is meta, applied to quasiquote-a.

2014-03-09  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (lazy_sub_str): Bugfix: "from" was mistakenly used
	in the adjustment of the "to" value.

	* match.c (search_form): Use predefined constants for -1 and 1
	instead of calling num.

2014-03-09  Kaz Kylheku  <kaz@kylheku.com>

	Fixing broken processing of horizontal matching across
	long lines produced by @(freeform). Once the matching
	passes about 4000 characters, the "consume_prefix"
	function kicks in to save memory. Then any code which is
	not properly written to handle this displaced situation
	will break.

	* match.c (h_text, h_var, h_coll, h_parallel, h_fun): Bugfix.
	The recursive calls to match_line return an absolute position.
	From this value we must subtract c->base if we are to 
	compare it with c->pos, or update c->pos.  If we use the
	absolute value, we are abruptly jumping ahead in the data.

2014-03-08  Kaz Kylheku  <kaz@kylheku.com>

	Issue: match_regex and search_regex were continuing to feed characters
	to the regex machine even when there is no transition available.  This
	was due to the broken return value protocol of regex_machine_feed.  For
	instance for the regex / +/ (one or more spaces), after matching some
	spaces, it would report REGM_INCOMPLETE for additional non-space
	characters, never reporting REGM_FAIL.

	* regex.c (regm_result_t): Block comment added, documenting protocol.
	(regex_machine_feed): Return REGM_FAIL if there are no transitions for
	the given character, even a partial match has been recorded. This is
	a signal to stop feeding more characters. At that point, the function
	can be called with a null character to distinguish the three cases:
	fail, partial or full match. 
	(search_regex): Now when the search loop gets a REGM_FAIL, it can
	no longer assume that nothing was matched and the search must restart
	at the next position. Upon the REGM_FAIL signal, it is necesary to
	seal the search by feeding in the 0 character. Only if that returns
	REGM_FAIL is it a no match situation. Otherwise it is actually a match!

2014-03-08  Kaz Kylheku  <kaz@kylheku.com>

	Version 85

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped.

	* RELNOTES: Updated

	* txr.vim: Updated.

2014-03-08  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Added missing documentation for @(forget)/@(local).

2014-03-08  Kaz Kylheku  <kaz@kylheku.com>

	* rand.c (rand_init): Oops! Spectacular silliness here
	broke the symbol module: two intern calls in consecutive
	lines, one for the name without "earmuffs", one with,
	leading to the situation that the C code looks for a
	dynamic variable that does not exist.

2014-03-07  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (LOG_MATCH, LOG_MISMATCH): Wouldn't you know it;
	the format strings in these macros contained a workaround for
	the broken * variable field width syntax, specifying
	~*~a where the extra ~ in the middle just feeds a character
	that the broken state machine expects.  These workarounds broke when I
	fixed the formatting, making -v mode useless.

2014-03-07  Kaz Kylheku  <kaz@kylheku.com>

	Version 84

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped.

	* RELNOTES: Updated

	* txr.vim: Updated.

2014-03-06  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (upop): New function.

	* lib.h (upop): Declared.

	* txr.c (txr_main): Two bugfixes. One is that the argument -
	was being pushed back twice resulting in *args* being ("-" "-").
	This is because the option processing loop checked for "-" and pushed
	it back into args, and then some logic after the loop pushed arg back
	into args again. But, these pushes were wrong because they push
	back a different cons cell; we would like to be able to
	do (ldiff *full-args* *args*). This is solved by upop, which provides
	one element of undo. After upop, we can restore the prior list
	from the undo save location.

2014-03-06  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (assert_s): New global variable.
	(obj_init): Intern assert symbol, store in assert_s.

	* lib.h (assert_s): Declared.

	* match.c (typed_error, v_assert, h_assert): New static functions.
	(dir_tables_init): Register v_assert and h_assert.
	Register assert_s as non-data-matching directive.

	* unwind.c (uw_init): Register assert as a subtype
	of error.

	* txr.1: Describe assert.

2014-03-06  Kaz Kylheku  <kaz@kylheku.com>

	* match.c: (v_next): Set the "curfile" in the context to "env" when
	scanning environment.
	(open_data_source): Regression: was not setting c->curfile when opening
	anything.

2014-03-06  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (apply_intrinsic, lazy_mapcar): Changed linkage to external.

	* eval.h (apply_intrinsic, lazy_mapcar): Declarations added.

	* stream.c (open_files, open_file_star): New functions.
	(stream_init): Registered new functions as intrinsics.

	* txr.1: Documented open-files and open-files*. Added to make-catenated-stream documentation.

	* genvim.txr: Replace bunch of code with open-files.

	* txr.vim: Regenerated.

2014-03-06  Kaz Kylheku  <kaz@kylheku.com>

	* match.c (match_files): Fix it again. The data (nil)
	can occur from an interactive/real-time stream.

2014-03-06  Kaz Kylheku  <kaz@kylheku.com>

	g++ regressions.

	* eval.c (env_k): Duplicate global variable definition removed.
	
	* lib.c (vector, vec_set_length): Fixed signed/unsigned comparison
	warnings.

	* stream.h (stdin_s, stdout_s, stddebug_s, stderr_s, stdnull_s):
	Declarations were definitions due to missing extern.

2014-03-05  Kaz Kylheku  <kaz@kylheku.com>

	* txr.c (txr_main): Don't push back arg into arg_list if arg is nil.

2014-03-05  Kaz Kylheku  <kaz@kylheku.com>

	Fixing regression caused by the 2014-02-19 change ("Fixed long-running
	issue ...").

	* match.c (open_data_source): if c->data is t, but c->files
	is nil, set c->data to nil: we cannot possibly open anything later.
	(match_files): We need to call open_data_source one more time just
	before processing a line with horizontal material.  The previous
	call(s) to open_data_source might not have opened anything. Before
	accesing car(c.data) the correct test is consp(c.data), not c.data. In
	the else clause, we now specificially check for nilp(c.data) which is
	the correct indicator of no more data. If c.data is any other atom at
	that point, we have an internal error, for which an assertion is added
	now.

2014-03-05  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (vformat): Fix broken parsing of parameteric width and
	precision (i.e. given by *). The simplest way to do this is to add a
	state vf_star which is similar to vf_digits, and reuses much of the
	logic via a goto. Fixing forgotten --fmt (push back char) when moving
	from vf_precision to vf_spec state due to unhandled character.
	Also, allowing a leading zero before a precision given as *
	so that computed precisions can be combined with zero padding.

	* txr.1: Documented leading zero better so it is clear it
	combines with *. Restructured documentation.

2014-03-05  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (put_line): Default string argument to empty string.
	(stream_init): Change how put_line is registered to take advantage of
	new optional parameter.

	* txr.1: Updated.

2014-03-04  Kaz Kylheku  <kaz@kylheku.com>

	* arith.c (logten): New function.

	* eval.c (eval_init): logten registered as intrinsic.

	* lib.h (logten): Declared.

	* txr.1: Documented.

2014-03-03  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l: Allowing ^ to be a quote character, and adjusting definition
	of identifiers to rule this out from being the first character of a
	symbol which has no prefix. Recognize the ^ character as a token in the
	NESTED state.

	* lib.c (obj_print, obj_pprint): Render sys:qquote as ^.

	* parser.y (choose_quote): Function removed.
	(n_expr): Recognize '^' as quasiquote. Removed all the "smart quote"
	hacks that try to make quote behave as quote or quasiquote, or try to
	cancel out unquotes and quotes.

	* tests/009/json.txr: Fixed to ^ quasiquote.

	* tests/010/reghash.txr: Likewise.

	* tests/011/macros-2.txr: Likewise.

	* tests/011/mandel.txr: Likewise.

	* tests/011/special-1.txr: Likewise.

	* txr.1: Updated docs.

	* genvim.txr: Revamped definitions for txr_ident and txl_ident so that
	unqualified identifiers cannot start with # or ^, but ones with @ or :
	in front can start with these characters.

	* txr.vim: Regenerated.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile (lex.yy.c): Remove lex.yy.c before trying to regenerate it.
	(y.tab.c, y.tab.h): Remove y.tab.c before running yacc. Write-protect
	y.tab.c, not $@, which could expand to the y.tab.h target if that is
	what triggered the rule.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Incorporating more corrections from Roman Mishin.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (make_env_intrinsic): New static function.
	(eval_init): Register new intrinsics make-env, env-fbind and env-vbind.
	
	* txr.1: Documented.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	Version 83

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date.

	* configure (txr_ver): Bumped.

	* RELNOTES: Updated

	* dep.mk: Updated.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand): Bugfix. When processing a defvar, should mark
	the variable as special at expansion time. Without this, binding
	forms in other parts of the tree won't be expanded properly
	to bring about the special semantics.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (unquotes_occur): Fix use of unquote_s rather than sys_unquote_s
	which breaks backquote, caught by tests/010/reghash.txr.
	I thought fixed this already! But I must have made the change to y.tab.c
	rather than parser.y.

	* Makefile (lex.yy.c, y.tab.c): Make these files readonly to prevent
	unintended edits.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Skip lines that contain system_package.

	* txr.vim: Regenerated.

2014-03-02  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: catenated stream objects not hooked into garbage collector,
	causing premature collection of the catenated stream list.

	* stream.c (cat_mark): new function.
	(cat_stream_ops): use cat_mark for gc mark function.

2014-03-01  Kaz Kylheku  <kaz@kylheku.com>

	New quasiquote idea: let's have two quasiquote macros sharing one
	expander. One macro based on sys:qquote, sys:unquote and sys:splice,
	and the other based on qquote, unquote and splice in the user package.
	The read syntax puts out the sys: one.

	* eval.c (expand_qquote): Takes three additional arguments: the
	qquote, unquote and splice symbols to recognize.
	The invalid splice diagnostic is adjusted based on which backquote
	we are expanding.
	(me_qquote): Look at the symbol in the first position of the form
	and then expand either the internal quasiquote macro or the public one,
	passing the right symbols into expand_qquote.
	(eval_init): Register error-throwing stub functions
	for the sys_qquote_s, sys_unquote_s and sys_splice_s symbols.
	Register a macro for sys_qquote_s.

	* lib.c (sys_qquote_s, sys_unquote_s, sys_splice_s): New symbol
	variables.
	(obj_init): Initialize new variables. Change qquote_s,
	unquote_s and splice_s to user package.
	(obj_print, obj_pprint): Convert only sys_qquote_s,
	sys_unquote_s and sys_splice_s to the read syntax.
	The quote_s, unquote_s and splice_s symbols are not
	treated specially.

	* lib.h (sys_qquote_s, sys_unquote_s, sys_splice_s): Declared.

	* parser.y (n_expr): Use sys_qquote_s, sys_unquote_s and
	sys_splice_s rather than qquote_s, unquote_s and splice_s.
	(unquotes_occur): Likewise.

	* txr.1: Documented.

2014-03-01  Kaz Kylheku  <kaz@kylheku.com>

	* configure: changed numerous "if ! conftest" tests to "if conftest",
	swapping around the consequent and alternative clauses.

2014-03-01  Kaz Kylheku  <kaz@kylheku.com>

	* configure (conftest, conftest_o): New functions
	Use functions throughout tests instead of repeated code for removing
	target, invoking make with redirection and testing for existence of
	target.

2014-03-01  Kaz Kylheku  <kaz@kylheku.com>

	* tests/011/special-1.txr: Add some coverage for evaluation
	of a re-bound special under the Lisp-1 evaluation of the [ ]
	notation. This test case would have failed three commits
	back.

2014-03-01  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand_qquote): Another bugfix: not recognizing a trailing
	atom that comes out of recursive call, wrapped in (quote ...),
	resulting in '(,a . b) expanding to (append 'a . quote b)
	rather than (append (list 'a) (quote b)); i.e.  (append (list 'a) 'b).

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (lookup_sym_lisp1): Bugfix: wasn't following the dynamic
	environment at all, and still had vestiges of support for the the old
	cptr based global variables.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	* Makefile: Use target-specific assignment
	to suppress TXR_DBG_OPTS for tests under tests/011.
	The --gen-gc makes mandel.txr run too slow.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (self_evaluating_p, maybe_quote): New functions.
	(expand): Use maybe-quote form macro-time, to not quote
	result unnecessarily.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	* tests/011/mandel.expected: New file.

	* tests/011/mandel.txr: New file.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	Turn *gensym-counter* into proper special variable.

	* eval.c (eval_init): Save *gensym-counter* symbol in gensym_counter_s
	symbol variable right after interning, and use zero as the inital value
	rather than the gensym_counter variable which is removed now.

	* lib.c (gensym_counter_s): New symbol variable.
	(gensym_counter): Variable removed.
	(gensym): Slight refactoring to avoid a double variable lookup.
	Also, for generational GC correctness, use the set macro to update it,
	since the variable could live inside heap object and the counter
	could overflow to bignums which are heap objects.
	(obj_init): Remove initialization of gensym_counter.

	* lib.h (gensym_counter_s): Declared.
	(gensym_counter): Declaration removed, replaced by macro.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	Change in the design of how special variables work, to fix the broken
	re-binding. C code now has to go through the dynamic environment lookup
	to access things like *random-state*, or *stdout*.  As part of this,
	I'm moving some intrinsic variable and function initializations out of
	eval.c and into their respective modules.  Macros are are used to make
	global variables look like ordinary C variables.  This is very similar
	to the errno trick in POSIX threads implementations.

	* eval.c (looup_var, lookup_var_l): Restructured to eliminate silly
	goto, the cobjp handling is gone.
	(reg_fun, reg_var): Internal function becomes external.
	reg_var registers a simple cons cell binding now, without any
	C pointer tricks to real C global variables.
	(c_var_mark): Static function removed.
	(c_var_ops): Static struct removed.
	(eval_init): Numerous initializations for streams, syslog, rand,
	signals and others moved to their respective modules.
	The new symbol variables user_package_s, keyword_package_s
	and system_package_s are interned here, and the variables are
	created in a special way.

	* eval.h (reg_var, reg_fun): Declared.

	* gc.c (prot1): Added assert that the loc pointer isn't null.
	This happened, and blew up during garbage collection.

	* lib.c (system_package, keyword_package, user_package): Variables
	removed these become macros.
	(system_package_var, keyword_package_var, user_package_var): New
	global variables.
	(system_package_s, keyword_package_s, user_package_s): New
	symbol globals.
	(get_user_package, get_system_package, get_keyword_package): New 
	functions.
	(obj_init): Protect new variables. Initialization order of modules
	tweaked: the modules sig_init, stream_init, and rand_init are moved
	after eval_init because they register variables.

	* lib.h (keyword_package, system_pckage, user_package): Variables
	turned into macros.
	(system_package_var, keyword_package_var, user_package_var): Declared.
	(system_package_s, keyword_package_s, user_package_s): Declared.
	(get_user_package, get_system_package, get_keyword_package): Declared.

	* rand.c (struct random_state): Renamed to struct rand_state to
	avoid clash with new random_state macro.
	(random_state): Global variable removed.
	(random_state_s): New symbol global.
	(make_state, rand32, make_random_state, random_fixnum, random):
	Follow rename of struct random_state.
	(rand_init): Reference to random_state variable gone. Using
	reg_var to create the *random-state* variable that is referenced
	from C using the random_stat macro.

	* rand.h (random_state): Variable removed, replaced by macro
	that performs dynamic lookup.

	* signal.c (sig_init): References to all the sig_* global variables
	removed. The signal-related reg_var and reg_fun calls from eval.c moved
	here.

	* stream.c (std_input, std_output, std_debug, std_error, std_null):
	Variables removed.
	(s_ifmt, s_ifsock, s_iflnk, s_ifreg, s_ifblk, s_ifdir,
	s_ifchr, s_ififo, s_isuid, s_isgid, s_isvtx, s_irwxu,
	s_irusr, s_iwusr, s_ixusr, s_irwxg, s_irgrp, s_iwgrp,
	s_ixgrp, s_irwxo, s_iroth, s_iwoth, s_ixoth): Variables removed.
	(stdin_s, stdout_s, stddebug_s, stderr_s, stdnull_s): New symbol
	globals.
	(stream_init): References to removed variables gone. Moved
	stream-related initializations here from eval.c. The global
	streams are set up differently.

	* stream.h (std_input, std_output, std_debug, std_error, std_null):
	Variable declarations replaced by macros.
	(lookup_var_l): Declared.
	(s_ifmt, s_ifsock, s_iflnk, s_ifreg, s_ifblk, s_ifdir,
	s_ifchr, s_ififo, s_isuid, s_isgid, s_isvtx, s_irwxu,
	s_irusr, s_iwusr, s_ixusr, s_irwxg, s_irgrp, s_iwgrp,
	s_ixgrp, s_irwxo, s_iroth, s_iwoth, s_ixoth): Declarations removed.

	* syslog.c (log_pid_v, log_cons_v, log_ndelay_v, log_odelay_v,
	log_nowait_v, log_perror_v, log_user_v, log_daemon_v, log_auth_v,
	log_authpriv_v, log_emerg_v, log_alert_v, log_crit_v, log_err_v,
	log_warning_v, log_notice_v, log_info_v,
	log_debug_v, std_log): Variables removed.
	(syslog_init): References to removed variables removed.
	Moved syslog-related initializations here out of eval_init.

	* syslog.h:x (std_log): Declration removed.

	* txr.c (self_path, prog_args_full, prog_args): Variables gone.
	(txr_main): References to removed varaibles are gone.
	Moved registration of special variables out of eval_init
	here.

	* txr.h (self_path, prog_args_full, prog_args): Declarations gone.

	* tests/011/special-1.txr: Test case modified to properly test
	special variables. Previously it produced the expected output
	even though *stdout* wasn't rebound properly.

	* tests/011/special-1.expected: Updated.

	* genvim.txr: Updated to follow variable and function registration
	moves. It has to scan more files than just eval.c. Produces identical
	contents, so no change to txr.vim.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (op_defvar): Remove the same-named symbol macro when a
	variable is defined.
	(op_defsymacro): Remove the same-named variable when a symbol macro is
	defined.
	(op_defun): Throw excpetion if an attempt is made to define a
	special operator as a function. Remove the same-named macro when a
	function is defined.
	(op_defmacro): Throw excpetion if an attempt is made to define a
	special operator as a macro. REmove the same-named function
	when a macro is defined.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand_qquote): Fix broken '(,x . ,y) case, which
	is generating (append (list x) . y) instead of (append (list x) y).
	Also, added a nil case which is now necessary to prevent
	'(,x) from generating (append (list x) nil), though this is
	effectively an optimization, which is pointless, since
	the expander isn't optimizing overall.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	* tests/010/output-clauses.expected: New file.

	* tests/010/output-clauses.txr: New file.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	About time for some new regression tests.

	* tests/011/macros-1.expected: New file.

	* tests/011/macros-1.txr: New file.

	* tests/011/macros-2.expected: New file.

	* tests/011/macros-2.txr: New file.

	* tests/011/special-1.expected: New file.

	* tests/011/special-1.txr: New file.

2014-02-28  Kaz Kylheku  <kaz@kylheku.com>

	Bugfixing semantics of symbol macro hiding by variable bindings.

	* eval.c (expand_vars): Expand vars needs to know whether it's
	handling a sequential (let*-like) or parallel (let-like) binding.
	The init form of a variable sees the previous macro environment,
	but that variable must, for the remaining variables, shadow any
	previous symbol macro.
	(expand): In expand we must inform expand_vars whether we have
	a sequential or parallel binding construct. Moreover, there was
	a huge bug here: the new_menv (with the shadows) was passed to
	expand_vars, so that all the variables were hiding same-named
	symbol macros from all their initforms.

2014-02-27  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (delay_s): Global variable removed.
	(eval_init): Initialiation of delay_s removed.
	Symbol now interned in reg_mac call for registering me_delay .

	* genvim.txr: Updated to recognize a reg_mac call
	with intern.

2014-02-27  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Improved documentation for the dwim operator.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	Version 82

	* txr.c (version): Bumped.

	* txr.1: Bumped version, set date, improved the documentation
	for the copy function and copy-list, and fixed the
	an instance where the delay macro was called a function.

	* configure (txr_ver): Bumped.

	* RELNOTES, txr.vim: Updated.

2014-02-27  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Typos, grammar and formatting fixes mailed in
	by Roman Mishin.

2014-02-27  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l: Regression: valid floating-point literals tagged
	as having trailing junk. The fix is to put the junk-matching rule after
	the valid rules.

2014-02-27  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (copy): New function.

	* lib.h (copy): Declared.

	* eval.c (eval_init): Registered copy function as intrinsic.

	* txr.1: Added missing documentation for length. Documented copy.

2014-02-27  Kaz Kylheku  <kaz@kylheku.com>

	* genvim.txr: Updated with regard to how operators are registered in
	in eval_init. Also, scans reg_mac registrations now.

	* txr.vim: Refreshed. The previously missed "delay" operator is now
	listed, thanks to reg_mac.

2014-02-27  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (maybe_progn): New function.
	(expand_macrolet, expand_symacrolet): Use maybe_progn
	to eliminate unnecessary progn wrapping.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (gun_s): New global variable.
	(me_gun): New static function.
	(eval_init): New gun symbol interened, me_gun registered
	as intrinsic macro.

	* txr.1: Documented gun.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	Converting expander special case code transformations into
	formal macros that are in the top_mb table, make their symbols
	fboundp and can be expanded with macroexpand.

	* eval.c (mefun_t): New typedef name.
	(expand_macro): If the expander is a cobj, then pull out the C function
	and call it, otherwise realize the interpreted macro as before.
	(me_gen, me_delay): New static functions, replace expand_gen
	and expand_delay.
	(expand_qquote): Renamed to me_quote.
	(expand_gen, expand_delay): Renamed to me_gen and me_delay,
	with an interface adjustment and moved.
	(expand_op): Renamed to me_op.
	(expand): Removed qquote, gen, delay, op, and do handling, since
	these operators are now macros.
	Removed the unnecessary expansion of with-saved-vars.
	(reg_op, reg_fun): Assert that the symbol is not nil, to catch
	initialization order issues.  One just showed up: op_do was
	interned in match.c, which is initialized later.
	(reg_mac): New static function
	(eval_init): Intern do_s, because match.c hasn't done it yet
	at this point. Register me_gen, me_delay, me_op (twice) and me_qquote
	as intrinsic macros.

	* txr.1: Documented those operators as macros.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (reg_op): New static function.
	(eval_init): Register operators with reg_op instead of direct sethash
	calls.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (make_like): If the first element of list isn't
	a character, then don't try to make it into a string;
	keep it as a list. This allows [mapcar list "abc" "def"]
	to work intuitively rather than blow up.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (lit_s): New symbol.
	(code2type): Return lit_s for LIT type.
	(typeof): Return lit_s for TAG_LIT.
	(replace_str): Error message wording.
	(obj_init): lit_s interned.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (do_eval): Set last_form_evaled just before
	dispatching function, so it is not clobbered by argument evaluations.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand_op): Use rlcp_tree when constructing the
	dwim_body, since the append2 copies list structure.

	* parser.y (n_exprs): propagate source loc info from both 
	constituents, giving precedence to the left one, rather than just taking
	it from the left one and ignoring the second constituent.  This fixes
	cases of missing location info. The left constituent n_expr is often 
	a symbol, and those do not have location info. We want a case like
	like ((x) y) to take from (x), and (x (y)) to take it from (y),
	and so on.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (list): For @n_expr, get the source location info
	from the @ token.
	(n_expr): Bugfix: do not attribute a symbol with location info.
	(quasilit): Obtain location info from quasi_items, and only
	if that is unavailable, then from lineno.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	Version 81

	* txr.c (version): Bumped.

	* txr.1: Bumped version and set date.

	* configure (txr_ver): Bumped.

	* RELNOTES, txr.vim: Updated.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l (regex_parse, lisp_parse): Better formatting
	for the context string that serves in place of a filename.

2014-02-26  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand_place): Unnecessary, buggy function removed.
	It was handling silly special cases with the net effect of being
	nearly equivalent to just expand, while failing to expand places
	which are compound macro calls. It did diagnose nonexistent place
	types at expansion time, which isn't worth much.
	(expand): All the expansions for the mutating operator sset, inc, dec,
	push, pop and flip were also pointless and have been removed.  they did
	the precise equivalent of doing expand(rest(form)), and consing the
	symbol to the front, which is the fallback case for function call
	forms.

2014-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Make it an error to have implicit function declarations by
	means of -Werror=implicit-function-declarations.  Fix broken mkdir and
	mknod tests. Regenerate config.make if we add -U__STRICT_ANSI__
	to the compiler options, so that later tests benefit from this.
	Regenerate config.make right away if adding -D_DARWIN_C_SOURCE.
	This allows the makedev test to pass.

	* stream.c: Include <sys/types.h> for makedev.
	(mknod_wrap): Don't rely on makedev wrappers to be there; test.

2014-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (spec): Bugfix: SECRET_ESCAPE_E should use n_expr
	not expr. expr is subject to expand_meta.
	(n_expr): Do not associate source info with character
	literals.
	(expand_meta): Bugfix: when walking forms in a collecting loop,
	propagate the source info to them. Bugfix: attach source
	info to var and expr expansions.
	(rl): Rewritten in terms of rlset.
	(rlset): Only set source info for an object that doesn't already
	have it.

2014-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (obj_init): Revert qquote, unquote and splice
	to the system namespace, for hygiene.

	* txr.1: Updated.

2014-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): HAVE_MAKEDEV not HAVE_MKDEV.

2014-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (getcwd_wrap): Implement correct test of getcwd's
	return value.

2014-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Use -Werror= on the missing prototypes and
	strict prototypes warnings; these should be errors.

2014-02-25  Kaz Kylheku  <kaz@kylheku.com>

	* configure: Added feature tests for makedev, link/symlink/readlink,
	mkdir and mknod.

	* eval.c (eval_init): Wrap #ifdefs around the registrations of
	the wrappers for these functions.

	* stream.c (mkdir_wrap): Wrap in #ifdef HAVE_MKDIR, and
	provide a Windows version if HAVE_MKDIR is missing, but
	HAVE_WINDOWS_H is true.
	(makedev_wrap, major_wrap, minor_wrap): Wrap with #if HAVE_MAKEDEV.
	(mknod): Use #if HAVE_MKNOD.
	(symlink_wrap, link_wrap, readlink_wrap): Wrap with #if HAVE_SYMLINK.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	* debug.c (debug): Fix 2013-12-02 regression, which leaves the
	debugger not printing the current line of data.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Intern symlink_wrap, link_wrap, readlink_wrap.

	* stream.c (symlink_wrap, link_wrap, readlink_wrap): New functions.

	* stream.h (symlink_wrap, link_wrap, readlink_wrap): Declared.

	* txr.1: Documented.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register forgotten s_ifsock variable.
	Register mkdir_wrap, chdir_wrap, getcwd_wrap, makedev_wrap, minor_wrap,
	major_wrap and mknod_wrap.

	* stream.c (mkdir_wrap, chdir_wrap, getcwd_wrap, makedev_wrap,
	minor_wrap, major_wrap, mknod_wrap): New functions.
	(stream_init): Initialize forgotten variable s-ifsock.

	* stream.h (s_ifsock): Declared.
	(mkdir_wrap, chdir_wrap, getcwd_wrap, makedev_wrap,
	minor_wrap, major_wrap, mknod_wrap): Declared.

	* txr.1: Forgotten documentation for remove-path and rename-path
	added. Forgotten mention of s-ifsock. Documented new Unix functions.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	* parser.l: Support octal and binary numbers.

	* txr.1: Documented.

	* genvim.txr, txr.vim: Updated.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (modifiers): Bugfix: list element not subject to expansion
	of Lisp forms denoted by @.
	(expand_meta): Bugfix: failure to expand vars, which can be
	symbol macros now.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (obj_print, obj_pprint): Render quasi-quote hash and
	vector literals using their original notation.

	* parser.y (unquotes_occur): Takes new argument, level. 
	Only finds quotes which are at the given quasiquoting level.
	Finally, this is the right semantics. In the first version of this
	function, we were not eager enough: we neglected to find unquotes
	that were wrapped in nested quasiquotes. Then we were too eager:
	finding any unquotes, even ones belonging to the inner backquotes.
	(vector, hash, choose_quote): Pass zero to unquotes_occur function.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand_qquote): Bugfix. Was not handling an unquote
	in the dotted position: (qquote x1 .. xn . (unquote form)),
	which looks like the structure (qquote x1 .. xn unquote form).
	Fixed by a hack: after recursively expanding the (unquote form)
	part (rest of the form), we check whether the unexpanded
	version has unquote at the front. If so, we know the expansion is just
	form, and use it to emit the suitable expansion.

2014-02-24  Kaz Kylheku  <kaz@kylheku.com>

	Symbol macros.

	* eval.c (top_smb, defsymacro_s, symacrolet_s): New global variables.
	(lookup_symac, get_opt_param_syms, get_param_syms, op_defsymacro,
	expand_symacrolet, make_var_shadowing_env): New static functions.
	(expand_tree_cases, expand_catch_clause): Install shadowing environment
	so lexical bindings hide any symbol macrolets.
	(expand_place): Fix neglect to expand an atomic form, which breaks
	symbol macros used as places.
	(expand): Expand symbol macros, expand symacrolet binding forms.
	Make sure symbol macros are shadowed in the lexical binding
	constructs. Take advantage of return value of rlcp_tree in a
	few places.
	(macro_form_p): Support for symbol macros; bugfix: not handling
	default argument.
	(macroexpand_1): Streamlined, and support added for symbol macros.
	(eval_init): Protect top_smb from gc. Create new hash, stored in
	top_smb. Initialize defsymacro_s and symacrolet_s.
	Register op_defsymacro.

	* parser.y (rlcp_tree): Return the to form instead of useless t and nil.

	* txr.1: Documented.

2014-02-23  Kaz Kylheku  <kaz@kylheku.com>

	* txr.1: Document quasiquote operator syntax.

2014-02-23  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (env_fbind, env_vbind): Use acons_new_c, and provide
	a much more useful return value: the binding cell itself,
	rather than the symbol.
	(bind_args): Bugfix: env_vbind was still being called in one case,
	leading to a neglect to bind a special variable properly.
	(bindings_helper): Changed interface. Bugfix: in sequential binding,
	actually bind the successive environments so closures will behave
	100% correctly. Returns a list of the actual bindings, in which
	special variables are not distinguished in any way.
	(op_let, op_for): Conform to new bindings_helper interface. Use the
	lexical environment that it returns instead of making a new one.
	(op_each): Use the environment and list of bindings out of
	bindings_helper. The bindings are used for stepping the lists,
	and that includes stepping any special vars. The lexical environment
	is used for evaluating the body. Thus, we need no special processing
	for special vars here any more.

2014-02-23  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bindings_helper): This must now bind dynamic values
	rather than just assign to them. Got rid of the superfluous variable
	saving array. Fixed the problem in recognizing the special_s symbol (it
	is bindable).
	(op_with_saved_vars): This simplifies, since it no longer needs
	to save individual variables in an array, only to set up and
	tear down a new dynamic environment frame.
	(expand_vars): No longer returns two values with a cons. 
	Takes a form argument for error reporting and a pointer to a boolean
	just to report whether there are special vars without listing them.
	(expand_save_specials): The with-saved-specials form doesn't need
	a var list any more, so the expander is updated not to stick them in.
	(expand): Update calls to expand_vars to new interface.

2014-02-23  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (get_string_from_stream): Bugfix: do not abort if
	stream is not a string stream, but throw a proper error exception.

2014-02-23  Kaz Kylheku  <kaz@kylheku.com>

	Get special variable overriding working in function and macro
	parameter lists.

	There is a bugfix here too (see eval_init below).

	* eval.c (special_s): New global variable. This symbol is used
	as a marker in parameter lists denoting expander-generating
	syntax that gives information about specials.
	(lookup_var, looup_var_l): Bugfix: walk the dynamic chain properly.
	Fallback from the lexical chain to the dynamic.
	(env_vbind_special): New static function.
	(bind_args, bind_macro_params):  Detect special list in params. Use
	env_vbind_special to bind variables either in the dynamic environment
	or the lexical one.
	(expand_opt_params, expand_params): Renamed to expand_opt_params_rec
	and expand_params_rec, respectively. Now take extra argument for
	accumulating list of special variables found in the param list.
	(expand_params): New static function.
	(set_dyn_env): New static function.
	(interp_fun, expand_macro): Set up and tear down new dynamic
	environment around parameter list evaluation and body evaluation. This
	will take any new dynamic bindings.
	(bindings_helper, op_each): The special_s symbol is now used instead of
	colon_k for marking specials.
	(op_defun): Recognize the specials added to the parameter list
	so as not to t report that as not a bindable symbol.
	(op_catch): Set up an tear down new dynamic environment around
	the evaluation of the catch clause param binding and body.
	(expand_vars): use colon_s symbol instead of colon_k for marking
	special var.
	(eval_init): Bugfix: gc-protect recently added dyn_env variable.
	Intern special symbol into special_s variable.

2014-02-23  Kaz Kylheku  <kaz@kylheku.com>

	Introducing some changes for improved handling of special variables.
	Saving and restoring of individual variables is very silly
	and it's making it difficult to implement function parameters
	that are rebindings of special variables.

	Let's have a global pointer to a dynamic environment called dyn_env.
	Let's make it part of the extended_jmp_buf structure, so that it's
	implicitly saved and restored across exception handling.

	Special variable lookups go through the dyn_env chain, and fall back on
	the global bindings.

	To override some specials, we just push a new dynamic environment and
	stick them there. (As a bonus, the bindings can even be repeated in the
	lexical environment (i.e. the same objects), so they can be found
	faster. We have to make sure we remove that environment when we
	leave the scope in the normal way. If we unwind out, it is done
	automatically by extended_longjmp mechanism.

	* eval.c (dyn_env): New global variable.
	(lookup_var, lookup_var_l): If env is nil, look in the dyn_env
	first, and only if that fails, look in the global bindings top_vb.

	* signal.h (extended_jmp_buf): New member, de, for saving/restoring
	dyn_env. This structure is now used whether or not we have signals.
	(extended_setjmp, extended_longjmp): Updated to save and restore
	dyn_env, and to do it regardless of whether there is POSIX signal
	support.
	(dyn_env): Declared here.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (symbol_function): Retrieve the global macro binding if the
	function lookup fails, and if that fails, retrieve the special
	operator binding.
	(fboundp): Report t if there is a global macro binding.

	* txr.1: Use "global" rather than "toplevel". Added note that
	the fun operator doesn't see macro bindings. Documented that
	symbol-function and fboundp see global macro bindings,
	and that symbol-function can retrieve a special operator binding.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (prinl, pprinl): New functions.
	(eval_init): Registered as intrinsics.

	* txr.1: Documented.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (obj_init): changing the quote, qquote, unquote
	and splice symbols to be in the regular user package,
	rather than the system package.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y: Allow the (. expr) syntax to denote expr.

	* eval.h: Declare existing lambda_s extern variable.

	* lib.c (obj_print, obj_pprint): print (lambda sym ...)
	as (lambda (. sym) ...) and (lambda sym) as (lambda (. sym)).

	* txr.1: document it.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	Implemented macrolet.

	* eval.c (macrolet_s): New variable.
	(lookup_mac, expand_macrolet): New static functions.
	(expand): Recognize and expand macrolet form.
	use lookup_mac to resolve macros rather than gethash,
	since we have lexical macros now.
	(eval_init): Intern macrolet symbol.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bind_macro_params, expand_macro, macroexpand_1, macroexpand):
	Rename mac_env variable to menv for consistency.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	Preparation for lexical macros: we need to pass a macro
	environment down through the expander call hierarchy.

	* eval.c (expand_opt_params, expand_params, expand_tree_cases,
	expand_tree_case, expand_forms, val expand_cond_pairs, val
	expand_place, expand_qquote, expand_vars, expand_quasi, expand_op,
	expand_catch_clause, expand_catch, expand): All expanders get new
	parameter, menv. expand_forms and expand handle a nil value of menv.
	(eval_intrinsic): Pass nil macro environment to expand.
	(eval_init): Update intrinsic registration for expand.

	* eval.h (expand, expand_forms): Declarations updated.

	* parser.y (expand_meta): Gets macro env parameter.
	(elem, o_elem, exprs, expr): Pass nil to expand_forms and expand_meta.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	Replacing uses of the eq function which are used only as C booleans,
	with just using the == operator. 

	Removing cobj_equal_op since it's indistinguishable from eq.

	Streamlining missingp and null_or_missing_p.

	* eval.c (transform_op): eq to ==.
	(c_var_ops): cobj_equal_op to eq.

	* filter.c (trie_compress, trie_lookup_feed_char, filter_string_tree,
	html_hex_continue, html_dec_continue): eq to ==.

	* hash.c (hash_iter_ops): cobj_equal to eq.

	* lib.c (countq, getplist, getplist_f, search_str_tree,
	posq): eq to ==.
	(cobj_equal_op): Function removed.

	* lib.h (cobj_equal_op): Declaration removed.
	(missingp): Becomes a simple macro that yields a C boolean instead
	of t/nil val, because it's only used that way.
	(null_or_missing_p): Becomes inline function returning int.

	* match.c (v_output): eq to ==.

	* rand.c (random_state_ops): cobj_equal_op to eq.

	* regex.c (char_set_obj_ops, regex_obj_ops): cobj_equal_op to eq.
	(reg_derivative): Silly if3 expression replaced by null.
	(regexp): Redundant if2 expression wrapped around eq removed.

	* stream.c (null_ops, stdio_ops, tail_ops, pipe_ops, string_in_ops,
	byte_in_ops, string_out_ops, strlist_out_ops, dir_ops,
	cat_stream_ops): cobj_equal_op to eq.

	* syslog.c (syslog_strm_ops): cobj_equal_op to eq.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	The C function nullp is being renamed to null, and the rarely
	used global variable null which holds a symbol becomes null_s.

	A new macro called nilp is added that more efficiently checks whether
	an object is nil, producing a C boolean value rather than t or nil.

	Most of the uses of nullp in the codebase just become the more
	streamlined nilp.

	* debug.c (show_bindings): nullp to nilp

	* eval.c (lookup_var, lookup_var_l, lookup_fun, lookup_sym_lisp1,
	do_eval, expand_qquote, expand_quasi, expand_op): nullp to nilp.
	(op_modplace): nullp to null.
	(eval_init): Update registration of null and not from C function
	nullp to null.

	* filter.c (trie_compress, html_hex_continue): nullp to nil.
	(filter_string_tree): null to null_s.

	* hash.c (hash_next): nullp to nilp.

	* lib.c (null): Variable renamed to null_s.
	(code2type): null to null_s.
	(lazy_flatten_scan, chainv, lazy_str, lazy_str_force_upto,
	obj_print, obj_pprint):
	nullp to nilp.
	(obj_init): null to null_s; nullp to null.

	* lib.h (null): declaration changed to null_s.
	(nullp): Inline function renamed to null.
	(nilp): New macro.

	* match.c (do_match_line): nullp to nilp.

	* rand.c (make_random_state): Likewise.

	* regex.c (compile_regex): Likewise.

2014-02-22  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y: Bugfix, I think. :) We do not need to call the expander
	for a Lisp expression in a quasistring, and doing so leads to a
	potentially incorrect double expansion because the whole thing
	will be expanded again, either by the TXR Lisp quasi operator's
	expander (if this is a quasiliteral in Lisp) or in the TXR
	pattern language, by expand_meta, which hunts down down @ expressions
	and expands them. 

2014-02-21  Kaz Kylheku  <kaz@kylheku.com>

	Implementing special variables with local overriding.
	All predefined globals become special.

	* eval.c (special, with_saved_vars_s): New global variables.
	(mark_special, special_p): New functions.
	(bindings_helper): Takes new argument, include_specials.
	Now processes the special colon syntax for denoting special variables,
	setting up their values, taking care to observe whether the
	binding is parallel or sequential.
	(op_let, op_for): Pass new argument to bindings_helper.
	(op_each): Pass new argument to bindings_helper with a value of it,
	and deal with the colon annotations that emerge in the bindings.
	(op_defvar, regvar): Mark symbol as special.
	(op_with_saved_vars): New static function.
	(expand_vars): Takes new argument, returns a cons. Detects special
	variables among the vars and produces the colon syntax.
	(expand_catch_clause): Bugfix: this was using expand_vars on
	a parameter list. Now properly uses expand_params.
	(expand_save_specials): New static function.
	(expand): For the operators that are binding constructs, handle
	the new form of expand_vars which returns information about
	special variables. If specials occur, then generate the 
	with-saved-vars form around the expansion which will save and restore
	their values. The expansion of vars done by expand_vars, together
	with the run-time actions of bindings_helper, do the rest.
	Speaking of which, the new with-saved-vars operator form is now
	expanded here too.
	(eval_init): Protect new variables special and with_saved_vars_s.
	Initialize special with new hash table. Store new interned
	symbol in with_saved_vars_s. Register op_with_save_vars in op_table.

	* txr.1: Documented specials.

2014-02-21  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (subst_vars): Change throwing of query_error_s
	to eval_error call. This is a leftover from when this was cloned
	from its counterpart in match.c. However, I can't think of a way
	this call can ever be reached.

2014-02-20  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (macro_form_p, macroexpand_1, macroexpand): New static
	functions.
	(eval_init): Registered new functions.

	* txr.1: Documented.

2014-02-20  Kaz Kylheku  <kaz@kylheku.com>

	* parser.y (unquotes_occur): Bugfix: we should not terminate
	the recursion early if we see a quote. This would be true if
	the only quotes were those generated by the parser based on
	calls to choose_quote. However, it breaks for something
	like an explicitly coded '(sys:quote ,form), which becomes
	(sys:quote (sys:quote ,form)), leaving a dangling unquote.

2014-02-19  Kaz Kylheku  <kaz@kylheku.com>

	* mpi-patches/faster-square-root (mp_sqrt): Bugfix: was computing square
	roots that were incorrect in the last digit/bit, because it was not
	generating the guess mask all the way down to bit zero. Also, added
	an early test to bail the loop when an the guess at the root happens
	to be right.

	* mpi-patches/add-bitops: Refreshed.

	* mpi-patches/fix-ctype-warnings: Likewise.

	* mpi-patches/mpi-to-double: Likewise.

2014-02-19  Kaz Kylheku  <kaz@kylheku.com>

	Fixing a long-running issue in the TXR pattern language: premature
	opening of files, prior to directives that actually need data.
	The documentation basically lied that this is the case: namely,
	the text "A file isn't opened until the query demands material from
	that file, and then the contents are read on demand, not all at
	once."   This is now a fact.

	* match.c (non_matching_directive_table): New global variable.
	(open_data_source): New static function. Contains an almost
	verbatim migration of the source-opening logic that used
	to be in match_files. The useless assignment to c->nil is gone,
	and c->data == t is explicitly tested for. Instead of assuming
	that only the @(next) directive does not need to have a data source
	open, the table of non-matching directives is consulted. Opening
	the data source is now skipped for numerous directives.
	(match_files): Call open_data_source within the loop. This
	means that even after processing numerous non-matching directives,
	we will still correctly set up the data lazy list.
	(dir_tables_init): Initialize non_matching_directive_table,
	protect from GC and populate with numerous directives.

	* txr.1: Improved documentation for @(next :args), and removed
	a description of the hack that a single @(next) at the top of the
	query suppressed the opening of the data source.

2014-02-18  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (env_hash): new function.
	(eval_init): Register env and env_hash functions.  Register prog_args
	and prog_args_full as *args* and *full-args*.

	* lib.c (timegm_hack): Invalidate env_list, after mucking with
	the environment via setenv and unsetenv.

	* txr.c (prog_args_full, prog_args): New global variables.
	(txr_main): Command-line processing converted to use TXR's
	library. Populates prog_args_full and prog_args.

	* txr.h (prog_args_full, prog_args): Declared.

	* txr.1: Documented *args*, *full-args*, env and env-hash.

2014-02-18  Kaz Kylheku  <kaz@kylheku.com>

	The mode argument in some stream-opening functions becomes optional.

	* eval.c (eval_init): Change registration for open_file, open_tail
	and open_command.

	* stream.c (open_file, open_tail, open_command): mode_str argument
	defaulted.

	* txr.1: Updated.

2014-02-18  Kaz Kylheku  <kaz@kylheku.com>

	* stream.c (open_tail): Fix 2013-12-02 regression:
	seek_to_end_p argument being ignored, with the
	behavior being no initial seek to the end.

	* txr.1: Clarified the behavior of the seek-to-end-p
	option.

2014-02-18  Kaz Kylheku  <kaz@kylheku.com>

	* combi.c (rperm_gen_full): Update ptail with return value
	of list_collect. This is not necessary for correctness, but it spares
	list_collect from having to search for the tail on each call.

2014-02-17  Kaz Kylheku  <kaz@kylheku.com>

	Version 80

	* txr.c (version): Bumped.

	* txr.1: Bumped version and set date.

	* configure (txr_ver): Bumped.

	* RELNOTES, txr.vim, dep.mk: Updated.

2014-02-17  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bind_args, op_defvar, op_defun, op_defmacro, op_modplace):
	Fix sybol misspelling.

2014-02-17  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register gensym function as the gensym
	intrinsic, rather than gensymv.
	Register gensym_counter as *gensym-counter*.

	* lib.c (gensym): Handle missing prefix argument by defaulting
	the prefix to "g".
	(gensymv): Function removed.

	* lib.h (gensymv): Declaration removed.

	* txr.1: Fixed omission: missing documentation for gensym.
	Documented *gensym-counter*.

2014-02-17  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand): Bugfix: do not expand any part of the macro
	form via expand_forms. This is completely wrong since only the
	macro knows what material is evaluated and what isn't.

2014-02-16  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (op_tree_case): Removed superfluous handling of
	nil parameter list; this is correctly handled by bind_macro_params.
	Added support for the colon symbol as an indication that
	the case is declined.

	* txr.1: Updated.

2014-02-16  Kaz Kylheku  <kaz@kylheku.com>

	New destructuring operators.

	* eval.c (tree_case_s, tree_bind_s): New symbol variables.
	(bind_macro_params): Bugfix: inappropriate exception thrown when atom
	matched against parameter list. Bugfix: nil being returned when
	atom matches empty parameter list. Added support for a new convention:
	if loose_p is the colon keyword, then exceptions are not thrown
	for destructuring mismatches; nil is returned instad.
	(op_tree_case, expand_tree_cases, expand_tree_case, op_tree_bind):
	New static functions.
	(expand): Handle tree_case_s and tree_bind_s.
	(eval_init): Intern tree-case and tree-bind symbols.
	Register the corresponding operator functions op_tree_case and
	op_tree_bind under these symbols in op_table.

	* txr.1: Documented tree-case and tree-bind operators.

2014-02-16  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bind_macro_params): Bugfix: enforce mismatch on
	superfluous material.

2014-02-16  Kaz Kylheku  <kaz@kylheku.com>

	In the spirit of the previous hack, here is another hack to
	alleviate a long-standing pain: when an exception happens in
	TXR's library somewhere, the program dies without leaving
	a clue about what code was being evaluated when that happened.
	What we can do is have the evaluator publish the most recent
	compound form it has processed by stashing it in a variable.
	Then when an unhandled exception occurs, we can peek at that
	and try to pull out source location info.

	* eval.c (last_form_evaled): New variable.
	(do_eval): When evaluating a compound form, stash it in
	last_form_evaled.
	(eval_init): Protect last_form_evaled from gc.

	* eval.h (last_form_evaled): Declared.
	(eval_error_s): Existing variable declared.

	* unwind.c: Has to include "eval.h" for the above variable
	and "parser.h" for the source_loc function.
	(uw_throw): When an exception is unhandled, if 
	last_form_evaled has source info, add it to the diagnostic.
	But not if the exception is eval-error; because errors from
	the evaluators already have the info.

2014-02-16  Kaz Kylheku  <kaz@kylheku.com>

	Nice idea: how about a function which walks the tree structure and
	back-fills some missing source code location info.  We apply this to
	macro expansions.  If some error occurs in expanded code, this way it
	is referenced to the line where the macro *call* occurs.
	Not only is this better than nothing, it may be better than tracing
	it to the macro definition. Ideally, we would have both places:
	("the error is in the code expanded from this macro, at this site").

	* eval.c (expand): Use rlcp_tree to back-fill source info in
	macro expansion by taking it from the unexpanded form.

	* parser.h (rlcp_tree): Declared.

	* parser.y (rlcp_tree): New function.

2014-02-16  Kaz Kylheku  <kaz@kylheku.com>

	Bugfixes: not propagating source loc info in quasiliterals.

	* eval.c (expand_quasi): Add some rlcp's here.

	* parser.y (o_var, quasi_items, o_elems_transform): Likewise.

2014-02-16  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (expand): Replace blatant tail calls with
	a backwards goto.

2014-02-15  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bind_macro_params): Bugfix: the :whole parameter must
	capture the entire form, not just the arguments.
	(expand): Apply rlcp to the result of macro expansion, if it has
	not set up source code location.
	(eval_init): Register rlcp as intrinsic.

	* txr.1: Start of macro documentation. Documented rlcp.

2014-02-15  Kaz Kylheku  <kaz@kylheku.com>

	First cut at implementation of macros.

	* eval.c (top_mb, defmacro_s, macro_time_s, whole_k, env_k): New global
	variables.
	(expand_params): Recurse to handle macro parameter lists too.
	(bind_macro_params, op_defmacro, expand_macro): New static functions.
	(expand): Evaluate defmacro forms and macro-time forms at expansion
	time. Recognize and expand macros (albeit not yet with proper lexical
	scoping: local bindings are not able to shadow a macro).
	(eval_init): Protect top_mb from GC and initialize it.
	Intern new symbols defmacro, macro-time, and :whole.
	Register defmacro operator in op_table.

	* match.h (env_k): Added declaration for existing external variable.

2014-02-15  Kaz Kylheku  <kaz@kylheku.com>

	Bugfix: parameters of defun were not being treated by expander.
	They need to be since they can contain evaluable initforms for default
	arguments. Ditto with lambda; lambda parameters were being treated
	using expand_vars, which is not appropriate.

	* eval.c (expand_opt_params, expand_params): New static functions.
	(expand_vars): Bugfix: added some missing rlcp's to propagate
	line number info.
	(expand): Move lambda to separate case, and expand its params

2014-02-15  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bind_args, op_modplace): Use ~s consistently
	in error messages.

2014-02-15  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (bindings_helper): Fixed misspelling of "symbol" in exception
	message.

2014-02-15  Kaz Kylheku  <kaz@kylheku.com>

	A trivial change in the UTF-8 decoder allows TXR to handle null bytes
	in text.

	* utf8.h (UTF8_ADMIT_NUL): New preprocessor symbol.
	(utf8_decoder): New member, flags.

	* utf8.c (utf8_decoder_init): Initialize flags to 0.
	(utf8_decode): If a null byte is encountered in the input,
	then convert it to 0xDC00, rather than keeping it as zero,
	unless flags contains UTF8_ADMIT_NUL.

	* txr.1: Document handling of null bytes.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (hash_update): Avoid double cdr.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (inhash): Simplify with gethash_c.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	Replacing acons_new_l and aconsq_new_l interfaces with ones
	that return the new or old cons cell rather than a pointer
	to its cdr field.

	* eval.c (transform_op): use of acons_new_l replaced with
	acons_new_c.

	* hash.c (struct hash): acons_new_l_fun member replaced
	with acons_new_c_fun.
	(make_hash, make_similar_hash): initialize acons_new_l_fun
	member using either acons_new_c or aconsql_new_c.
	(gethash_l): function becomes an inline in hash.h.
	(gethash_c): new function, based on gethash_l.
	(inhash, gethash_n): updated w.r.t struct hash change.

	* hash.h (gethash_c): declared.
	(gethash_l): becomes an inline wrapper for gethash_c.

	* lib.c (acons_new_l, aconsql_new_l): functions removed.
	(acons_new_c, aconsql_new_c): new functions.
	(obj_init): use gethash_c and rplacd instead of gethash_l
	and set.

	* lib.h (acons_new_l, aconsql_new_l): declarations removed.
	(acons_new_c, aconsql_new_c): declared.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (inhash): Simplify code with gethash_f.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Registered hash_update_1 as intrinsic.

	* hash.c (hash_update_1): New function.

	* hash.h (hash_update_1): Declared.

	* txr.1: Documented hash-update-1.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	* hash.c (inhash): Rename local variable from new to new_p.
	This is consistent with usage elsewhere in the module,
	and more importantly, keeps our code C++.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	* lib.c (class_check): Bugfix: the function was assuming that
	the argument is a pointer type object, leading to a crash
	if given a fixnum integer or string literal.

2014-02-14  Kaz Kylheku  <kaz@kylheku.com>

	* eval.c (eval_init): Register inhash as intrinsic.

